*put the appropriate file paths in quotations
global data "...."
global folder "...."

import excel "$data\CohLifeTables_F_Alt2_TR2023.xlsx", sheet("CohLifeTables") cellrange(A6:C24126) firstrow clear

*qx - probability of death
*px - probability of surviving each age
*Year - birth year
gen px=1-qx
drop qx
drop if Year>=2020

reshape wide px, i(x) j(Year)

*find cumulative survival probabilities
forvalues y=1900/2019{
	gen cpx`y'=px`y' if x==0
	forvalues i=2/120{
		replace cpx`y'= cpx`y'[`i'-1] * px`y'[`i'] in `i'
	}
}

drop px*
reshape long cpx, i(x) j(Year)
reshape wide cpx, i(Year) j(x)

gen ragender=2
rename Year rabyear

save "$folder/cumu_mort_f.dta",replace

import excel "$data\CohLifeTables_M_Alt2_TR2023.xlsx", sheet("CohLifeTables") cellrange(A6:C24126) firstrow clear

*qx - probability of death
*px - probability of surviving each age
*Year - birth year
gen px=1-qx
drop qx
drop if Year>=2020

reshape wide px, i(x) j(Year)

*find cumulative survival probabilities
forvalues y=1900/2019{
	gen cpx`y'=px`y' if x==0
	forvalues i=2/120{
		replace cpx`y'= cpx`y'[`i'-1] * px`y'[`i'] in `i'
	}
}

drop px*
reshape long cpx, i(x) j(Year)
reshape wide cpx, i(Year) j(x)

gen ragender=1
rename Year rabyear

save "$folder/cumu_mort_m.dta",replace
append using "$folder/cumu_mort_f.dta"
save "$folder/cumu_mort.dta",replace
