* --------------------------------------------------------------------------------*
* Basic demographics to use in nearest-neighbor imputations
* --------------------------------------------------------------------------------*

clear

global folder " "
global rawfolder " "

use "$rawfolder\trk2020tr_r.dta",clear

*if a respondent is not in the tracker yet, use demographics section of HRS CORE (h*b_r)

rename BIRTHYR rabyear
replace rabyear=. if rabyear==0

*rename RACE race
*replace race=. if race==0

gen race=(RACE!=1)
*replace race=. if RACE==0

gen educ=(SCHLYRS>=13)
*replace educ=. if SCHLYRS==99

rename GENDER gender

*gen married=(RCOUPLE==1)


 forvalues i=10/18{
 local let : word `i' of `c(ALPHA)'
 local w=`i'-3
 gen married`w'=(`let'COUPLE==1)
 }
 
  forvalues i=5/8{
 local let : word `i' of `c(ALPHA)'
 local w=`i'-2
 gen married`w'=(`let'COUPLE==1)
 }

 gen married2=(CCOUPLE==1)
 gen married1=(ACOUPLE==1)

keep HHID PN  rabyear race educ gender married*

save "$folder\demog.dta",replace





