*------------------------------------------------------------------------------*
*                 MAIN FINANCIAL AND HOUSING WEALTH PROGRAM                    *
*------------------------------------------------------------------------------*
 clear all
 set maxvar 30000

*replace global paths with appropriate folder names 

*folder with all the codes
global main "...\main_codes"
*folder where all the edited data will be saved
global folder "..."
*folder with all raw HRS data
global rawfolder "..."



cd "...\main_codes\financial_and_housing_wealth"
****Financial Wealth
 *  Net value of real estate (h*arles)
    do "real estate.do"
 *  Net value of vehicles (h*atran)
	do "transportation.do"
 *  Net value of businesses (h*absns)
	do "business.do"
 *  Net value of IRA, Keogh accounts* (h*aira)
	do "IRA.do"
 *  Net value of stocks, mutual funds, and investment trusts (h*astck)
	do "stocks.do"
 *  Value of checking, savings, or money market accounts (h*achck)
	do "checking.do"
 *  Value of CD, government savings bonds, and T-bills (h*acd)
	do "cd.do"
 *  Net value of bonds and bond funds (h*abond)
 	do "bond.do"
 *  Net value of all other savings (h*aothr)
 	do "other.do"
 *  Value of other debt (h*adebt)
 	do "debt.do"
****Housing wealth
*   Value of primary residence (h*ahous)
	do "primary residence.do"
*   Value of all mortgages/land contracts (primary residence) (h*amort)
	do "primary mortgage"
*   Value of other home loans (primary residence) (h*ahmln)
	do "primary home loan.do"
*   Value of secondary residence (h*ahoub)
	do "second home.do"
*   Value of all mortgages/land contracts (secondary residence) (h*amortb)
	do "mortgage second home.do"

	
*merge to RAND or tracker	
use "$rawfolder\hrs2020\h20pr_r.dta",clear 

gen h15hhid=hhid+rsubhh
destring h15hhid,replace
bys h15hhid: egen anyfinr=min(rfinr)

*there are 325 people in pr that don't match with anything
 foreach val in rles tran bsns ira stock chck cd bond othr debt hous mort hmln houb mortb{
 	merge m:1 h15hhid using "$folder\wave15\\`val'15.dta",keep(3) nogen
	
 }
 
 
 
 gen hhidpn=hhid+pn
 destring hhidpn,replace
 
 keep hhidpn h15hhid h*
 

 gen m_h15amort=-h15amort
 gen m_h15ahmln=-h15ahmln
 gen m_h15adebt=-h15adebt
 gen m_h15amortb=-h15amortb
 
 
 *Net value of primary housing
 egen h15atoth=rowtotal(h15ahous m_h15amort m_h15ahmln),m
 *Net value of secondary housing
 egen h15anethb=rowtotal(h15ahoub m_h15amortb)
 *Net value of non-housing financial wealth
 egen h15atotf=rowtotal(h15astck h15achck h15acd h15abond h15aothr m_h15adebt)
 *Total wealth
 egen h15atotb=rowtotal(h15atotf h15atoth h15anethb h15arles h15atran h15absns h15aira)
 *Total wealth net of IRA
 egen h15atotw=rowtotal(h15atotf h15atoth h15anethb h15arles h15atran h15absns)
 *Total non-housing wealth
 egen h15atotn=rowtotal(h15atotf  h15arles h15atran h15absns h15aira)
 
 drop m_*

 *no financial respondent: currently each asset looks missing - can make them 0