* --------------------------------------------------------------------------------*
                    /* IRA account balances - upto 3*/
* --------------------------------------------------------------------------------*	

clear

*load the imputation program
do "$main/imputethis.do"




use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_9*)

**************IRA balances

*do you/partner have any money that are held in IRA or Keogh account?
gen hasira=(RQ162==1)

*upto 3 accounts in 2020
gen howmany=0
replace howmany=1 if RQ163==1
replace howmany=2 if RQ163==2
replace howmany=3 if inrange(RQ163,3,4)
replace howmany=. if inrange(RQ163,8,9)
replace howmany=. if RQ163==-8
replace howmany=1 if (RU002_9==3 | RU002_9==5)  & !missing(RU003_9B) 


**************First IRA
*treat the value in asset reconciliation as the value in IRA #1
replace RQ166_1=RU003_9B if (RU002_9==3 | RU002_9==5) 
replace RQ166_1=999999998 if (RU002_9==3 | RU002_9==5) & !missing(RU003_9B) & RU003_9B>=9999998
replace RQ167_1=RU004_9B if (RU002_9==3 | RU002_9==5) 
replace RQ168_1=RU005_9B if (RU002_9==3 | RU002_9==5) 

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if RQ166_1<999999998 // donor group 
replace mmiss=1 if RQ166_1>999999997 & RQ166_1<1999999998 // missing variable code
replace mmiss=1 if RQ166_1==-8 // missing variable code

replace RQ167_1=0 if mmiss==1 & RQ167_1==.
replace RQ168_1=99999996 if mmiss==1 & RQ168_1==.

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=RQ166_1
replace exactvalue=999999998 if RQ166_1==-8
gen double lowervalue=RQ167_1
gen double uppervalue=RQ168_1

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999998  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.


* Impute
imputethis
* Replace variable with imputation
gen h15aira1=exactvalue
gen h15afaira1=1 if RQ166_1<999999998 & RQ166_1!=-8
replace h15afaira1=2 if (RQ166_1>=999999998 & RQ166_1!=.) | RQ166_1==-8
replace h15afaira1=3 if RQ166_1==0 | howmany==0
replace h15afaira1=4 if howmany==.

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag

**************2nd IRA account

gen mmiss=.
replace mmiss=0 if RQ166_2<999999998 // donor group 
replace mmiss=1 if RQ166_2>999999997 & RQ166_2<1999999998 // missing variable code
replace mmiss=1 if RQ166_2==-8 // missing variable code

replace RQ167_2=0 if mmiss==1 & RQ167_2==.
replace RQ168_2=99999996 if mmiss==1 & RQ168_2==.

* Code lower, upper, and exact values (input for imputation code)
replace exactvalue=RQ166_2
replace exactvalue=999999998 if RQ166_2==-8
replace exactvalue=999999998 if exactvalue>=999999998 & RQ166_2<1999999999
replace lowervalue=RQ167_2
replace uppervalue=RQ168_2

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999998  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis
* Replace variable with imputation
gen h15aira2=exactvalue
replace h15aira2=0 if howmany==1 // need this due to asset reconciliation
gen h15afaira2=1 if RQ166_2<999999998 & RQ166_2!=-8
replace h15afaira2=2 if (RQ166_2>=999999998 & RQ166_2!=.) | RQ166_2==-8
replace h15afaira2=3 if RQ166_2==0 | (howmany==0 | howmany==1)
replace h15afaira2=4 if howmany==.

label values h15afaira2 flag
**************3rd IRA account

gen mmiss=.
replace mmiss=0 if RQ166_3<999999998 // donor group 
replace mmiss=1 if RQ166_3>999999997 & RQ166_3<1999999998 // missing variable code
replace mmiss=1 if RQ166_3==-8 // missing variable code

replace RQ167_3=0 if mmiss==1 & RQ167_3==.
replace RQ168_3=99999996 if mmiss==1 & RQ168_3==.

* Code lower, upper, and exact values (input for imputation code)
replace exactvalue=RQ166_3
replace exactvalue=999999998 if RQ166_3==-8
replace exactvalue=999999998 if !missing(exactvalue) & exactvalue>=999999998
replace lowervalue=RQ167_3
replace uppervalue=RQ168_3

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999998  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis
* Replace variable with imputation
gen h15aira3=exactvalue
replace h15aira3=0 if howmany==1 // need this due to asset reconciliation
gen h15afaira3=3 if RQ166_3<999999998 & RQ166_3!=-8
replace h15afaira3=2 if (RQ166_3>=999999998 & RQ166_3!=.) | RQ166_3==-8
replace h15afaira3=3 if RQ166_3==0 | (howmany==0 | howmany==1 | howmany==2 )
replace h15afaira3=4 if howmany==.

label values h15afaira3 flag

*total
egen h15aira=rowtotal(h15aira*),m

gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15aira* h15af*
save "$folder\wave15\ira15.dta",replace