* --------------------------------------------------------------------------------*
* Net value of corporate, municipal, government or foreign bonds, or bond funds
* --------------------------------------------------------------------------------*

clear
/*
global main "..."
global folder "..."
global rawfolder "..."
*/
*load the imputation program
do "$main/imputethis.do"



use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_7*)
*if this wave is wrong change the answer
replace RQ330=1 if (RU002_7==3 | RU002_7==5)  & !missing(RU003_7B) 
replace RQ331=RU003_7B if (RU002_7==3 | RU002_7==5) 
replace RQ331=9999998 if (RU002_7==3 | RU002_7==5) & !missing(RU003_7B) & RU003_7B>=999998
replace RQ332=RU004_7B if (RU002_7==3 | RU002_7==5) 
replace RQ333=RU005_7B if (RU002_7==3 | RU002_7==5) 



**************corporate, municipal, government or foreign  bonds, or bond funds
*sequence --- Q330: ownership - Q331: amount - Q332: min  - Q333: max

*** be careful with the missings**

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ331<9999998 // donor group
replace mmiss= 1 if RQ331>9999997 & RQ331<1999999999 // missing variable code
replace mmiss= 1 if RQ331==-8 // missing variable code

* if any coding is needed
replace RQ332= 0 if RQ332==. & mmiss==1      
replace RQ333= 99999996 if RQ333==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ331
replace exactvalue = 99999999 if RQ331>9999997 & RQ331<1999999999
replace exactvalue = 99999999 if RQ331==-8
gen double lowervalue = RQ332
gen double uppervalue = RQ333

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15abond=exactvalue
gen h15afbond=1 if RQ331<9999998 & RQ331!=-8
replace h15afbond=2 if (RQ331>=9999998 & RQ331!=.) | RQ331==-8
replace h15afbond=3 if RQ331==0 | RQ330==5
replace h15afbond=4 if RQ330!=1 & RQ330!=5

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag
 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15abond h15afbond
save "$folder\wave15\bond15.dta",replace