* --------------------------------------------------------------------------------*
                    /* Net value of business or farm*/
* --------------------------------------------------------------------------------*		

clear

*load the imputation program
do "$main/imputethis.do"




use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_10*)
*if this wave is wrong change the answer
replace RQ147=1 if (RU002_10==3 | RU002_10==5)  & !missing(RU003_10B) 
replace RQ148=RU003_10B if (RU002_10==3 | RU002_10==5) 
replace RQ148=99999998 if (RU002_10==3 | RU002_10==5) & !missing(RU003_10B) & RU003_10B>=9999998
replace RQ149=RU004_10B if (RU002_10==3 | RU002_10==5) 
replace RQ150=RU005_10B if (RU002_10==3 | RU002_10==5) 


*sequence --- Q147: ownership - Q148: amount - Q149: min  - Q150: max

*** be careful with the missings**

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ148<99999998 // donor group
replace mmiss= 1 if RQ148>99999997 & RQ148<1999999999 // missing variable code
replace mmiss= 1 if RQ148==-8 // missing variable code

* if any coding is needed
replace RQ149= 0 if RQ149==. & mmiss==1     
replace RQ150= 99999996 if RQ150==. & mmiss==1   

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ148
replace exactvalue = 99999998 if RQ148==-8
gen double lowervalue = RQ149
gen double uppervalue = RQ150

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999998 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15absns=exactvalue
gen h15afbsns=1 if RQ148<99999998 & RQ148!=-8
replace h15afbsns=2 if (RQ148>=99999998 & RQ148!=.) | RQ148==-8
replace h15afbsns=3 if RQ148==0 | RQ147==5
replace h15afbsns=4 if RQ147!=1 & RQ147!=5

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag
 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15absns h15afbsns
save "$folder\wave15\bsns15.dta",replace