* --------------------------------------------------------------------------------*
*      Net value of CDs, Government Savings Bonds, or Treasury Bills              *
* --------------------------------------------------------------------------------*	

clear

*load the imputation program
do "$main/imputethis.do"




use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_5*)
*if this wave is wrong change the answer
replace RQ356=1 if (RU002_5==3 | RU002_5==5)  & !missing(RU003_5B) 
replace RQ357=RU003_5B if (RU002_5==3 | RU002_5==5) 
replace RQ357=999999998 if (RU002_5==3 | RU002_5==5) & !missing(RU003_5B) & RU003_5B>=999998
replace RQ358=RU004_5B if (RU002_5==3 | RU002_5==5) 
replace RQ359=RU005_5B if (RU002_5==3 | RU002_5==5) 


**************CDs, Government Savings Bonds, or Treasury Bills
*sequence --- Q356: ownership - Q357: amount - Q358: min  - Q359: max

*** be careful with the missings**

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ357<999999998 // donor group
replace mmiss= 1 if RQ357>999999997 & RQ357<1999999999 // missing variable code
replace mmiss= 1 if RQ357==-8 // missing variable code

* if any coding is needed
replace RQ358= 0 if RQ358==. & mmiss==1     
replace RQ359= 99999996 if RQ359==. & mmiss==1   

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ357
replace exactvalue = 999999999 if RQ357==-8
gen double lowervalue = RQ358
gen double uppervalue = RQ359

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999998 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15acd=exactvalue
gen h15afcd=1 if RQ357<999999998 & RQ357!=-8
replace h15afcd=2 if (RQ357>=999999998 & RQ357!=.) | RQ357==-8
replace h15afcd=3 if RQ357==0 | RQ356==5
replace h15afcd=4 if RQ356!=1 & RQ356!=5

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag
 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15acd h15afcd
save "$folder\wave15\cd15.dta",replace