* --------------------------------------------------------------------------------*
   /* Net value of checking accoungs, savings accounts, money market funds*/ 
* --------------------------------------------------------------------------------*	

clear

*load the imputation program
do "$main/imputethis.do"




use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_6*)
*if this wave is wrong change the answer
replace RQ344=1 if (RU002_6==3 | RU002_6==5)  & !missing(RU003_6B) 
replace RQ345=RU003_6B if (RU002_6==3 | RU002_6==5) 
replace RQ345=9999998 if (RU002_6==3 | RU002_6==5) & !missing(RU003_6B) & RU003_6B>=9999998
replace RQ346=RU004_6B if (RU002_6==3 | RU002_6==5) 
replace RQ347=RU005_6B if (RU002_6==3 | RU002_6==5) 



**************checking accoungs, savings accounts, money market funds
*sequence --- Q344: ownership - Q345: amount - Q346: min  - Q347: max

*** be careful with the missings**

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ345<9999998 // donor group
replace mmiss= 1 if RQ345>9999997 & RQ345<1999999999 // missing variable code
replace mmiss= 1 if RQ345==-8 // missing variable code

* if any coding is needed
replace RQ346= 0 if RQ346==. & mmiss==1     
replace RQ347= 99999996 if RQ347==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ345
replace exactvalue = 99999999 if RQ345>9999997 & RQ345<1999999999
replace exactvalue = 99999999 if RQ345==-8
gen double lowervalue = RQ346
gen double uppervalue = RQ347

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15achck=exactvalue
gen h15afchck=1 if RQ345<9999998 & RQ345!=-8
replace h15afchck=2 if (RQ345>=9999998 & RQ345!=.) | RQ345==-8
replace h15afchck=3 if RQ345==0 | RQ344==5
replace h15afchck=4 if RQ344!=1 & RQ344!=5

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag

 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15achck h15afchck
save "$folder\wave15\chck15.dta",replace