* --------------------------------------------------------------------------------*
*                   Value of other debt                                           *      
	  
	  /* any debts that we haven't asked
         about, such as credit card balances, medical debts, life insurance policy loans,
         loans from relatives, and so forth*/     
* --------------------------------------------------------------------------------*	



clear

*load the imputation program
do "$main/imputethis.do"




use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_1*)
*if this wave is wrong change the answer
replace RQ477=1 if (RU002_1==3 | RU002_1==5)  & !missing(RU003_1B) 
replace RQ478=RU003_1B if (RU002_1==3 | RU002_1==5) 
replace RQ478=9999998 if (RU002_1==3 | RU002_1==5) & !missing(RU003_1B) & RU003_1B>=999998
replace RQ479=RU004_1B if (RU002_1==3 | RU002_1==5) 
replace RQ480=RU005_1B if (RU002_1==3 | RU002_1==5) 


*sequence --- Q477: ownership - Q478: amount - Q479: min  - Q480: max

*** be careful with the missings**

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ478<9999998 // donor group
replace mmiss= 1 if RQ478>9999997 & RQ478<1999999999 // missing variable code
replace mmiss= 1 if RQ478==-8 // missing variable code

* if any coding is needed
replace RQ479= 0 if RQ479==. & mmiss==1      
replace RQ480= 99999996 if RQ480==. & mmiss==1   

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ478
replace exactvalue = 99999999 if RQ478==-8
replace exactvalue = 99999999 if RQ478>9999997 & RQ478<19999999999
gen double lowervalue = RQ479
gen double uppervalue = RQ480

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15adebt=exactvalue
gen h15afdebt=1 if RQ478<999999998 & RQ478!=-8 //continious value reported
replace h15afdebt=2 if (RQ478>=999999998 & RQ478!=.) | RQ478==-8 //imputed
replace h15afdebt=3 if RQ478==0 | RQ477==5 // no asset
replace h15afdebt=4 if RQ477!=1 & RQ477!=5 // dk ownership

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag
 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15adebt h15afdebt
save "$folder\wave15\debt15.dta",replace