* --------------------------------------------------------------------------------*
*            Value of all mortgages/land contracts (secondary residence)          *      
* --------------------------------------------------------------------------------*	


clear


*load the imputation program
do "$main/imputethis.do"



use "$rawfolder\hrs2020\h20h_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_18*)

*if this wave is wrong change the answer - second home
replace RH171=RU003_18B if (RU002_18==3 | RU002_18==5) 
replace RH171=9999998 if (RU002_18==3 | RU002_18==5) & !missing(RU003_18B) & RU003_18B>= 999998
replace RH172=RU004_18B if (RU002_18==3 | RU002_18==5) 
replace RH173=RU005_18B if (RU002_18==3 | RU002_18==5) 


*** be careful with the missings**

rename hhid HHID


* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RH171<9999998 // donor group
replace mmiss= 1 if RH171>9999997 & RH171<19999999998 // missing variable code
replace mmiss= 1 if RH171==-8 // missing variable code

* if any coding is needed
replace RH172= 0 if RH172==. & mmiss==1     
replace RH173= 99999996 if RH173==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RH171
replace exactvalue = 9999999998 if RH171==-8
gen double lowervalue = RH172
gen double uppervalue = RH173


gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=9999998 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15amortb=exactvalue
gen h15afmortb=1 if RH171<9999998 & RH171!=-8
replace h15afmortb=2 if (RH171>=99999998 & RH171!=.) | RH171==-8
replace h15afmortb=3 if RH171==0 | inlist(RH170M1,.,5)
replace h15afmortb=4 if  inlist(RH170M1,8,9,-8)


label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag

 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15amortb h15afmortb 
save "$folder\wave15\mortb15.dta",replace