* --------------------------------------------------------------------------------*
*                    Net value of all other savings                               *      
	  
	  /* any other savings or assets, such
         as jewelry, money owed to you by others, a collection for investment purposes,
         rights in a trust or estate where you are the beneficiary, or an annuity that
         you haven't already told us about*/          
* --------------------------------------------------------------------------------*	


clear

*load the imputation program
do "$main/imputethis.do"



use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_3*)
*if this wave is wrong change the answer
replace RQ375=1 if (RU002_3==3 | RU002_3==5)  & !missing(RU003_3B) 
replace RQ376=RU003_3B if (RU002_3==3 | RU002_3==5) 
replace RQ376=999999998 if (RU002_3==3 | RU002_3==5) & !missing(RU003_3B) & RU003_3B>=9999998
replace RQ377=RU004_3B if (RU002_3==3 | RU002_3==5) 
replace RQ378=RU005_3B if (RU002_3==3 | RU002_3==5) 



*sequence --- Q375: ownership - Q376: amount - Q377: min  - Q378: max

*** be careful with the missings**

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ376<999999998 // donor group
replace mmiss= 1 if RQ376>999999997 & RQ376<1999999999 // missing variable code
replace mmiss= 1 if RQ376==-8 // missing variable code

* if any coding is needed
replace RQ377= 0 if RQ377==. & mmiss==1    
replace RQ378= 99999996 if RQ378==. & mmiss==1   

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ376
replace exactvalue = 999999999 if RQ376==-8
gen double lowervalue = RQ377
gen double uppervalue = RQ378

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999998 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.


gen PN=RPN_FIN
* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15aothr=exactvalue
gen h15afothr=1 if RQ376<999999998 & RQ376!=-8 //continious value reported
replace h15afothr=2 if (RQ376>=999999998 & RQ376!=.) | RQ376==-8 //imputed
replace h15afothr=3 if RQ376==0 | RQ375==5 // no asset
replace h15afothr=4 if RQ375!=1 & RQ375!=5 // dk ownership

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag
 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15aothr h15afothr
save "$folder\wave15\othr15.dta",replace