* --------------------------------------------------------------------------------*
*           Value of other home loans (primary residence)             *      
	  
            /*equity loan and other home loan */
* --------------------------------------------------------------------------------*	


clear

*load the imputation program
do "$main/imputethis.do"



use "$rawfolder\hrs2020\h20h_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_15*)

**************equity loan

*ownership RH061

*equity loan 
replace RH061=1 if (RU002_15==3 | RU002_15==5)  &  !missing(RU003_15B)
replace RH062=RU003_15B if (RU002_15==3 | RU002_15==5) 
replace RH062=999998 if (RU002_15==3 | RU002_15==5) & !missing(RU003_15B) & RU003_15B>=999998
replace RH063=RU004_15B if (RU002_15==3 | RU002_15==5) 
replace RH064=RU005_15B if (RU002_15==3 | RU002_15==5) 


rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if RH062<999998 // donor group 
replace mmiss=1 if RH062>999997 & RH062<199999999 // missing variable code
replace mmiss=1 if RH062==-8 // missing variable code

replace RH063=0 if mmiss==1 & RH063==.
replace RH064=99999996 if mmiss==1 & RH064==.

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=RH062
replace exactvalue=99999999 if mmiss==1
gen double lowervalue=RH063
gen double uppervalue=RH064

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis
* Replace variable with imputation
gen h15aeqln = exactvalue
gen h15afeqln = 1 if RH062<999998 & RH062!=-8
replace h15afeqln = 2 if (RH062>=999998 & RH062!=.) | RH062==-8
replace h15afeqln = 3 if RH062==0 |  RH061==5 |  RH061==. //doesn't have this mortgage, might have the second one.
replace h15afeqln = 4 if inlist(RH061, 8, 9, -8)

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag


**************home equity line of credit balances


gen mmiss=.
replace mmiss=0 if RH052<9999998 // donor group 
replace mmiss=1 if RH052>9999997 & RH052<199999999 // missing variable code
replace mmiss=1 if RH052==-8 // missing variable code

replace RH053=0 if mmiss==1 & RH053==.
replace RH054=99999996 if mmiss==1 & RH054==.

* Code lower, upper, and exact values (input for imputation code)
replace exactvalue=RH052
replace exactvalue=99999999 if mmiss==1
replace lowervalue=RH053
replace uppervalue=RH054

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis
* Replace variable with imputation
gen h15aeqcd=exactvalue
gen h15afeqcd=1 if RH052<9999998  & RH052!=-8
replace h15afeqcd=2 if (RH052>=9999998  & RH052!=.) | RH052==-8
replace h15afeqcd=3 if RH052==0 | RH052==.

label values h15afeqcd flag

*total
egen h15ahmln=rowtotal(h15aeq*),m

gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15ahmln* h15af* h15ae*
save "$folder\wave15\hmln15.dta",replace