* --------------------------------------------------------------------------------*
*           Value of all mortgages/land contracts (primary residence)             *      
	  
            /*how much still owed in mortagages - primary residence */ 
* --------------------------------------------------------------------------------*	


clear

*load the imputation program
do "$main/imputethis.do"



use "$rawfolder\hrs2020\h20h_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_13*)
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_14*)


**************mortgage


*upto 2 mortgage plans in 2020 (+ home loan - in a separete code)
gen howmany=0
replace howmany=1 if RH024M1==1 | (RH024M1==2 &  RH024M1!=1)
replace howmany=2 if (RH024M2==2 | RH024M2==1) & RH024M1!=3



*First mortgage
replace RH032=RU003_13B if (RU002_13==3 | RU002_13==5) 
replace RH032=9999998 if (RU002_13==3 | RU002_13==5) & !missing(RU003_13B) & RU003_13B>=999998
replace RH033=RU004_13B if (RU002_13==3 | RU002_13==5) 
replace RH034=RU005_13B if (RU002_13==3 | RU002_13==5) 

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if RH032<9999998 // donor group 
replace mmiss=1 if RH032>9999997 & RH032<199999999 // missing variable code
replace mmiss=1 if RH032==-8 // missing variable code

replace RH033=0 if mmiss==1 & RH033==.
replace RH034=99999996 if mmiss==1 & RH034==.

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=RH032
replace exactvalue=99999999 if mmiss==1
gen double lowervalue=RH033
gen double uppervalue=RH034

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis
* Replace variable with imputation
gen h15amort1=exactvalue
gen h15afmort1=1 if RH032<9999998 & RH032!=-8
replace h15afmort1=2 if (RH032>=9999998 & RH032!=.) | RH032==-8
replace h15afmort1=3 if RH032==0 | howmany==0 | (howmany==1 & RH032==.) //doesn't have this mortgage, might have the second one.
replace h15afmort1=4 if inlist(RH024M1,8,9)

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag

**************2nd mortgage

replace RH042=RU003_14B if (RU002_14==3 | RU002_14==5) 
replace RH042=9999998 if (RU002_14==3 | RU002_14==5) & !missing(RU003_14B) & RU003_14B>=999998
replace RH043=RU004_14B if (RU002_14==3 | RU002_14==5) 
replace RH044=RU005_14B if (RU002_14==3 | RU002_14==5) 


gen mmiss=.
replace mmiss=0 if RH042<999998 // donor group 
replace mmiss=1 if RH042>999997 & RH042<199999999 // missing variable code
replace mmiss=1 if RH042==-8 // missing variable code

replace RH043=0 if mmiss==1 & RH043==.
replace RH044=99999996 if mmiss==1 & RH044==.

* Code lower, upper, and exact values (input for imputation code)
replace exactvalue=RH042
replace exactvalue=99999999 if mmiss==1
replace lowervalue=RH043
replace uppervalue=RH044

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis
* Replace variable with imputation
gen h15amort2=exactvalue
gen h15afmort2=1 if RH042<999998  & RH042!=-8
replace h15afmort2=2 if (RH042>=999998  & RH042!=.) | RH042==-8
replace h15afmort2=3 if RH042==0 | (howmany==0 | (howmany==1 & RH032!=.))
replace h15afmort2=4 if howmany==.
label values h15afmort2 flag

drop howmany
*total
egen h15amort=rowtotal(h15amort*),m

gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15amort* h15af*
save "$folder\wave15\mort15.dta",replace