* --------------------------------------------------------------------------------*
*                   Value of primary residence                                    *      
	  
            /*primary residence - (home or mobile home) */   
* --------------------------------------------------------------------------------*	

clear


*load the imputation program
do "$main/imputethis.do"




use "$rawfolder\hrs2020\h20h_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_12*)
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_16*)

*if this wave is wrong change the answer - home
replace RH004=1 if (RU002_12==3 | RU002_12==5)  & !missing(RU003_12B) 
replace RH020=RU003_12B if (RU002_12==3 | RU002_12==5) 
replace RH020=9999999998 if (RU002_12==3 | RU002_12==5) & !missing(RU003_12B) & RU003_12B>=9999998
replace RH021=RU004_12B if (RU002_12==3 | RU002_12==5) 
replace RH022=RU005_12B if (RU002_12==3 | RU002_12==5) 


*sequence --- H004: ownership - H020: amount - H021: min  - H022: max

*** be careful with the missings**

rename hhid HHID


* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RH020<9999999998 // donor group
replace mmiss= 1 if RH020>9999999997 & RH020<19999999998 // missing variable code
replace mmiss= 1 if RH020==-8 // missing variable code

* if any coding is needed
replace RH021= 0 if RH021==. & mmiss==1   
replace RH022= 99999996 if RH022==. & mmiss==1   

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RH020
replace exactvalue = 9999999998 if RH020==-8
gen double lowervalue = RH021
gen double uppervalue = RH022

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=9999999998  & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15ahous=exactvalue
gen h15afhous=1 if RH020<9999999998 & RH020!=-8
replace h15afhous=2 if (RH020>=9999999998 & RH020!=.) | RH020==-8
replace h15afhous=3 if RH020==0 | inlist(RH004,2,3,7,.)
replace h15afhous=4 if  inlist(RH004,8,9)

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag

drop exactvalue lowervalue uppervalue


****************mobile home

*if this wave is wrong change the answer - home
replace RH014=1 if (RU002_16==3 | RU002_16==5)  & !missing(RU003_16B) 
replace RH016=RU003_16B if (RU002_16==3 | RU002_16==5) 
replace RH016=999998 if (RU002_16==3 | RU002_16==5) & !missing(RU003_16B) & RU003_16B>=999998
replace RH017=RU004_16B if (RU002_16==3 | RU002_16==5) 
replace RH018=RU005_16B if (RU002_16==3 | RU002_16==5) 


*sequence --- H014: ownership - H016: amount - H017: min  - H018: max


* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RH016<999998 // donor group
replace mmiss= 1 if RH016>999997 & RH016<19999999998 // missing variable code
replace mmiss= 1 if RH016==-8 // missing variable code

* if any coding is needed
replace RH017= 0 if RH017==. & mmiss==1    
replace RH018= 99999996 if RH018==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RH016
replace exactvalue = 99999998 if mmiss==1
gen double lowervalue = RH017
gen double uppervalue = RH018

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999998 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15amob=exactvalue
gen h15afmob=1 if RH016<999998 & RH016!=-8
replace h15afmob=2 if (RH016>=999998 & RH016!=.) | RH016==-8
replace h15afmob=3 if RH016==0 | inlist(RH014,4,7,.)
replace h15afmob=4 if  inlist(RH004,8,9)

replace h15ahous=h15ahous+h15amob

label values h15afmob flag

 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15ahous h15afhous h15afmob
save "$folder\wave15\hous15.dta",replace