* --------------------------------------------------------------------------------*
       *REAL ESTATE [other than your main home or second home]

/* any real estate [other than your main home or second home] such as land, rental real estate, 
     or money owed to you on a land contract or mortgage*/
* --------------------------------------------------------------------------------*		 

clear


*load the imputation program
do "$main/imputethis.do"



use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_11*)
*if this wave is wrong change the answer
replace RQ133=1 if (RU002_11==3 | RU002_11==5)  & !missing(RU003_11B) 
replace RQ134=RU003_11B if (RU002_11==3 | RU002_11==5) 
replace RQ134=999999998 if (RU002_11==3 | RU002_11==5) & !missing(RU003_11B) & RU003_11B>=99999998
replace RQ135=RU004_11B if (RU002_11==3 | RU002_11==5) 
replace RQ136=RU005_11B if (RU002_11==3 | RU002_11==5) 


*sequence --- Q133: ownership - Q134: amount - Q135: min  - Q136: max

*** be careful with the missings**

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ134<999999998 // donor group
replace mmiss= 1 if RQ134>999999997 & RQ134<1999999999 // missing variable code
replace mmiss= 1 if RQ134==-8 // missing variable code


* if any coding is needed
replace RQ135= 0 if RQ135==. & mmiss==1      
replace RQ136= 99999996 if RQ136==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ134
replace exactvalue = 999999998 if RQ134==-8
gen double lowervalue = RQ135
gen double uppervalue = RQ136

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999998 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15arles=exactvalue
gen h15afrles=1 if RQ134<999999998 & RQ134!=-8
replace h15afrles=2 if (RQ134>=999999998 & RQ134!=.) | RQ134==-8
replace h15afrles=3 if RQ134==0 | RQ133==5
replace h15afrles=4 if RQ133!=1 & RQ133!=5

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag
 
 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15arles h15afrles
save "$folder\wave15\rles15.dta",replace