* --------------------------------------------------------------------------------*
*                   Value of secondary residence                                  *      
* --------------------------------------------------------------------------------*	


clear

*load the imputation program
do "$main/imputethis.do"



use "$rawfolder\hrs2020\h20h_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_17*)

*if this wave is wrong change the answer - second home
replace RH166=RU003_17B if (RU002_17==3 | RU002_17==5) 
replace RH166=9999998 if (RU002_17==3 | RU002_17==5) & !missing(RU003_17B) & RU003_17B>= 9999998
replace RH167=RU004_17B if (RU002_17==3 | RU002_17==5) 
replace RH168=RU005_17B if (RU002_17==3 | RU002_17==5) 



*** be careful with the missings**

rename hhid HHID


* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RH166<9999998 // donor group
replace mmiss= 1 if RH166>9999997 & RH166<1999999998 // missing variable code
replace mmiss= 1 if RH166==-8 // missing variable code

* if any coding is needed
replace RH167= 0 if RH167==. & mmiss==1      
replace RH168= 99999996 if RH168==. & mmiss==1   

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RH166
replace exactvalue = 9999999998 if mmiss==1
gen double lowervalue = RH167
gen double uppervalue = RH168

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=9999999998 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15ahoub=exactvalue
gen h15afhoub=1 if RH166<9999998 & RH166!=-8
replace h15afhoub=2 if (RH166>=9999998 & RH166!=.) | RH166==-8
replace h15afhoub=3 if RH166==0 
replace h15afhoub=4 if  inlist(RH156,8,9,-8,.) & h15afhoub==.

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag

 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15ahoub h15afhoub 
save "$folder\wave15\houb15.dta",replace