* --------------------------------------------------------------------------------*
                    /* Net value of stocks, mutual funds, and investment trusts  */
* --------------------------------------------------------------------------------*	

clear

*load the imputation program
do "$main/imputethis.do"



use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_8*)
*if this wave is wrong change the answer
replace RQ316=1 if (RU002_8==3 | RU002_8==5)  & !missing(RU003_8B) 
replace RQ317=RU003_8B if (RU002_8==3 | RU002_8==5) 
replace RQ317=999999998 if (RU002_8==3 | RU002_8==5) & !missing(RU003_8B) & RU003_8B>=99999998
replace RQ318=RU004_8B if (RU002_8==3 | RU002_8==5) 
replace RQ319=RU005_8B if (RU002_8==3 | RU002_8==5) 



**************stocks
*sequence --- Q316: ownership - Q317: amount - Q318: min  - Q319: max

*** be careful with the missings**

rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
*replace mmiss= 0 if RQ317>-1 & RQ317<999999998 // donor group
replace mmiss= 0 if RQ317<999999998 // donor group
replace mmiss= 1 if RQ317>999999997 & RQ317<1999999999 // missing variable code
replace mmiss= 1 if RQ317==-8 // missing variable code

* if any coding is needed
replace RQ318= 0 if RQ318==. & mmiss==1      
replace RQ319= 99999996 if RQ319==. & mmiss==1   

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ317
replace exactvalue = 999999999 if RQ317==-8
gen double lowervalue = RQ318
gen double uppervalue = RQ319

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999998 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
gen PN=RPN_FIN
* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15astck=exactvalue
gen h15afstck=1 if RQ317<999999998 & RQ317!=-8
replace h15afstck=2 if (RQ317>=999999998 & RQ317!=.) | RQ317==-8
replace h15afstck=3 if RQ317==0 | RQ316==5
replace h15afstck=4 if RQ316!=1 & RQ316!=5

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag
 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15astck h15afstck
save "$folder\wave15\stock15.dta",replace