* --------------------------------------------------------------------------------*
                                 * VEHICLES

         /* cars, trucks, a trailer, a motor home, a boat, or an airplane?    
                     Does not include leased vehicles*/
* --------------------------------------------------------------------------------*		 

clear

*load the imputation program
do "$main/imputethis.do"




use "$rawfolder\hrs2020\h20q_h.dta",clear
*merge asset reconciliation
merge 1:1 hhid rsubhh RPN_FIN using "$rawfolder\hrs2020\h20u_h.dta", nogen keep(1 3) keepusing(*_4*)
*if this wave is wrong change the answer
replace RQ370=1 if (RU002_4==3 | RU002_4==5)  & !missing(RU003_4B) 
replace RQ371=RU003_4B if (RU002_4==3 | RU002_4==5) 
replace RQ371=999998 if (RU002_4==3 | RU002_4==5) & !missing(RU003_4B) & RU003_4B>=999998
replace RQ372=RU004_4B if (RU002_4==3 | RU002_4==5) 
replace RQ373=RU005_4B if (RU002_4==3 | RU002_4==5) 


*sequence --- Q370: ownership - Q371: amount - Q372: min  - Q373: max

*** be careful with the missings**

rename hhid HHID


* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ371<999998 // donor group
replace mmiss= 1 if RQ371>999997 & RQ371<1999999999 // missing variable code
replace mmiss= 1 if RQ371==-8 // missing variable code


* if any coding is needed
replace RQ372= 0 if RQ372==. & mmiss==1     
replace RQ373= 99999996 if RQ373==. & mmiss==1   

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ371
replace exactvalue = 99999999 if RQ371==-8
replace exactvalue = 99999999 if RQ371>999997 & RQ371<1999999999
gen double lowervalue = RQ372
gen double uppervalue = RQ373

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis


*******************************
* Replace variable with imputation
gen h15atran=exactvalue
gen h15aftran=1 if RQ371<999998 & RQ371!=-8
replace h15aftran=2 if (RQ371>=999998 & RQ371!=.) | RQ371==-8
replace h15aftran=3 if RQ371==0 | RQ370==5
replace h15aftran=4 if RQ370!=1 & RQ370!=5

label define flag 1 "Continious value" 2 "Imputed" 3 "No asset" 4 "No asset/DK ownership"
label values h15af flag
 
gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15atran h15aftran
save "$folder\wave15\tran15.dta",replace