/*code description
	1. within given range, find the group of respodnents with most similar characteristics
	2. among this group, pick a random neighbor


*/
program drop _all
capture log close
clear 
*set seed 8309830



*******************************IMPUTATIONS************************************

program define imputethis

cap drop gender race married* educ rabyear
merge m:1 HHID  PN using "$folder\demog.dta", nogen keep(3)

gen married=married15
forvalues w=1/14{
cap replace married=married`w' if yr==`w' 
}


mi set wide
mi register imputed exactvalue_imp

egen recipgrp = group(lowervalue uppervalue)
tab recipgrp
egen numgroup = max(recipgrp)
local num = numgroup[1]
display `num'
sum uppervalue
local maxup = r(max)

gen exactvalueimpute=.

*imputation algorithm here*****************************
local numimp=1
local ii =1
while `ii' <= `num' {

*first get upper and lower bounds 
gen mygroup=1
replace mygroup=0 if recipgrp == `ii'

sum recipgrp if recipgrp == `ii'

sort mygroup

local mymin= lowervalue[1]
local mymax= uppervalue[1]
gen dif=`mymax'-`mymin'

if abs(dif)<1{
	*gen _`ii'_exactvalue_imp=`mymin'
	replace exactvalueimpute = lowervalue[1] if recipgrp==`ii'
	drop mygroup dif
	local ii = `ii' + 1
	continue
}
drop dif
qui sum exactvalue if mmiss==0 & exactvalue>=`mymin' & exactvalue<=`mymax' 
local num_don = r(N) // number of "donors"
qui sum exactvalue if exactvalue~=. & ((exactvalue>=`mymin' & exactvalue<=`mymax')|(mygroup==0))
local num_samp = r(N) //number of "recipients"


gen sample = 1
replace sample = 0 if exactvalue~=. & ((exactvalue>=`mymin' & exactvalue<=`mymax')|(mygroup==0))
gen donors = 1
replace donors = 0 if mmiss==0 & exactvalue>=`mymin' & exactvalue<=`mymax' 


qui cap reg exactvalue_imp gender i.race educ rabyear married if sample==0 
scalar df_residual = e(df_r)

 
sort sample donors  HHID PN 
*number of donors need to be greater than number of parameters - in such cases, use hotdeck
if (`num_don'>4 & `num_don'<50000) & df_residual!=0 {

mi impute pmm exactvalue_imp gender i.race educ rabyear married if sample==0, add(1) knn(1) force
replace exactvalueimpute=_`numimp'_exactvalue_imp if sample==0 & donors==1
local numimp = `numimp' + 1
}

if (`num_don'>0 & `num_don'<5) |  df_residual==0 {
local i=1
	while `i' <= `num_samp' {
	  local i2 = ceil(uniform()*`num_don')
	  qui replace exactvalueimpute = exactvalue[`i2'] in `i'
	  local i = `i' + 1
			
}
}

if (`num_don'<1 | `num_don'>50000) {
 local i=1
	while `i' <= `num_samp' {	
			qui replace exactvalueimpute = (lowervalue+uppervalue)/2 in `i' if uppervalue~=99999996
			qui replace exactvalueimpute = lowervalue in `i' if uppervalue==99999996
    local i = `i' + 1
	      }
}


drop mygroup sample donors 
local ii = `ii' + 1
}

replace exactvalue=exactvalueimpute if mmiss==1
replace exactvalue=0 if mmiss==.
sort mmiss
by mmiss: sum exactvalue

mi unset
*drop mmiss recipgrp numgroup exactvalueimpute exactvalue_imp_* mi_miss exactvalue_imp
drop mmiss recipgrp numgroup exactvalueimpute  mi_miss exactvalue_imp*

end

