*------------------------------------------------------------------------------*
*                 MAIN INCOME PROGRAM                                          *
*------------------------------------------------------------------------------*

*cd - working folder
cd "\\courageous\Administration\Executive\CRR\CRRMicroDataFiles\HRS\Template Code\Code\main_codes\income"

global main "...\Code\main_codes"
global do "...\Code\main_codes"
global folder "..."
global rawfolder "..."
global rand "..."
global data "..."


*DC withdrawals for all waves (not in RAND) - on individual level
forvalues i=1992(2)2020{
	do "DC withdrawals/DC withdrawals `i'.do"
}

*other income variables(replication of RAND) - asked on household level - adjust accordingly when merging into RAND
* "r" is the financial respondent and "s" is the non-financial respondent

*Note: order doesn't matter - except run "spouse social security" before "social security"
do "earnings.do"
do "capital income.do"
do "government transfers.do"
do "IRA withdrawals.do"
do "other income.do"
do "pension and annuity.do"
do "social security.do"
do "unemployment and workers compensation.do"


*merge and impute nr spouse for DC withdrawals
do "DC withdrawal nr spouse adjustment.do"

*merge all income variables and organize it on the individual level similar to RAND longitidunal file
do "merge.do"

*individual level
*before running "rmd.do", need to run all the codes in "pensions" box as well as all the DC and IRA withdrawal codes
do "rmd.do"



*create dataset to merge to rand
use "$folder/income_merged.dta",clear
merge 1:1 hhidpn using "$folder/dcw.dta" , keep(1 3) nogen
merge 1:1 hhidpn using "$folder/rmd.dta", keep(1 3) nogen


