*Incorporate non-respondent spouse to DC withdrawal questions
*impute based on respondent spouse's characteristics


use "$rand\randhrs1992_2020v1.dta", clear
merge 1:1 hhidpn using "$folder/missingspouse.dta",keep(1 3) nogen 
 
*wave 11 on - missing means 0 if interviewed
forvalues i=1/15{ 
merge 1:1 hhidpn using "$folder\wave15\dcwtdr_`i'.dta",keep(1 3) nogen
}
drop *_imp
forvalues i=1/15{
	replace r`i'dcw_=0 if r`i'iwendy!=. & r`i'dcw_==.
	rename r`i'dcw_ r`i'dcw
}

rename hhidpn hhidpn_o


*merge for spouses
forvalues i=1/15{ 
rename s`i'hhidpn hhidpn
merge m:1 hhidpn using "$folder\wave15\dcwtdr_`i'.dta",keep(1 3) gen(s`i')
rename hhidpn s`i'hhidpn

rename r`i'dcw_ s`i'dcw
cap drop *_imp
replace s`i'dcw=0 if s`i'dcw==. & r`i'iwendy!=. & r`i'missingsp!=1.
drop s`i'


*variable creation
gen married`i'=inlist(r`i'mstat,1,2)
gen age`i'=r`i'agey_m
gen sage`i'=s`i'agey_m
replace sage`i'=age`i' if sage`i'==. & married`i'==1
}


 gen gender=ragender
 gen cohort=racohbyr
 gen nonwhite=(rarace!=1 & rahispan!=0) 
 gen college=(raeduc>=4)
 
 
mi set wide 

forvalues i=1/15{

mi register imputed s`i'dcw
mi impute pmm s`i'dcw = gender i.cohort age`i' sage`i' i.nonwhite i.college i.married`i' r`i'iearn r`i'isret r`i'ipen, replace knn(1) add(1) force

replace s`i'dcw=_1_s`i'dcw if (r`i'missingsp==1)
mi unregister  s`i'dcw

 }

 keep hhidpn r*dcw s*dcw
 rename hhidpn_o hhidpn

 save "$folder/dcw.dta",replace