
do "$do/imputethis.do"
use "$rawfolder/hrs1992/EMPLOYER.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

****************************
* 1. LAST JOB
*******************************

*if withdrew - means they withdrew all the money in the account when they left


*DC type or "both" type are asked separate sets of questions

*Both type - ignore
*no separate dispostion question for the "both" type


*DC type
gen withdrawn=0
replace withdrawn=1 if V3524==1



*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)

* Code missings (input for imputation code)
replace V3523=9999996 if V3501==2 & V3523==.
gen mmiss=.
replace mmiss=0 if V3523 <9999996 // donor group 
replace mmiss=1 if V3523 >9999995 & V3523<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=V3523
gen double lowervalue=0
gen double uppervalue=9999995

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=1
imputethis
drop yr

gen aleft=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd=0
replace plan_dc_wd=aleft if withdrawn==1



*last year worked
gen lastyear=V3403 if V3403<9996
gen lastmonth=V3402 if lastyear!=. & V3402<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=AIWYEAR*12+AIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<AIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==AIWYEAR-1

gen dc_wd_total1 = plan_dc_wd
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since
replace dc_wd_total1=0 if dc_wd_total1==.

drop lastmonth lastyear months*
*no other pension disposition questions for last job



*JOB HISTORY #1 - if type B plan, and has cash settlement - withdrawal

*DC type
gen withdrawn2=0
replace withdrawn2=1 if inlist(V3644,51,52,53,55)


replace V3643=9999996 if V3621==2 & V3643==.
gen mmiss=.
replace mmiss=0 if V3643 <9999996 // donor group 
replace mmiss=1 if V3643 >9999995 & V3643<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=V3643
gen double lowervalue=0
gen double uppervalue=9999995

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=1
imputethis
drop yr

gen a2left=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd2=0
replace plan_dc_wd2=a2left if withdrawn2==1



*last year worked
gen lastyear=V3607 if V3607<9996
gen lastmonth=V3606 if lastyear!=. & V3606<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=AIWYEAR*12+AIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<AIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==AIWYEAR-1

gen dc_wd_total2 = plan_dc_wd2
replace dc_wd_total2=dc_wd_total2*monthsinlcy/months_since
replace dc_wd_total2=0 if dc_wd_total2==.
drop lastmonth lastyear months*

*JOB HISTORY #2 - if type B plan, and has cash settlement - withdrawal

gen withdrawn3=0
replace withdrawn3=1 if inlist(V3731,51,52,53,55)


replace V3730=9999996 if V3708==2 & V3730==.
gen mmiss=.
replace mmiss=0 if V3730 <9999996 // donor group 
replace mmiss=1 if V3730 >9999995 & V3730<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=V3730
gen double lowervalue=0
gen double uppervalue=9999995

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=1
imputethis
drop yr

gen a3left=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd3=0
replace plan_dc_wd3=a3left if withdrawn3==1



*last year worked
gen lastyear=V3705 if V3705<9996
gen lastmonth=6 if lastyear!=. 

gen months_since=AIWYEAR*12+AIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<AIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==AIWYEAR-1

gen dc_wd_total3 = plan_dc_wd3
replace dc_wd_total3=dc_wd_total3*monthsinlcy/months_since
replace dc_wd_total3=0 if dc_wd_total3==.
drop lastmonth lastyear months*


*JOB HISTORY #3 - if type B plan, and has cash settlement - withdrawal


gen withdrawn4=0
replace withdrawn4=1 if inlist(V3831,51,52,53,55)


replace V3830=9999996 if V3808==2 & V3830==.
gen mmiss=.
replace mmiss=0 if V3830 <9999996 // donor group 
replace mmiss=1 if V3830 >9999995 & V3830<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=V3830
gen double lowervalue=0
gen double uppervalue=9999995

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=1
imputethis
drop yr

gen a4left=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd4=0
replace plan_dc_wd4=a4left if withdrawn4==1



*last year worked
gen lastyear=V3805 if V3805<9996
gen lastmonth=6 if lastyear!=. 

gen months_since=AIWYEAR*12+AIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<AIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==AIWYEAR-1

gen dc_wd_total4 = plan_dc_wd4
replace dc_wd_total4=dc_wd_total4*monthsinlcy/months_since
replace dc_wd_total4=0 if dc_wd_total4==.
drop lastmonth lastyear months*



egen r1dcw_ = rowtotal(dc_wd_total*)
keep hhidpn r1dcw_
save "$folder\wave15\dcwtdr_1.dta",replace
