
do "$do/imputethis.do"
use "$rawfolder/hrs1994/W2FA.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

****************************
* 1. PREV wave employer:
*******************************

*if withdrew - means they withdrew all the money in the account when they left

/*
. tab W3572

  FA31.TYPE |
 OF PENSION |
        PLA |      Freq.     Percent        Cum.
------------+-----------------------------------
          0 |     11,387       98.20       98.20
     Type A |         99        0.85       99.05
     Type B |         89        0.77       99.82
       both |         15        0.13       99.95
          8 |          6        0.05      100.00
------------+-----------------------------------
      Total |     11,596      100.00

*/


*DC type or "both" type are asked separate sets of questions

*Both type - ignore
*no separate dispostion question for the "both" type


*DC type
gen withdrawn=0
replace withdrawn=1 if W3602==1



*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if W3601 <9999997 // donor group 
replace mmiss=1 if W3601 >9999996 & W3601<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=W3601
gen double lowervalue=0
gen double uppervalue=9999994

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=2
imputethis
drop yr

gen aleft=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd=0
replace plan_dc_wd=aleft if withdrawn==1



*last year worked
gen lastyear=W3504 if W3504<9996
gen lastmonth=W3503 if lastyear!=. & W3503<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=CIWYEAR*12+CIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<CIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==CIWYEAR-1

gen dc_wd_total1 = plan_dc_wd
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since
replace dc_wd_total1=0 if dc_wd_total1==.

*no other pension disposition questions


egen dc_wd_totalFA = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalFA
save "$folder\wave15\dcwtdr1_2.dta",replace


*self employed
use "$rawfolder/hrs1994/W2FB.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

****************************
* 1. PREV wave employer:
*******************************


*DC type or "both" type are asked separate sets of questions

*Both type - ignore
*no separate dispostion question for the "both" type

*prev wave employed - now self employed

*DC type
gen withdrawn=0
replace withdrawn=1 if W4307==1



*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if W4306 <9999997 // donor group 
replace mmiss=1 if W4306 >9999996 & W4306<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=W4306
gen double lowervalue=0
gen double uppervalue=9999994

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=2
imputethis
drop yr

gen aleft=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd=0
replace plan_dc_wd=aleft if withdrawn==1


*last year worked
gen lastyear=W4201 if W4201<9996
gen lastmonth=W4200 if lastyear!=. & W4200<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=CIWYEAR*12+CIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<CIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==CIWYEAR-1

gen dc_wd_total1 = plan_dc_wd
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since
replace dc_wd_total1=0 if dc_wd_total1==.


*no other withdrawals asked in this section

egen dc_wd_totalFB = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalFB
save "$folder\wave15\dcwtdr2_2.dta",replace




*unemployed
use "$rawfolder/hrs1994/W2FC.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

****************************
* 1. PREV wave employer:
*******************************


*DC type or "both" type are asked separate sets of questions

*Both type - ignore
*no separate dispostion question for the "both" type

*prev wave self employed - now  unemployed
*no withdrawals


*prev wave employed - now  unemployed

*DC type
gen withdrawn=0
replace withdrawn=1 if W4996==1



*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if W4995 <9999997 // donor group 
replace mmiss=1 if W4995 >9999996 & W4995<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=W4995
gen double lowervalue=0
gen double uppervalue=9999994

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=2
imputethis
drop yr

gen aleft=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd=0
replace plan_dc_wd=aleft if withdrawn==1


*last year worked
gen lastyear=W4898 if W4898<9996
gen lastmonth=W4897 if lastyear!=. & W4897<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=CIWYEAR*12+CIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<CIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==CIWYEAR-1

gen dc_wd_total1 = plan_dc_wd
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since
replace dc_wd_total1=0 if dc_wd_total1==.


*no other withdrawals asked in this section

egen dc_wd_totalFC = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalFC
save "$folder\wave15\dcwtdr3_2.dta",replace


*LAST JOB
use "$rawfolder/hrs1994/W2G.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)


*only one person withdrew money from DC - non missing

gen plan_dc_wd=0
replace plan_dc_wd=W7062 if W7063==1

gen lastyear=W7002 if W7002<9996
gen lastmonth=W7004 if lastyear!=. & W7004<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=CIWYEAR*12+CIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<CIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==CIWYEAR-1

gen dc_wd_total1 = plan_dc_wd
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since
replace dc_wd_total1=0 if dc_wd_total1==.


*no other withdrawals asked in this section

egen dc_wd_totalG = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalG
save "$folder\wave15\dcwtdr4_2.dta",replace



*JOB HISTORY
use "$rawfolder/hrs1994/W2H.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)


*withdrawals from this year or very old - ignore
tab W7108 if W7154==1



use "$folder\wave15\dcwtdr1_2.dta",clear
merge 1:1 hhidpn using "$folder\wave15\dcwtdr2_2.dta",nogen
merge 1:1 hhidpn using "$folder\wave15\dcwtdr3_2.dta",nogen
merge 1:1 hhidpn using "$folder\wave15\dcwtdr4_2.dta",nogen
egen r2dcw_ = rowtotal(dc_wd_totalFA dc_wd_totalFB dc_wd_totalFC dc_wd_totalG)
drop dc_wd*
keep hhidpn r2*
save "$folder\wave15\dcwtdr_2.dta",replace