
do "$do/imputethis.do"
use "$rawfolder/hrs1996/H96G_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

****************************
* 1. PREV wave employer:
*******************************

*if withdrew - means they withdrew all the money in the account when they left

*DC type or "both" type are asked separate sets of questions

*type "both"

* 0 : no w/d 1: withdrawal only 
gen withdrawn=0
replace withdrawn=1 if E2683==1



*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if E2682 <9999998 // donor group 
replace mmiss=1 if E2682 >9999997 & E2682<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=E2682 
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=3
imputethis
drop yr

gen aleft=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd=0
replace plan_dc_wd=aleft if withdrawn==1



*type "DC"

gen withdrawn2=0
replace withdrawn2=1 if E2715==1



* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if E2714<9999997 // donor group 
replace mmiss=1 if E2714>9999996 & E2714<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=E2714
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=3
imputethis
drop yr

gen a2left=exactvalue

drop exactvalue lowervalue uppervalue 

replace plan_dc_wd=a2left if withdrawn2==1



*last year worked
gen lastyear=E2668 if E2668<9997
gen lastmonth=E2667 if lastyear!=. & E2667<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=EIWYEAR*12+EIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<EIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==EIWYEAR-1

gen dc_wd_total1 = plan_dc_wd
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since
replace dc_wd_total1=0 if dc_wd_total1==.

drop months_since monthsinlcy lastyear lastmonth plan_dc_wd*


****************************
*between previous wave job and current job - LAST JOB
*******************************

*"both" type - no both type -


gen plan_dc_wd3=0



*"DC" type - no withdrawal


drop withdrawn* 
****************************
*Job history: other 5+ year job
*******************************

*"both" type - no both type

gen plan_dc_wd=0



*DC type - 1 

gen withdrawn2=0
replace withdrawn2=1 if E3379  ==5


tab E3337 if withdrawn2==1
*nothing in last two years


*********Other employer pensions

*E3394 - no one else had another employer with pension


egen dc_wd_totalG = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalG
save "$folder\wave15\dcwtdr1_3.dta",replace


*DORMANT pensions mentioned earlier 
use "$rawfolder/hrs1996/H96J_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

forvalues i=1/2{
gen withdrawn_`i'=0
replace withdrawn_`i'=1 if E4329_`i'==3
}

*all asked together(withdrawn, annuity, balance) - ignore tohers
replace E4330_1 =. if withdrawn_1!=1
replace E4330_2 =. if withdrawn_2!=1

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if E4330_1 <9999998 // donor group 
replace mmiss=1 if E4330_1 >9999997 & E4330_1<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=E4330_1
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=3
imputethis
drop yr

gen aleft=exactvalue

drop exactvalue lowervalue uppervalue 


gen plan_dc_wd=0
replace plan_dc_wd=aleft if withdrawn_1==1
replace plan_dc_wd=plan_dc_wd+E4330_2 if withdrawn_2==1


*interview four years ago
gen lastmonth=AIWMONTH
gen lastyear=AIWYEAR 


gen months_since=EIWYEAR*12+EIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth`i' if lastyear==EIWYEAR-1

gen dc_wd_totalJ = plan_dc_wd
replace dc_wd_totalJ=dc_wd_totalJ*monthsinlcy/months_since
replace dc_wd_totalJ=0 if dc_wd_totalJ==.


save "$folder\wave15\dcwtdr2_3.dta",replace



use "$folder\wave15\dcwtdr1_3.dta",clear
merge 1:1 hhidpn using "$folder\wave15\dcwtdr2_3.dta",nogen
egen r3dcw_ = rowtotal(dc_wd_total?)
drop dc_wd*
keep hhidpn r3*
save "$folder\wave15\dcwtdr_3.dta",replace