
do "$do/imputethis.do"
use "$rawfolder/hrs1998/H98G_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

****************************
* 1. PREV wave employer:
*******************************

*if withdrew - means they withdrew all the money in the account when they left

*DC type or "both" type are asked separate sets of questions

*type "both"

* 0 : no w/d 1: withdrawal only 
gen withdrawn=0
replace withdrawn=1 if F3205==1



*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if F3204 <99999998 // donor group 
replace mmiss=1 if F3204 >99999997 & F3204<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=F3204 
gen double lowervalue=0
gen double uppervalue=99999996


gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=4
imputethis
drop yr


gen aleft=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd=0
replace plan_dc_wd=aleft if withdrawn==1



*type "DC"

gen withdrawn2=0
replace withdrawn2=1 if F3237==1



* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if F3236<99999998 // donor group 
replace mmiss=1 if F3236>99999997 & F3236<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=F3236
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=4
imputethis
drop yr

gen a2left=exactvalue

drop exactvalue lowervalue uppervalue 

replace plan_dc_wd=a2left if withdrawn2==1



*last year worked
gen lastyear=F3189 if F3189<9998
gen lastmonth=F3188 if lastyear!=. & F3188<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=FIWYEAR*12+FIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<FIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==FIWYEAR-1

gen dc_wd_total1 = plan_dc_wd
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since
replace dc_wd_total1=0 if dc_wd_total1==.

drop months_since monthsinlcy lastyear lastmonth plan_dc_wd*


****************************
*between previous wave job and current job - LAST JOB
*******************************

*"both" type

gen withdrawn3=0
replace withdrawn3=1 if F3676 ==1

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if F3675 <99999998 // donor group 
replace mmiss=1 if F3675>99999997 & F3675<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=F3675
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=4
imputethis
drop yr

gen a3left=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd3=0
replace plan_dc_wd3=a3left if withdrawn3==1



*"DC" type

gen withdrawn4=0
replace withdrawn4=1 if F3702 ==1


* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if F3701<99999998 // donor group 
replace mmiss=1 if F3701>99999997 & F3701<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=F3701
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=4
imputethis
drop yr

gen a4left=exactvalue

drop exactvalue lowervalue uppervalue 

replace plan_dc_wd3=a4left if withdrawn4==1




*last year worked
gen lastyear=F3644  if F3644 <9998
replace lastyear=FIWYEAR-F3645 if F3645<98 & lastyear==.
gen lastmonth=F3647 if lastyear!=. & F3647<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=FIWYEAR*12+FIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<FIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==FIWYEAR-1

gen dc_wd_total2 = plan_dc_wd3
replace dc_wd_total2=dc_wd_total2*monthsinlcy/months_since
replace dc_wd_total2=0 if dc_wd_total2==.

drop months_since monthsinlcy lastyear lastmonth plan_dc_wd3


drop withdrawn* 
****************************
*Job history: other 5+ year job
*******************************

*"both" type 

gen withdrawn=0
replace withdrawn=1 if F3857 ==1

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if F3856  <99999998 // donor group 
replace mmiss=1 if F3856 >99999997 & F3856 <1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=F3856 
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=4
imputethis
drop yr

gen a5left=exactvalue

drop exactvalue lowervalue uppervalue 

gen plan_dc_wd=0
replace plan_dc_wd=a5left if withdrawn==1


*DC type - 1 

gen withdrawn2=0
replace withdrawn2=1 if F3884 ==5

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if F3883  <99999998 // donor group 
replace mmiss=1 if F3883 >99999997 & F3883 <1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=F3883
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=4
imputethis
drop yr

gen a6left=exactvalue

drop exactvalue lowervalue uppervalue 

replace plan_dc_wd=a6left if withdrawn2==1

*last year worked
gen lastyear=F3842  if F3842 <9998
replace lastyear=FIWYEAR-F3843 if F3843<98 & lastyear==.
replace lastyear=BIRTHYR+F3844 if F3844<98 & lastyear==.
gen lastmonth=6 if lastyear!=.

gen months_since=FIWYEAR*12+FIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<FIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==FIWYEAR-1
replace monthsinlcy=0 if lastyear==FIWYEAR

gen dc_wd_total3 = plan_dc_wd
replace dc_wd_total3=dc_wd_total3*monthsinlcy/months_since
replace dc_wd_total3=0 if dc_wd_total3==.

drop months_since monthsinlcy lastyear lastmonth plan_dc_wd

*********Other employer pensions

*both types - no withdrawals in past two years
tab F3904_1 if F3910_1==1
tab F3904_2 if F3910_2==1

*DC type - one account with withdrawals in past two years
tab F3904_1 if F3937_1==5

*nothing from second account
tab F3904_2 if F3936_2!=. & F3937_2==5

gen plan_dc_wd2=0
replace plan_dc_wd2=F3936_1 if F3937_1==5 & F3904_1==1997

gen months_since=FIWYEAR*12+FIWMONTH-(1997*12+6) 
gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-6 if FIWYEAR-1==1997

gen dc_wd_total4 = plan_dc_wd2
replace dc_wd_total4=dc_wd_total4*monthsinlcy/months_since
replace dc_wd_total4=0 if dc_wd_total4==.


egen dc_wd_totalG = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalG
save "$folder\wave15\dcwtdr1_4.dta",replace


*DORMANT pensions mentioned earlier 
use "$rawfolder/hrs1998/H98J_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

forvalues i=1/2{
gen withdrawn_`i'=0
replace withdrawn_`i'=1 if F5089_`i'==3
}

*all asked together(withdrawn, annuity, balance) - ignore tohers
replace F5090_1 =. if withdrawn_1!=1

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if F5090_1  <99999998 // donor group 
replace mmiss=1 if F5090_1 >99999997 & F5090_1<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=F5090_1
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=4
imputethis
drop yr

gen aleft=exactvalue

drop exactvalue lowervalue uppervalue 


gen plan_dc_wd=0
replace plan_dc_wd=aleft if withdrawn_1==1
replace plan_dc_wd=plan_dc_wd+F5090_1 if withdrawn_2==1


*date of last interview
*find date of last interview
*interview four years ago
gen lastmonth=CIWMONTH
gen lastyear=CIWYEAR 


gen months_since=FIWYEAR*12+FIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth`i' if lastyear==FIWYEAR-1

gen dc_wd_totalJ = plan_dc_wd
replace dc_wd_totalJ=dc_wd_totalJ*monthsinlcy/months_since
replace dc_wd_totalJ=0 if dc_wd_totalJ==.


save "$folder\wave15\dcwtdr2_4.dta",replace



use "$folder\wave15\dcwtdr1_4.dta",clear
merge 1:1 hhidpn using "$folder\wave15\dcwtdr2_4.dta",nogen
egen r4dcw_ = rowtotal(dc_wd_total?)
drop dc_wd*
keep hhidpn r4*
save "$folder\wave15\dcwtdr_4.dta",replace