
do "$do/imputethis.do"
use "$rawfolder/hrs2000/H00G_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH)

****************************
* 1. PREV wave employer:
*******************************

*if withdrew - means they withdrew all the money in the account when they left

/*
G3437 G26.STOP WORK PREV WAVE EMPLYR-MO
G3438 G26A.STOP WORK PREV WAVE EMPLYR-YR
*/

forvalues i=1/4{
	gen type_dc`i'=1 if G3455_`i'==2
	replace type_dc`i'=2 if G3455_`i'==3
}

*DC type or "both" type are asked separate sets of questions

*type "both"

* 0 : no w/d 1: withdrawal only 
forvalues i=1/4{
gen withdrawn_`i'=0
replace withdrawn_`i'=1 if G3457_`i'==1
}


*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)

forvalues val=1/2{

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if G3456_`val'<99999998 // donor group 
replace mmiss=1 if G3456_`val'>99999997 & G3456_`val'<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=G3456_`val'
gen double lowervalue=0
gen double uppervalue=99999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=5
imputethis
drop yr

gen aleft`val'=exactvalue

drop exactvalue lowervalue uppervalue 


}



forvalues val=1/4{
gen plan_dc_wd_`val'=0	
if `val'<=2{
replace plan_dc_wd_`val'=aleft`val' if withdrawn_`val'==1
}
}



*type "DC"
* 0 : no w/d 1: withdrawal only 
forvalues i=1/4{
gen withdrawn2_`i'=0
replace withdrawn2_`i'=1 if G3487_`i'==1
}

*no positive reported for account 4
forvalues val=1/3{

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if G3482_`val'<99999998 // donor group 
replace mmiss=1 if G3482_`val'>99999997 & G3482_`val'<1999999999 // missing variable code

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=G3482_`val'
gen double lowervalue=0
gen double uppervalue=99999996

*20,000
*if equal
replace exactvalue=20000 if G3483_`val'==3
replace mmiss=0 if  G3483_`val'==3
*if less than 20k
replace uppervalue=20000 if G3483_`val'==1
*if more than 20k
replace lowervalue=20000 if G3483_`val'==5

*if about equal to 5k
replace exactvalue=5000 if G3484_`val'==3
replace mmiss=0 if  G3484_`val'==3
*if less than 5k
replace uppervalue=5000 if G3484_`val'==1
*if more than 5k
replace lowervalue=5000 if G3484_`val'==5


*if about equal to 150k
replace exactvalue=150000 if G3485_`val'==3
replace mmiss=0 if  G3485_`val'==3
*if less than 5k
replace uppervalue=150000 if G3485_`val'==1
*if more than 5k
replace lowervalue=150000 if G3485_`val'==5


gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=5
imputethis
drop yr

gen a2left`val'=exactvalue

drop exactvalue lowervalue uppervalue 


}


forvalues val=1/3{
replace plan_dc_wd_`val'=a2left`val' if withdrawn2_`val'==1

}




*last year worked
gen lastyear=G3438 if G3438<9998
gen lastmonth=G3437 if lastyear!=. & G3437<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=GIWYEAR*12+GIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<GIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==GIWYEAR-1

egen dc_wd_total1 = rowtotal(plan_dc_wd_?)
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since
replace dc_wd_total1=0 if dc_wd_total1==.

drop months_since monthsinlcy lastyear lastmonth plan_dc_wd_*


****************************
*between previous wave job and current job - LAST JOB
*******************************

*"both" type
*no withdrawals

*"DC" type
forvalues i=1/3{
gen withdrawn3_`i'=0
replace withdrawn3_`i'=1 if G4022_`i'==1
}
*2 accounts
*no imputation needed for amount when left
forvalues val=1/3{
gen plan_dc_wd2_`val'=0
replace plan_dc_wd2_`val'=G4021_`val' if withdrawn3_`val'==1
}

*last year worked
gen lastyear=G3954 if G3954<9998
replace lastyear=GIWYEAR-G3955 if G3955<98 & lastyear==.
gen lastmonth=G3957 if lastyear!=. & G3957<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=GIWYEAR*12+GIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<GIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==GIWYEAR-1

egen dc_wd_total2 = rowtotal(plan_dc_wd2_?)
replace dc_wd_total2=dc_wd_total2*monthsinlcy/months_since
replace dc_wd_total2=0 if dc_wd_total2==.

drop months_since monthsinlcy lastyear lastmonth plan_dc_wd2_*



****************************
*Job history: other 5+ year job
*******************************

*"both" type - no withdrawals

*DC type - 1 
*1 withdrawal - from an account in 1975 - ignore
 tab G4104 if  G4157_1 ==5
 
 *other pension job #1 and #2
 *no both type
forvalues i=1/2{
gen withdrawn4_`i'=0
replace withdrawn4_`i'=1 if G4214_`i'==5
}

*none in last two years - ignore
tab G4177_1 if withdrawn4_1==1
tab G4177_2 if withdrawn4_2==1

egen dc_wd_totalG = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalG
save "$folder\wave15\dcwtdr1_5.dta",replace


*DORMANT pensions mentioned earlier - In Wave 5, questions in the old pension sequence were not asked. 


egen r5dcw_ = rowtotal(dc_wd_total?)
drop dc_wd*
keep hhidpn r5*
save "$folder\wave15\dcwtdr_5.dta",replace
