

do "$do/imputethis.do"
use "$rawfolder/hrs2004/H04J_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH)

****************************
* 1. PREV wave employer:
*******************************


* 0 : no w/d 1: withdrawal only 2: withdrawal + other option
foreach val in a b c d{

gen withdrawn_`val'=0
forvalues i=1/3{
	replace withdrawn_`val'=1 if JJW006`val'`i'==1
}

forvalues i=1/3{
	replace withdrawn_`val'=2 if !inlist(JJW006`val'`i',1,.,8,9) & withdrawn_`val'==1
}



}



*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)
foreach val in a b c d{

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if JJW002`val'<9999998 // donor group 
replace mmiss=1 if JJW002`val'>9999997 & JJW002`val'<1999999999 // missing variable code

replace JJW003`val'=0 if mmiss==1 & JJW003`val'==.
replace JJW004`val'=99999996 if mmiss==1 & JJW004`val'==.

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=JJW002`val'
replace exactvalue=99999998 if mmiss==1
gen double lowervalue=JJW003`val'
gen double uppervalue=JJW004`val'

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=7
imputethis
drop yr

gen aleft`val'=exactvalue

drop exactvalue lowervalue uppervalue 


}


*amount withdrawn (lump-sum/ cash)

foreach val in a b{
	
* Impute for the missing
* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if JJW056`val'<999998 // donor group 
replace mmiss=1 if JJW056`val'>999997 & JJW056`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=JJW056`val'
gen double lowervalue=0
gen double uppervalue=600000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=7
imputethis
drop yr

gen plan_dc_wd_`val'=exactvalue 
drop exactvalue lowervalue uppervalue 

	
}
gen plan_dc_wd_c=0
gen plan_dc_wd_d=0 


foreach val in a b c d{
replace plan_dc_wd_`val'=aleft`val' if withdrawn_`val'==1
replace plan_dc_wd_`val'=0 if JJW057`val'==5
}



*last year worked
gen lastyear=JJ064 if JJ064<9998
gen lastmonth=JJ063 if lastyear!=. & JJ063<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=JIWYEAR*12+JIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<JIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==JIWYEAR-1

egen dc_wd_total1 = rowtotal(plan_dc_wd_?)
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since
replace dc_wd_total1=0 if dc_wd_total1==.

drop months_since monthsinlcy lastyear lastmonth


****************************
*dormant pensions from previous interviews
*******************************

*date of last interview
*find date of last interview
gen lastmonth=.
gen lastyear=.

foreach j in `c(ALPHA)' {
  if "`j'"<="H" & "`j'"!="I" {
    replace lastmonth=`j'IWMONTH if `j'IWMONTH!=.
	replace lastyear=`j'IWYEAR if `j'IWYEAR!=.
  }
}



*amount withdrawn (past pension - type B)
local j=1
foreach val in a b c{
	
	
gen mmiss=.
replace mmiss=0 if JJ453`val'<999998 // donor group 
replace mmiss=1 if JJ453`val'>999997 & JJ453`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=JJ453`val'
gen double lowervalue=0
gen double uppervalue=800000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=7
imputethis
drop yr

gen plan_dc_wd_`j'=exactvalue 
replace plan_dc_wd_`j'=0 if JJ667`val'==5

gen yearwd_`val'=JJ452`val' if JJ452`val'<9998

drop exactvalue lowervalue uppervalue 
local j=`j'+1
	
}


*year of withdrawal is known in this section. However, to be consistent with other years, we wiJL also use date of last interview here.

*months since last interview
local j=1
foreach i in a b c{
gen months_since=JIWYEAR*12+JIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  yearwd_`i'<JIWYEAR-2 & JIWYEAR!=.
replace months_since=. if  lastyear<JIWYEAR-2 
replace months_since=24 if lastyear<JIWYEAR-2 & yearwd_`i'!=. & yearwd_`i'>=JIWYEAR-2

gen lastmonth`i'=lastmonth
replace lastmonth`i'=6 if lastyear<JIWYEAR-2 & yearwd_`i'!=. & yearwd_`i'>=JIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth`i' if lastyear==JIWYEAR-1

replace plan_dc_wd_`j'=plan_dc_wd_`j'*monthsinlcy/months_since

drop months_since monthsinlcy lastmonth`i'
local j=`j'+1
}


egen dc_wd_total2=rowtotal(plan_dc_wd_1 plan_dc_wd_2 plan_dc_wd_3)


egen dc_wd_totalJ = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalJ
save "$folder\wave15\dcwtdr1_7.dta",replace



********************************************************************************
*                               Last Job
********************************************************************************


*only asked to those currently not working (and first interview)
use "${rawfolder}\hrs2004\H04K_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

keep if JK031==1
keep if JK032!=0
count

* 0 : no w/d 1: withdrawal only 2: withdrawal + other option
foreach val in a b c {

gen withdrawn_`val'=0
forvalues i=1/3{
	replace withdrawn_`val'=1 if JKW006`val'`i'==1
}

forvalues i=1/3{
	replace withdrawn_`val'=2 if !inlist(JKW006`val'`i',1,.,8,9) & withdrawn_`val'==1
}

}

*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)
foreach val in a b {

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if JKW002`val'<999998 // donor group 
replace mmiss=1 if JKW002`val'>999997 & JKW002`val'<1999999999 // missing variable code

replace JKW003`val'=0 if mmiss==1 & JKW003`val'==.
replace JKW004`val'=99999996 if mmiss==1 & JKW004`val'==.

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=JKW002`val'
replace exactvalue=99999998 if mmiss==1
gen double lowervalue=JKW003`val'
gen double uppervalue=JKW004`val'

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=7
imputethis
drop yr

gen aleft`val'=exactvalue

drop exactvalue lowervalue uppervalue 


}


gen aleftc=0
replace aleftc=JKW002c if JKW002c!=.



*withdrawal 
* DC plan from last job (just two plans reported in 2004)
gen plan_dc_wd_a=0
replace plan_dc_wd_a=5700 if JKW056a!=.


replace plan_dc_wd_a=alefta if withdrawn_a==1
replace plan_dc_wd_a=0 if JKW057a==5

foreach val in b c {
	gen plan_dc_wd_`val'=0 
	replace plan_dc_wd_`val'=aleft`val' if withdrawn_`val'==1 
	replace plan_dc_wd_`val'=0 if JKW057`val'==5
}

*last year worked
gen lastyear=JK004 if JK004<9998
replace lastyear=JIWYEAR-JK005 if inlist(JK004,9998,9999) & JK005<=97
gen lastmonth=JK006 if lastyear!=. & JK006<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=JIWYEAR*12+JIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<JIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth`i' if lastyear==JIWYEAR-1


egen dc_wd_totalK=rowtotal(plan_dc_*)
replace dc_wd_totalK = dc_wd_totalK*monthsinlcy/months_since
replace dc_wd_totalK=0 if dc_wd_totalK==.


keep hhidpn dc_wd_totalK*

save "$folder\wave15\dcwtdr2_7.dta",replace


********************************************************************************
*                               Job History
********************************************************************************

*Only asked if first interview!
use "${rawfolder}\hrs2004\H04L_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH BIRTHYR)

keep if (JL027==1 & JL028!=0) | JL031==1 
count

* 0 : no w/d 1: withdrawal only 2: withdrawal + other option
foreach val in a b c d e f {

gen withdrawn_`val'=0
forvalues i=1/3{
	replace withdrawn_`val'=1 if JLW006`val'`i'==1
}

forvalues i=1/3{
	replace withdrawn_`val'=2 if !inlist(JLW006`val'`i',1,.,8,9) & withdrawn_`val'==1
}

}

*find amount in account when R left the job - those with w/d==1 will w/d all of this amount (only asked to DC/both type)
foreach val in a b  c e f{

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if JLW002`val'<999998 // donor group 
replace mmiss=1 if JLW002`val'>999997 & JLW002`val'<1999999999 // missing variable code

replace JLW003`val'=0 if mmiss==1 & JLW003`val'==.
replace JLW004`val'=99999996 if mmiss==1 & JLW004`val'==.

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=JLW002`val'
replace exactvalue=99999998 if mmiss==1
gen double lowervalue=JLW003`val'
gen double uppervalue=JLW004`val'

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=7
imputethis
drop yr
gen aleft`val'=exactvalue

drop exactvalue lowervalue uppervalue 


}
*no missing
gen aleftd=0
replace aleftd=JLW002d if JLW002d!=.



*withdrawal 
* DC plan from last job (just two plans reported in 2004)
*need imputation for plan a only


* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if JLW056a<99998 // donor group 
replace mmiss=1 if JLW056a>99997 & JLW056a<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=JLW056a
gen double lowervalue=0
gen double uppervalue=60000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=7
imputethis
drop yr

gen plan_dc_wd_a=exactvalue 
drop exactvalue lowervalue uppervalue 

*plan e has one postive reported	
gen plan_dc_wd_e=0
replace plan_dc_wd_e=5000 if JLW056e!=.

foreach val in a e{
replace plan_dc_wd_`val'=aleft`val' if withdrawn_`val'==1
replace plan_dc_wd_`val'=0 if JLW057`val'==5
}

foreach val in b c d f {
	gen plan_dc_wd_`val'=0 
	replace plan_dc_wd_`val'=aleft`val' if withdrawn_`val'==1 
	replace plan_dc_wd_`val'=0 if JLW057`val'==5
}

*year last worked for job #1
gen lastyear=JL016 if JL016<9998
replace lastyear=JIWYEAR-JL017 if inlist(JL016,9998,9999) & JL017<=97
replace lastyear=BIRTHYR+ JL018 if JL018<=97
gen lastmonth=6 if lastyear!=. 

gen months_since=JIWYEAR*12+JIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<JIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth`i' if lastyear==JIWYEAR-1

egen dc_wd_totalL1=rowtotal(plan_dc_wd_a plan_dc_wd_b plan_dc_wd_c plan_dc_wd_d)
replace dc_wd_totalL1 = dc_wd_totalL1*monthsinlcy/months_since
replace dc_wd_totalL1=0 if dc_wd_totalL1==.



*tab JL035a if plan_dc_wd_e>0
*tab JL035b if plan_dc_wd_f>0
*none in last two years

gen dc_wd_totalL= dc_wd_totalL1
keep hhidpn dc_wd_totalL

save "$folder\wave15\dcwtdr3_7.dta",replace

use "$folder\wave15\dcwtdr1_7.dta",clear
merge 1:1 hhidpn using "$folder\wave15\dcwtdr2_7.dta",nogen
merge 1:1 hhidpn using "$folder\wave15\dcwtdr3_7.dta",nogen
egen r7dcw_ = rowtotal(dc_wd_total?)
drop dc_wd*
keep r7* hhidpn
save "$folder\wave15\dcwtdr_7.dta",replace
