


do "$do/imputethis.do"
use "$rawfolder/hrs2008/H08J_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH)

****************************
* 1. PREV wave employer:
*******************************


*amount withdrawn (lump-sum/ cash)

foreach val in A B C D{
	
	
*DC balances
*1 based on plan name
gen dc`val'=0
replace dc`val'=1 if inlist(LJW001`val',2,3)
replace dc`val'=1 if inlist(LJW001`val',8,9) & !inlist(LJW082`val',3,97,98,99,.)
gen  LJW056`val'_org= LJW056`val'
* elimate the DB accounts  from this imputation
replace LJW056`val'=. if dc`val'==0
* Impute for the missing
* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if LJW056`val'<99999998 // donor group 
replace mmiss=1 if LJW056`val'>99999997 & LJW056`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=LJW056`val'
gen double lowervalue=0
gen double uppervalue=600000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=9
imputethis
drop yr

gen plan_dc_wd_`val'=exactvalue 
replace plan_dc_wd_`val'=0 if LJW057`val'==5

drop exactvalue lowervalue uppervalue 

	
}

*last year worked
gen lastyear=LJ064 if LJ064<9998
gen lastmonth=LJ063 if lastyear!=. & LJ063<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=LIWYEAR*12+LIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<LIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==LIWYEAR-1

egen dc_wd_total1 = rowtotal(plan_dc_wd_?)
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since

drop months_since monthsinlcy lastyear lastmonth


*irregular withdrawals (prev. wave job)
foreach val in A B C D{
	
	
*DC balances
* elimate the DB accounts  from this imputation
replace LJW063`val'=. if dc`val'==0
* Impute for the missing
* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if LJW063`val'<9999999998 // donor group 
replace mmiss=1 if LJW063`val'>9999999997 & LJW063`val'<19999999998 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=LJW063`val'
gen double lowervalue=0
gen double uppervalue=250000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=9
imputethis
drop yr


gen plan_dc_wdi_`val'=exactvalue 


drop exactvalue lowervalue uppervalue 

	
}

egen dc_wd_total2=rowtotal(plan_dc_wdi_?)


****************************
*dormant pensions from previous interviews
*******************************

*date of last interview
*find date of last interview
gen lastmonth=.
gen lastyear=.

foreach j in `c(ALPHA)' {
  if "`j'"<="K" & "`j'"!="I" {
    replace lastmonth=`j'IWMONTH if `j'IWMONTH!=.
	replace lastyear=`j'IWYEAR if `j'IWYEAR!=.
  }
}



*amount withdrawn (past pension - type B)
forvalues val=1/2{
	
	
gen mmiss=.
replace mmiss=0 if LJ453_`val'<99999998 // donor group 
replace mmiss=1 if LJ453_`val'>99999997 & LJ453_`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=LJ453_`val'
gen double lowervalue=LJ454_`val'
replace lowervalue=0 if mmiss==1 & lowervalue==.
gen double uppervalue=LJ455_`val'
replace uppervalue=999996 if mmiss==1 & uppervalue==.

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=9
imputethis
drop yr


gen plan_dc_wd_`val'=exactvalue 
replace plan_dc_wd_`val'=0 if LJ667_`val'==5

gen yearwd_`val'=LJ452_`val' if LJ452_`val'<9998

drop exactvalue lowervalue uppervalue 

	
}

gen plan_dc_wd_3=LJ453_3 
replace plan_dc_wd_3=0 if LJ453_3==.
gen yearwd_3= LJ452_3 


*year of withdrawal is known in this section. However, to be consistent with other years, we will also use date of last interview here.

*months since last interview
forvalues i=1/3{
gen months_since=LIWYEAR*12+LIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  yearwd_`i'<LIWYEAR-2 & LIWYEAR!=.
replace months_since=. if  lastyear<LIWYEAR-2 
replace months_since=24 if lastyear<LIWYEAR-2 & yearwd_`i'!=. & yearwd_`i'>=LIWYEAR-2

gen lastmonth`i'=lastmonth
replace lastmonth`i'=6 if lastyear<LIWYEAR-2 & yearwd_`i'!=. & yearwd_`i'>=LIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth`i' if lastyear==LIWYEAR-1

replace plan_dc_wd_`i'=plan_dc_wd_`i'*monthsinlcy/months_since

drop months_since monthsinlcy
}


egen dc_wd_total3=rowtotal(plan_dc_wd_1 plan_dc_wd_2 plan_dc_wd_3)



*irregular withdrawals in the LCY
forvalues val=1/2{
	
	
gen mmiss=.
replace mmiss=0 if LJ838_`val'<9999999998 // donor group 
replace mmiss=1 if LJ838_`val'>9999999997 & LJ838_`val'<19999999998 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=LJ838_`val'
gen double lowervalue=LJ891_`val'
replace lowervalue=0 if mmiss==1 & lowervalue==.
gen double uppervalue=LJ892_`val'
replace uppervalue=9999996 if mmiss==1 & uppervalue==.

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=9
imputethis
drop yr


gen plan_dc_wdi_`val'=exactvalue 


drop exactvalue lowervalue uppervalue 

	
}

egen dc_wd_total4=rowtotal(plan_dc_wdi_1 plan_dc_wdi_2 )


egen dc_wd_totalJ = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalJ
save "$folder\wave15\dcwtdr1_9.dta",replace



********************************************************************************
*                               Last Job
********************************************************************************


*only asked to those currently not working (and first interview)
use "${rawfolder}\hrs2008\H08K_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH)

keep if LK031==1
keep if LK032!=0
count

*cash/lumpsum
* DC plan from last job (just one plan reported in 2008)
gen plan_dc_1 = inlist(LKW001a,2,3)
replace plan_dc_1=1 if inlist(LKW001a,8,9) & !inlist(LKW082a,3,97,98,99,.)
gen plan_dc_wd_1=0
replace plan_dc_wd_1=LKW056a if LKW056a!=.
replace plan_dc_wd_1=0 if plan_dc_1==0

*last year worked
gen lastyear=LK004 if LK004<9998
replace lastyear=LIWYEAR-LK005 if inlist(LK004,9998,9999) & LK005<=12
gen lastmonth=LK006 if lastyear!=. & LK006<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=LIWYEAR*12+LIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<LIWYEAR-2
*left job in 2003


gen dc_wd_totalK1 = 0


*irregular payments 

*no one did this in 2008

gen dc_wd_totalK=0


keep hhidpn dc_wd_totalK*

save "$folder\wave15\dcwtdr2_9.dta",replace


********************************************************************************
*                               Job History
********************************************************************************

*Only asked if first interview!
use "${rawfolder}\hrs2008\H08L_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH)

keep if (LL027==1 & LL028!=0) | LL031==1 
count


*  only one person reports non-missing postive withdrawal amount. assign this to missing ones if dc
gen plan_dc_A = inlist(LLW001A,2,3)
replace plan_dc_A=1 if inlist(LLW001A,8,9) & !inlist(LLW082A,3,97,98,99,.)

replace LLW056A=. if plan_dc_A==0
gen plan_dc_wd_A=0
replace plan_dc_wd_A=12000 if LLW056A!=.
replace plan_dc_wd_A=0 if LLW057A==5


*last year worked job #1
gen lastyear=LL016 if LL016<9998
replace lastyear=LIWYEAR-LL017 if inlist(LL016,9998,9999)
gen lastmonth=6 if lastyear!=.
gen months_since=LIWYEAR*12+LIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<LIWYEAR-2
gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==LIWYEAR-1

gen dc_wd_totalL1 = plan_dc_wd_A
replace dc_wd_totalL1=dc_wd_totalL1*monthsinlcy/months_since

drop  lastyear lastmonth months_since monthsinlcy





gen dc_wd_totalL = dc_wd_totalL1


keep hhidpn dc_wd_totalL*
save "$folder\wave15\dcwtdr3_9.dta",replace

use "$folder\wave15\dcwtdr1_9.dta",clear
merge 1:1 hhidpn using "$folder\wave15\dcwtdr2_9.dta",nogen
merge 1:1 hhidpn using "$folder\wave15\dcwtdr3_9.dta",nogen
egen r9dcw_ = rowtotal(dc_wd_total?),m
keep hhidpn r9*
save "$folder\wave15\dcwtdr_9.dta",replace



