


do "$do/imputethis.do"
use "$rawfolder/hrs2010/H10J_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH)

****************************
* 1. PREV wave employer:
*******************************


*amount withdrawn (lump-sum/ cash)

foreach val in A B C D{
	
	
*DC balances
*1 based on plan name
gen dc`val'=0
replace dc`val'=1 if inlist(MJW001`val',2,3)
replace dc`val'=1 if inlist(MJW001`val',8,9) & !inlist(MJW082`val',3,97,98,99,.)
gen  MJW056`val'_org= MJW056`val'
* elimate the DB accounts  from this imputation
replace MJW056`val'=. if dc`val'==0
* Impute for the missing
* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if MJW056`val'<99999998 // donor group 
replace mmiss=1 if MJW056`val'>99999997 & MJW056`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=MJW056`val'
gen double lowervalue=0
gen double uppervalue=250000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=10
imputethis
drop yr

gen plan_dc_wd_`val'=exactvalue 
replace plan_dc_wd_`val'=0 if MJW057`val'==5

drop exactvalue lowervalue uppervalue 

	
}

*last year worked
gen lastyear=MJ064 if MJ064<9998
gen lastmonth=MJ063 if lastyear!=. & MJ063<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=MIWYEAR*12+MIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<MIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==MIWYEAR-1

egen dc_wd_total1 = rowtotal(plan_dc_wd_?)
replace dc_wd_total1=dc_wd_total1*monthsinlcy/months_since

drop months_since monthsinlcy lastyear lastmonth


*irregular withdrawals (prev. wave job)
foreach val in A B C D{
	
	
*DC balances
* elimate the DB accounts  from this imputation
replace MJW063`val'=. if dc`val'==0
* Impute for the missing
* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if MJW063`val'<99999998 // donor group 
replace mmiss=1 if MJW063`val'>99999997 & MJW063`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=MJW063`val'
gen double lowervalue=0
gen double uppervalue=250000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=10
imputethis
drop yr

gen plan_dc_wdi_`val'=exactvalue 
drop exactvalue lowervalue uppervalue 

	
}

egen dc_wd_total2=rowtotal(plan_dc_wdi_?)


****************************
*dormant pensions from previous interviews
*******************************

*lump-sum/cash-in
foreach val in E F G H{
	
	
*DC balances
*1 based on plan name
gen dc`val'=0
replace dc`val'=1 if !inlist(MJW082`val',3,97,98,99,.)

gen  MJW056`val'_org= MJW056`val'
* elimate the DB accounts  from this imputation
replace MJW056`val'=. if dc`val'==0

*impute missing
gen mmiss=.
replace mmiss=0 if MJW056`val'<99999998 // donor group 
replace mmiss=1 if MJW056`val'>99999997 & MJW056`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=MJW056`val'
gen double lowervalue=0
gen double uppervalue=600000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=10
imputethis
drop yr

gen plan_dc_wd_`val'=exactvalue 
replace plan_dc_wd_`val'=0 if MJW057`val'==5

drop exactvalue lowervalue uppervalue 
	
}

*find date of last interview
gen lastmonth=.
gen lastyear=.

foreach j in `c(ALPHA)' {
  if "`j'"<="L" & "`j'"!="I" {
    replace lastmonth=`j'IWMONTH if `j'IWMONTH!=.
	replace lastyear=`j'IWYEAR if `j'IWYEAR!=.
  }
}

*months since last interview
gen months_since=MIWYEAR*12+MIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<MIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==MIWYEAR-1

egen dc_wd_total3=rowtotal(plan_dc_wd_E plan_dc_wd_F plan_dc_wd_G plan_dc_wd_H)
replace dc_wd_total3=dc_wd_total3*monthsinlcy/months_since


*irregular withdrawals in the LCY
foreach val in E F G H{
	
	
*DC balances
* elimate the DB accounts  from this imputation
replace MJW063`val'=. if dc`val'==0
* Impute for the missing
* Code missings (input for imputation code)
gen mmiss=.
replace mmiss=0 if MJW063`val'<99999998 // donor group 
replace mmiss=1 if MJW063`val'>99999997 & MJW063`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=MJW063`val'
gen double lowervalue=0
gen double uppervalue=250000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=10
imputethis
drop yr

gen plan_dc_wdi_`val'=exactvalue 
replace plan_dc_wdi_`val'=0 if MJW057`val'==5

drop exactvalue lowervalue uppervalue 

	
}

egen dc_wd_total4=rowtotal(plan_dc_wdi_E plan_dc_wdi_F plan_dc_wdi_G plan_dc_wdi_H)


egen dc_wd_totalJ = rowtotal(dc_wd_total*)
keep hhidpn dc_wd_totalJ
save "$folder\wave15\dcwtdr1_10.dta",replace



********************************************************************************
*                               Last Job
********************************************************************************


*only asked to those currently not working (and first interview)
use "${rawfolder}\hrs2010\H10K_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH)

keep if MK031==1
keep if MK032!=0
count

*cash/lumpsum
* DC plan from last job (up t0 4 plans - no one has 4 in 2010)
local i = 1
foreach val in A B C{
gen plan_dc_`i' = inlist(MKW001`val',2,3)
replace plan_dc_`i'=1 if inlist(MKW001`val',8,9) & !inlist(MKW082`val',3,97,98,99,.)

replace MKW056`val'=. if plan_dc_`i'==0

*impute missing
gen mmiss=.
replace mmiss=0 if MKW056`val'<99999998 // donor group 
replace mmiss=1 if MKW056`val'>99999997 & MKW056`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=MKW056`val'
gen double lowervalue=0
gen double uppervalue=600000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=10
imputethis
drop yr

gen plan_dc_wd_`val'=exactvalue 
replace plan_dc_wd_`val'=0 if MKW057`val'==5

drop exactvalue lowervalue uppervalue 
 

local ++i

}
*last year worked
gen lastyear=MK004 if MK004<9998
replace lastyear=MIWYEAR-MK005 if inlist(MK004,9998,9999) & MK005<=12
gen lastmonth=MK006 if lastyear!=. & MK006<=12
replace lastmonth=6 if lastyear!=. & lastmonth==.

gen months_since=MIWYEAR*12+MIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<MIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==MIWYEAR-1


egen dc_wd_totalK1 = rowtotal(plan_dc_wd_?)
replace dc_wd_totalK1=dc_wd_totalK*monthsinlcy/months_since


*irregular payments (no values for C and D, and only missing for B)
local i = 1
foreach val in A{

replace MKW063`val'=. if plan_dc_`i'==0

*impute missing
gen mmiss=.
replace mmiss=0 if MKW063`val'<99999998 // donor group 
replace mmiss=1 if MKW063`val'>99999997 & MKW063`val'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=MKW063`val'
gen double lowervalue=0
gen double uppervalue=600000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=10
imputethis
drop yr

gen plan_dc_wdi_`val'=exactvalue 

drop exactvalue lowervalue uppervalue 
 

local ++i

}


egen dc_wd_totalK=rowtotal(plan_dc_wdi_A dc_wd_totalK1)


keep hhidpn dc_wd_totalK*

save "$folder\wave15\dcwtdr2_10.dta",replace


********************************************************************************
*                               Job History
********************************************************************************

*Only asked if first interview!
use "${rawfolder}\hrs2010\H10L_R.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH)

keep if (ML027==1 & ML028!=0) | ML031==1 
count


* up to 6 plans from employers in the last 5 years

replace MLW056A=99999998 if MLW056A>=9999998 & !missing(MLW056A)
replace MLW056C=99999998 if MLW056C>=9999998 & !missing(MLW056C)
replace MLW056E=99999998 if MLW056E>=9999998 & !missing(MLW056E)
replace MLW056F=99999998 if MLW056F>=9999998 & !missing(MLW056F)

local list="A B C D E F"

foreach i in `list' {
gen plan_dc_`i' = inlist(MLW001`i',2,3)
replace plan_dc_`i'=1 if inlist(MLW001`i',8,9) & !inlist(MLW082`i',3,97,98,99,.)

replace MLW056`i'=. if plan_dc_`i'==0


*impute missing
gen mmiss=.
replace mmiss=0 if MLW056`i'<999998 // donor group 
replace mmiss=1 if MLW056`i'>999997 & MLW056`i'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=MLW056`i'
gen double lowervalue=0
gen double uppervalue=600000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=10
imputethis
drop yr

gen plan_dc_wd_`i'=exactvalue 
replace plan_dc_wd_`i'=0 if MLW057`i'==5

drop exactvalue lowervalue uppervalue 


}

*last year worked job #1
gen lastyear=ML016 if ML016<9998
replace lastyear=MIWYEAR-ML017 if inlist(ML016,9998,9999)
gen lastmonth=6 if lastyear!=.
gen months_since=MIWYEAR*12+MIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<MIWYEAR-2
gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==MIWYEAR-1

egen dc_wd_totalL1 = rowtotal(plan_dc_wd_A plan_dc_wd_B plan_dc_wd_C plan_dc_wd_D)
replace dc_wd_totalL1=dc_wd_totalL1*monthsinlcy/months_since

drop  lastyear lastmonth months_since monthsinlcy

*last year worked job #2
gen lastyear=ML035A  if ML035A <9998
gen lastmonth=6 if lastyear!=.
gen months_since=MIWYEAR*12+MIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<MIWYEAR-2
gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==MIWYEAR-1

replace plan_dc_wd_E=plan_dc_wd_E*monthsinlcy/months_since

drop  lastyear lastmonth months_since monthsinlcy

*last year worked job #3
gen lastyear=ML035B  if ML035B <9998
gen lastmonth=6 if lastyear!=.
gen months_since=MIWYEAR*12+MIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=. if  lastyear<MIWYEAR-2
gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==MIWYEAR-1

replace plan_dc_wd_F=plan_dc_wd_F*monthsinlcy/months_since

drop  lastyear lastmonth months_since monthsinlcy

egen dc_wd_totalL2 = rowtotal(plan_dc_wd_E plan_dc_wd_F dc_wd_totalL1)


local list="A B C D E"

foreach i in `list' {

replace MLW063`i'=. if plan_dc_`i'==0


*impute missing
gen mmiss=.
replace mmiss=0 if MLW063`i'<999998 // donor group 
replace mmiss=1 if MLW063`i'>9999987 & MLW063`i'<1999999999 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue=MLW063`i'
gen double lowervalue=0
gen double uppervalue=600000

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=10
imputethis
drop yr

gen plan_dc_wdi_`i'=exactvalue 

drop exactvalue lowervalue uppervalue 


}



egen dc_wd_totalL = rowtotal(plan_dc_wdi_? dc_wd_totalL2)


keep hhidpn dc_wd_totalL*
save "$folder\wave15\dcwtdr3_10.dta",replace

use "$folder\wave15\dcwtdr1_10.dta",clear
merge 1:1 hhidpn using "$folder\wave15\dcwtdr2_10.dta",nogen
merge 1:1 hhidpn using "$folder\wave15\dcwtdr3_10.dta",nogen
egen r10dcw_ = rowtotal(dc_wd_total?),m
keep hhidpn r10*
save "$folder\wave15\dcwtdr_10.dta",replace



