*-----------------------------------*
*             DC withdrawals        *
*-----------------------------------*


do "$do/imputethis.do"


*2018 (wave 14)

use "${rawfolder}\hrs2018\H18J2_P.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

merge m:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH)
********************************************************************************
*	Focus on DC plans
********************************************************************************
* Assign plan_type: QJ2338. 1-DB; 2-DC; 3-Both. Why some missing? How to deal other or DK/RF (some have preload type)?
gen plan_dc = inlist(QJ2338,2,3)
* if missing, try to use detailed pension type
replace plan_dc = 1 if inlist(QJ2338,8,9,.,-8) & !inlist(QJ2W407,.,2,97,98,99,95,96,16,-8)
* if missing, try to use preload pension plan type: DC type
replace plan_dc = 1 if inlist(QJ2338,8,9,.,-8)  & inlist(QJ2W407,.,98,99,-8) & inlist(QJ2Z140,2,3)
replace plan_dc = 1 if inlist(QJ2W425,1,2)  & !inlist(QJ2W428,1,2) & !inlist(QJ2W426,1,2)
keep if plan_dc==1


*keep plans with status: Withdrew all money or withdrew some  money
keep if QJ2W436==1 | QJ2W437==1

*preloaded plans - "withdrew any amount since last interview date" - prorate to LCY
*newly added plans - "since you left that employer" -assume they w/d right away, if they left more than two years ago, make it zero - if in last two years, prorate to LCY
*what if it's from a current job? - assume it was drawn last 2 years?


*find date of last interview
gen lastmonth=.
gen lastyear=.

foreach j in `c(ALPHA)' {
  if "`j'"<="P" & "`j'"!="I" {
    replace lastmonth=`j'IWMONTH if `j'IWMONTH!=.
	replace lastyear=`j'IWYEAR if `j'IWYEAR!=.
  }
}

replace lastyear=. if QJ2JOBNDX==10
replace lastmonth=. if QJ2JOBNDX==10

gen oldjob_np= 1 if QJ2W452==5 & QJ2JOBNDX==10
replace lastyear=QJ2W411 if oldjob_np==1 & QJ2W411!=-8 
replace lastmonth=6 if oldjob_np==1 & QJ2W411!=-8 // assume they left their jobs mid-year

*use start date for currentjob
gen currentjob_np=1 if QJ2W452==1 & QJ2JOBNDX==10
replace lastyear=QJ2W410 if currentjob_np==1
replace lastmonth=6 if currentjob_np==1


*lastyear is missing for old jobs with missing end years - assume 0 withdrawn in the LCY


gen months_since=QIWYEAR*12+QIWMONTH-(lastyear*12+lastmonth) if lastyear!=.
replace months_since=24 if currentjob_np==1 & months_since>=24
replace months_since=. if currentjob_np==1 & lastyear>QIWYEAR-1
replace months_since=. if oldjob_np==1 & lastyear<QIWYEAR-2

gen monthsinlcy=12 if months_since!=.
replace monthsinlcy=12-lastmonth if lastyear==QIWYEAR-1


*withdrawal amount

gen mmiss=.
replace mmiss= 0 if QJ2W063<9999998 // donor group
replace mmiss= 1 if QJ2W063>9999997 & QJ2W063<1999999999 // missing variable code
replace mmiss= 1 if QJ2W063==-8 // missing variable code


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = QJ2W063
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = 0
gen double uppervalue =999999996


gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
gen yr=14
imputethis
drop yr

gen r14dcw_=exactvalue
gen r14dcw_imp=0 if QJ2W063<9999998  & QJ2W063!=-8
replace r14dcw_imp=1 if (QJ2W063>9999997 & QJ2W063<1999999999) | QJ2W063==-8
*if rolled into IRA, make it zero
replace r14dcw_=0 if QJ2W453M1==5 & QJ2W453M2==. & QJ2W453M3==. & QJ2W453M4==.

replace r14dcw_=exactvalue/months_since*monthsinlcy


drop exactvalue uppervalue lowervalue

keep hhidpn r14dcw_*
collapse (sum) r14dcw_ (sum) r14dcw_imp, by(hhidpn)

*RMD?


save "$folder\wave15\dcwtdr_14.dta",replace