*--------------------------------*
*          IRA withdrawals       *
*--------------------------------*



/*
xQ170_2 WITHDRAWN ANY MONEY FROM IRA -2
xQ170_3 WITHDRAWN ANY MONEY FROM IRA -3
xQ171_1 AMOUNT WITHDRAWN FROM IRA ACCOUNT -1
xQ171_2 AMOUNT WITHDRAWN FROM IRA ACCOUNT -2
xQ171_3 AMOUNT WITHDRAWN FROM IRA ACCOUNT -3
xQ172_1 AMT WITHDR FR IRA ACCOUNT - MIN -1
xQ172_2 AMT WITHDR FR IRA ACCOUNT - MIN -2
xQ172_3 AMT WITHDR FR IRA ACCOUNT - MIN -3
xQ173_1 AMT WITHDR FR IRA ACCOUNT - MAX -1
xQ173_2 AMT WITHDR FR IRA ACCOUNT - MAX -2
xQ173_3 AMT WITHDR FR IRA ACCOUNT - MAX -3
xQ174_1 AMT WITHDR FR IRA ACCOUNT - RESULT -1
xQ174_2 AMT WITHDR FR IRA ACCOUNT - RESULT -2
xQ174_3 AMT WITHDR FR IRA ACCOUNT - RESULT -3
xQ175_1 AMT WITHDR FR IRA ACCOUNTS-PER -1
xQ175_2 AMT WITHDR FR IRA ACCOUNTS-PER -2
xQ175_3 AMT WITHDR FR IRA ACCOUNTS-PER -3
xQ177_1 IRA MONEY MINIMUM WITHDRAWAL -1
xQ177_2 IRA MONEY MINIMUM WITHDRAWAL -2
xQ177_3 IRA MONEY MINIMUM WITHDRAWAL -3
xQ182 OTHER IRA ANNUITIES
xQ183 WHO HAS OTHER IRA ANNUITIES
xQ184M1 HOW IRA ANNUITIZED -M1
xQ184M2 HOW IRA ANNUITIZED -M2
xQ184M3 HOW IRA ANNUITIZED -M3
xQ204 AMT WITHDRAWN FROM OTHER IRA
xQ205 AMT WITHDRAWN FROM OTHER IRA - MIN
xQ206 AMT WITHDRAWN FROM OTHER IRA - MAX
xQ207 AMT WITHDRAWN FROM OTHER IRA - RESULT
*/

*IRA balances are construsted in wealth section - merge those to income section


*load the imputation program
do "$main/imputethis.do"


use "$rawfolder\hrs2020\h20q_h.dta",clear
rename hhid HHID
gen PN=RPN_FIN

gen h15hhid=HHID+rsubhh
destring h15hhid,replace
rename rsubhh RSUBHH

merge 1:1 h15hhid using "$folder\wave15\ira15.dta", keep(1 3) nogen
merge 1:1 HHID RSUBHH PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(*IWYEAR *IWMONTH *MARST RPPN)
rename RSUBHH rsubhh
*find date of last interview
gen lastmonth=.
gen lastyear=.

foreach j in `c(ALPHA)' {
  if "`j'"<="Q" & "`j'"!="I" {
    replace lastmonth=`j'IWMONTH if `j'IWMONTH!=.
	replace lastyear=`j'IWYEAR if `j'IWYEAR!=.
  }
}

gen months_since=24 if lastyear==.
replace months_since=RIWYEAR*12+RIWMONTH-(lastyear*12+lastmonth) if lastyear!=.

*impute missing for each withdrawal separately

*withdrawal from IRA account 1
*turn everything to total amount
replace RQ175_1=. if RQ171_1>999997
*month
replace RQ171_1=RQ171_1*months_since if RQ175_1==3
*quarter
replace RQ171_1=RQ171_1*months_since/3 if RQ175_1==4
*6 months
replace RQ171_1=RQ171_1*months_since/6 if RQ175_1==5
*year
replace RQ171_1=RQ171_1*months_since/12 if RQ175_1==6


*account 1

gen mmiss=.
replace mmiss= 0 if RQ171_1<999998 // donor group
replace mmiss= 1 if RQ171_1>999997 & RQ171_1<1999999999 // missing variable code
replace mmiss= 1 if RQ171_1==-8 // missing variable code


* if any coding is needed
replace RQ172_1= 0 if RQ172_1==. & mmiss==1     
replace RQ173_1= 99999996 if RQ173_1==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ171_1
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ172_1
gen double uppervalue =RQ173_1

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis

gen h15iiraw1=exactvalue
gen h15ifiraw1=1 if RQ171_1<999998 & RQ171_1!=-8
replace h15ifiraw1=2 if (RQ171_1>=999998 & RQ171_1!=.) | RQ171_1==-8
replace h15ifiraw1=3 if RQ171_1==0 | RQ170_1==5 | RQ162==5
replace h15ifiraw1=4 if inlist(RQ170_1,8,9,-8) | inlist(RQ162,8,9,-8)  

gen h15iiraw1y1=h15iiraw1/months_since*12


drop exactvalue uppervalue lowervalue
*account 2

gen mmiss=.
replace mmiss= 0 if RQ171_2<999998 // donor group
replace mmiss= 1 if RQ171_2>999997 & RQ171_2<1999999999 // missing variable code
replace mmiss= 1 if RQ171_2==-8 // missing variable code


* if any coding is needed
replace RQ172_2= 0 if RQ172_2==. & mmiss==1     
replace RQ173_2= 99999996 if RQ173_2==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ171_2
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ172_2
gen double uppervalue =RQ173_2

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis

gen h15iiraw2=exactvalue
gen h15ifiraw2=1 if RQ171_2<999998 & RQ171_2!=-8
replace h15ifiraw2=2 if (RQ171_2>=999998 & RQ171_2!=.) | RQ171_2==-8
replace h15ifiraw2=3 if RQ171_2==0 | RQ170_1==5 | RQ170_2==5 | RQ162==5 | inlist(RQ163,1,-8,8,9)
replace h15ifiraw2=4 if inlist(RQ170_2,8,9,-8) | inlist(RQ162,8,9,-8)  

gen h15iiraw2y1=h15iiraw2/months_since*12

drop exactvalue uppervalue lowervalue

*account 3

gen mmiss=.
replace mmiss= 0 if RQ171_3<999998 // donor group
replace mmiss= 1 if RQ171_3>999997 & RQ171_3<1999999999 // missing variable code
replace mmiss= 1 if RQ171_3==-8 // missing variable code


* if any coding is needed
replace RQ172_3= 0 if RQ172_3==. & mmiss==1     
replace RQ173_3= 99999996 if RQ173_3==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ171_3
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ172_3
gen double uppervalue =RQ173_3

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis

gen h15iiraw3=exactvalue
gen h15ifiraw3=1 if RQ171_3<999998 & RQ171_3!=-8
replace h15ifiraw3=2 if (RQ171_3>=999998 & RQ171_3!=.) | RQ171_3==-8
replace h15ifiraw3=3 if RQ171_3==0 | RQ170_1==5 | RQ170_2==5 | RQ170_3==5  | RQ162==5 | inlist(RQ163,1,2,-8,8,9)
replace h15ifiraw3=4 if inlist(RQ170_3,8,9,-8) | inlist(RQ162,8,9,-8)  

gen h15iiraw3y1=h15iiraw3/months_since*12
drop exactvalue uppervalue lowervalue

*other IRA
/*
RQ204 AMT WITHDRAWN FROM OTHER IRA
RQ205 AMT WITHDRAWN FROM OTHER IRA - MIN
RQ206 AMT WITHDRAWN FROM OTHER IRA - MAX
RQ207 AMT WITHDRAWN FROM OTHER IRA - RESUL
*/



gen mmiss=.
replace mmiss= 0 if RQ204<999998 // donor group
replace mmiss= 1 if RQ204>999997 & RQ204<1999999999 // missing variable code
replace mmiss= 1 if RQ204==-8 // missing variable code


* if any coding is needed
replace RQ205= 0 if RQ205==. & mmiss==1     
replace RQ206= 99999996 if RQ206==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ204
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ205
gen double uppervalue =RQ206

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis

gen h15iiraw4=exactvalue
gen h15ifiraw4=1 if RQ204<999998 & RQ204!=-8
replace h15ifiraw4=2 if (RQ204>=999998 & RQ204!=.) | RQ204==-8
replace h15ifiraw4=3 if RQ204==0 | RQ182==5   | !inlist(RQ184M1,1,.)
replace h15ifiraw4=4 if inlist(RQ182,8,9,-8)   
gen h15iiraw4y1=h15iiraw4/months_since*12
drop exactvalue uppervalue lowervalue

*RMD (ignore for now)

for num 1/4: gen r15iirawX=0
for num 1/4: gen s15iirawX=0
for num 1/4: gen r15iirawXy1=0
for num 1/4: gen s15iirawXy1=0
for num 1/3: replace r15iirawX=h15iirawX if inlist(RQ165_X,1,3,8,9,-8)
for num 1/3: replace s15iirawX=h15iirawX if inlist(RQ165_X,2)
for num 1/3: replace r15iirawXy1=h15iirawXy1 if inlist(RQ165_X,1,3,8,9,-8)
for num 1/3: replace s15iirawXy1=h15iirawXy1 if inlist(RQ165_X,2)

replace r15iiraw4=h15iiraw4 if inlist(RQ183,1,3,8,9,-8)
replace s15iiraw4=h15iiraw4 if inlist(RQ183,2)
replace r15iiraw4y1=h15iiraw4y1 if inlist(RQ183,1,3,8,9,-8)
replace s15iiraw4y1=h15iiraw4y1 if inlist(RQ183,2)

egen h15iiraw=rowtotal(h15iiraw*),m
egen h15iirawy1=rowtotal(h15iiraw*y1),m
egen r15iiraw=rowtotal(r15iiraw*),m
egen r15iirawy1=rowtotal(r15iiraw*y1),m
egen s15iiraw=rowtotal(s15iiraw*),m
egen s15iirawy1=rowtotal(s15iiraw*y1),m

keep h15hhid h15i* r15i* s15i*

save "$folder\wave15\irainc_15.dta",replace