*household capital income*


clear


*load the imputation program
do "$main/imputethis.do"

* -----------------
* START CODING HERE
* -----------------

use "$rawfolder\hrs2020\h20q_h.dta",clear
rename hhid HHID
gen PN=RPN_FIN

* -------------------------------------
* household - stocks
* --------------------------------------

/*

RQ152 BUSINESS OR FARM INCOME
RQ153 BUSINESS OR FARM INC RECEIVE HOW OFTEN
RQ155 BUSINESS OR FARM INC AMT LAST PERIOD
RQ156 BUSINESS OR FARM INC SAME AMT PER PERIOD
RQ157 BUSINESS OR FARM INC - LCY
RQ158 BUSINESS OR FARM INC - MIN
RQ159 BUSINESS OR FARM INC - MAX
*/

gen bus_aux=RQ157
replace bus_aux=RQ155*52 if RQ153==1 & RQ155<999998 & RQ155!=-8 & RQ157>=9999998
replace bus_aux=RQ155*24 if RQ153==2 & RQ155<999998 & RQ155!=-8  & RQ157>=9999998
replace bus_aux=RQ155*12 if RQ153==3 & RQ155<999998 & RQ155!=-8 & RQ157>=9999998
replace bus_aux=RQ155*4 if RQ153==4 & RQ155<999998 & RQ155!=-8 & RQ157>=9999998
replace bus_aux=RQ155*2 if RQ153==5 & RQ155<999998 & RQ155!=-8 & RQ157>=9999998

*replace bus_aux=RQ157 if inlist(RQ153,-8,6,7,8,9) | RQ156==5 | (!missing(RQ155) & RQ155>=999998)

gen mmiss=.
replace mmiss= 0 if bus_aux<9999998 // donor group
replace mmiss= 1 if bus_aux>9999997 & bus_aux<1999999999 // missing variable code
replace mmiss= 1 if bus_aux==-8 // missing variable code

* if any coding is needed
replace RQ158= 0 if RQ158==. & mmiss==1      //fix annoying quirk in data
replace RQ159= 99999996 if RQ159==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = bus_aux
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ158
gen double uppervalue = RQ159


gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis


* Replace variable with imputation
gen h15ibusin=exactvalue
gen h15ifbusin=1 if bus_aux<9999998 & bus_aux!=-8
replace h15ifbusin=2 if (bus_aux>=9999998 & bus_aux!=.) | bus_aux==-8
replace h15ifbusin=3 if bus_aux==0 | RQ152==5 |  RQ152==.
replace h15ifbusin=4 if inlist(RQ152,8,9,-8)

drop exactvalue uppervalue lowervalue

* -------------------------------------
* household - rental income
* -------------------------------------

gen rent_aux=RQ143
replace rent_aux=RQ141*52 if RQ139==1 & RQ141<99998 & RQ141!=-8 & RQ143>=999998
replace rent_aux=RQ141*24 if RQ139==2 & RQ141<99998 & RQ141!=-8 & RQ143>=999998
replace rent_aux=RQ141*12 if RQ139==3 & RQ141<99998 & RQ141!=-8 & RQ143>=999998
replace rent_aux=RQ141*4 if RQ139==4 & RQ141<99998 & RQ141!=-8 & RQ143>=999998
replace rent_aux=RQ141*2 if RQ139==5 & RQ141<99998 & RQ141!=-8 & RQ143>=999998

*replace rent_aux=RQ143 if inlist(RQ139,-8,6,7,8,9) | RQ142==5 | (!missing(RQ141) & RQ141>=99998)

gen mmiss=.
replace mmiss= 0 if rent_aux<999998 // donor group
replace mmiss= 1 if rent_aux>999997 & rent_aux<1999999999 // missing variable code
replace mmiss= 1 if rent_aux==-8 // missing variable code

* if any coding is needed
replace RQ144= 0 if RQ144==. & mmiss==1      //fix annoying quirk in data
replace RQ145= 99999996 if RQ145==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = rent_aux
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ144
gen double uppervalue = RQ145

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15irntin=exactvalue
gen h15ifrntin=1 if rent_aux<9999998 & rent_aux!=-8
replace h15ifrntin=2 if (rent_aux>=9999998 & rent_aux!=.) | rent_aux==-8
replace h15ifrntin=3 if rent_aux==0 | RQ138==5 |  RQ138==.
replace h15ifrntin=4 if inlist(RQ138,8,9,-8)

drop exactvalue uppervalue lowervalue


* -------------------------------------
* household - dividends from stocks
* -------------------------------------

gen stck_aux=RQ326
replace stck_aux=RQ324*52 if RQ322==1 & RQ324<999998 & RQ324!=-8 & RQ326>=999998 
replace stck_aux=RQ324*24 if RQ322==2 & RQ324<999998 & RQ324!=-8 & RQ326>=999998 
replace stck_aux=RQ324*12 if RQ322==3 & RQ324<999998 & RQ324!=-8 & RQ326>=999998 
replace stck_aux=RQ324*4 if RQ322==4 & RQ324<999998 & RQ324!=-8 & RQ326>=999998 
replace stck_aux=RQ324*2 if RQ322==5 & RQ324<999998 & RQ324!=-8 & RQ326>=999998 

*replace stck_aux=RQ326 if inlist(RQ322,-8,6,7,8,9) | RQ325==5 | (!missing(RQ324) & RQ324>=999998)

gen mmiss=.
replace mmiss= 0 if stck_aux<999998 // donor group
replace mmiss= 1 if stck_aux>999997 & stck_aux<1999999999 // missing variable code
replace mmiss= 1 if stck_aux==-8 // missing variable code

* if any coding is needed
replace RQ327= 0 if RQ327==. & mmiss==1      //fix annoying quirk in data
replace RQ328= 99999996 if RQ328==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = stck_aux
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ327
gen double uppervalue = RQ328

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15istk=exactvalue
gen h15ifstk=1 if stck_aux<999998 & stck_aux!=-8
replace h15ifstk=2 if (stck_aux>=999998 & stck_aux!=.) | stck_aux==-8
replace h15ifstk=3 if stck_aux==0 | RQ321==5 |  RQ321==.
replace h15ifstk=4 if inlist(RQ321,8,9,-8)

drop exactvalue uppervalue lowervalue

* -------------------------------------
* household - dividends from bonds
* -------------------------------------

gen bond_aux=RQ340
replace bond_aux=RQ338*52 if RQ336==1 & RQ338<99998 & RQ338!=-8 & RQ340>=999998 
replace bond_aux=RQ338*24 if RQ336==2 & RQ338<99998 & RQ338!=-8 & RQ340>=999998 
replace bond_aux=RQ338*12 if RQ336==3 & RQ338<99998 & RQ338!=-8 & RQ340>=999998 
replace bond_aux=RQ338*4 if RQ336==4 & RQ338<99998 & RQ338!=-8 & RQ340>=999998 
replace bond_aux=RQ338*2 if RQ336==5 & RQ338<99998 & RQ338!=-8 & RQ340>=999998 

*replace bond_aux=RQ340 if inlist(RQ336,-8,6,7,8,9) | RQ339==5 | (!missing(RQ338) & RQ338>=99998)

gen mmiss=.
replace mmiss= 0 if bond_aux<999998 // donor group
replace mmiss= 1 if bond_aux>999997 & bond_aux<1999999999 // missing variable code
replace mmiss= 1 if bond_aux==-8 // missing variable code

* if any coding is needed
replace RQ341= 0 if RQ341==. & mmiss==1      //fix annoying quirk in data
replace RQ342= 99999996 if RQ342==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = bond_aux
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ341
gen double uppervalue = RQ342

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15ibndind=exactvalue
gen h15ifbndind=1 if bond_aux<999998 & bond_aux!=-8
replace h15ifbndind=2 if (bond_aux>=999998 & bond_aux!=.) | bond_aux==-8
replace h15ifbndind=3 if bond_aux==0 | RQ335==5 |  RQ335==.
replace h15ifbndind=4 if inlist(RQ335,8,9,-8)

drop exactvalue uppervalue lowervalue

* -------------------------------------
* household - dividends from checking/saving accounts
* -------------------------------------

gen chck_aux=RQ354
replace chck_aux=RQ352*52 if RQ350==1 & RQ352<99998 & RQ352!=-8 & RQ354>=999998
replace chck_aux=RQ352*24 if RQ350==2 & RQ352<99998 & RQ352!=-8 & RQ354>=999998
replace chck_aux=RQ352*12 if RQ350==3 & RQ352<99998 & RQ352!=-8 & RQ354>=999998
replace chck_aux=RQ352*4 if RQ350==4 & RQ352<99998 & RQ352!=-8 & RQ354>=999998
replace chck_aux=RQ352*2 if RQ350==5 & RQ352<99998 & RQ352!=-8 & RQ354>=999998

*replace chck_aux=RQ354 if inlist(RQ350,-8,6,7,8,9) | RQ353==5 | (!missing(RQ352) & RQ352>=99998)

gen mmiss=.
replace mmiss= 0 if chck_aux<999998 // donor group
replace mmiss= 1 if chck_aux>999997 & chck_aux<1999999999 // missing variable code
replace mmiss= 1 if chck_aux==-8 // missing variable code

* if any coding is needed
replace RQ494= 0 if RQ494==. & mmiss==1      //fix annoying quirk in data
replace RQ495= 99999996 if RQ495==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = chck_aux
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ494
gen double uppervalue = RQ495

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15ichkin=exactvalue
gen h15ifchkin=1 if chck_aux<999998 & chck_aux!=-8
replace h15ifchkin=2 if (chck_aux>=999998 & chck_aux!=.) | chck_aux==-8
replace h15ifchkin=3 if chck_aux==0 | RQ349==5 |  RQ349==.
replace h15ifchkin=4 if inlist(RQ349,8,9,-8)

drop exactvalue uppervalue lowervalue

* -------------------------------------
* household - cd interest
* -------------------------------------

gen cd_aux=RQ366
replace cd_aux=RQ364*52 if RQ362==1 & RQ364<99998 & RQ364!=-8 & RQ366>=999998 
replace cd_aux=RQ364*24 if RQ362==2 & RQ364<99998 & RQ364!=-8 & RQ366>=999998 
replace cd_aux=RQ364*12 if RQ362==3 & RQ364<99998 & RQ364!=-8 & RQ366>=999998 
replace cd_aux=RQ364*4 if RQ362==4 & RQ364<99998 & RQ364!=-8 & RQ366>=999998 
replace cd_aux=RQ364*2 if RQ362==5 & RQ364<99998 & RQ364!=-8 & RQ366>=999998 

*replace cd_aux=RQ366 if inlist(RQ362,-8,6,7,8,9) | RQ365==5 | (!missing(RQ364) & RQ364>=99998)

gen mmiss=.
replace mmiss= 0 if cd_aux<999998 // donor group
replace mmiss= 1 if cd_aux>999997 & cd_aux<1999999999 // missing variable code
replace mmiss= 1 if cd_aux==-8 // missing variable code

* if any coding is needed
replace RQ367= 0 if RQ367==. & mmiss==1      //fix annoying quirk in data
replace RQ368= 99999996 if RQ368==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = cd_aux
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ367
gen double uppervalue = RQ368

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15icdin=exactvalue
gen h15ifcdin=1 if cd_aux<999998 & cd_aux!=-8
replace h15ifcdin=2 if (cd_aux>=999998 & cd_aux!=.) | cd_aux==-8
replace h15ifcdin=3 if cd_aux==0 | RQ361==5 |  RQ361==.
replace h15ifcdin=4 if inlist(RQ361,8,9,-8)

drop exactvalue uppervalue lowervalue

* -------------------------------------
* household - other assets income
* -------------------------------------


gen mmiss=.
replace mmiss= 0 if RQ381<999998 // donor group
replace mmiss= 1 if RQ381>999997 & RQ381<1999999999 // missing variable code
replace mmiss= 1 if RQ381==-8 // missing variable code

* if any coding is needed
replace RQ382= 0 if RQ382==. & mmiss==1      //fix annoying quirk in data
replace RQ383= 99999996 if RQ383==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ381
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ382
gen double uppervalue = RQ383

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15iothi1=exactvalue
gen h15ifothi1=1 if RQ381<999998 & RQ381!=-8
replace h15ifothi1=2 if (RQ381>=999998 & RQ381!=.) | RQ381==-8
replace h15ifothi1=3 if RQ381==0 | RQ380==5 |  RQ380==.
replace h15ifothi1=4 if inlist(RQ380,8,9,-8)

drop exactvalue uppervalue lowervalue

* -------------------------------------
* respondent - self employment
* -------------------------------------


gen mmiss=.
replace mmiss= 0 if RQ015<9999998 // donor group
replace mmiss= 1 if RQ015>9999997 & RQ015<1999999999 // missing variable code
replace mmiss= 1 if RQ015==-8 // missing variable code

* if any coding is needed
replace RQ016= 0 if RQ016==. & mmiss==1      //fix annoying quirk in data
replace RQ017= 99999996 if RQ017==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ015
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ016
gen double uppervalue = RQ017

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15isemp=exactvalue
gen r15ifsemp=1 if RQ015<9999998 & RQ015!=-8
replace r15ifsemp=2 if (RQ015>=9999998 & RQ015!=.) | RQ015==-8
replace r15ifsemp=3 if RQ015==0 | RQ014==5 |  RQ014==.
replace r15ifsemp=4 if inlist(RQ014,8,9,-8)

drop exactvalue uppervalue lowervalue

* -------------------------------------
* spouse - self employment
* -------------------------------------


gen mmiss=.
replace mmiss= 0 if RQ040<9999998 // donor group
replace mmiss= 1 if RQ040>9999997 & RQ040<1999999999 // missing variable code
replace mmiss= 1 if RQ040==-8 // missing variable code

* if any coding is needed
replace RQ041= 0 if RQ041==. & mmiss==1      //fix annoying quirk in data
replace RQ042= 99999996 if RQ042==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ040
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ041
gen double uppervalue = RQ042

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=999999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15isemp=exactvalue
gen s15ifsemp=1 if RQ040<9999998 & RQ040!=-8
replace s15ifsemp=2 if (RQ040>=9999998 & RQ040!=.) | RQ040==-8
replace s15ifsemp=3 if RQ040==0 | RQ039==5 |  RQ039==.
replace s15ifsemp=4 if inlist(RQ039,8,9,-8)

drop exactvalue uppervalue lowervalue

drop *_aux

egen h15icap=rowtotal(s15isemp r15isemp h15ibndind h15ibusin h15icdin h15ichkin h15istk h15irntin h15iothi1),m



gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15* r15* s15* 
save "$folder\wave15\capital15.dta",replace
