*earnings*
*wage and salary, trade or profesiional practice, second job, bonus and commision*

clear


*load the imputation program
do "$main/imputethis.do"

* -----------------
* START CODING HERE
* -----------------

use "$rawfolder\hrs2020\h20q_h.dta",clear
*rename RPN_FIN pn
*merge 1:1 hhid rsubhh pn using "$rawfolder\hrs2020\h20pr_r.dta", nogen keep(1 3) keepusing(RPN_SP)

* -----------------
* respondent wages
* -----------------
*
/*
xQ019 R WAGES AND SALARY INCOME - LCY
xQ020 R AMOUNT FROM WAGES AND SALARY LCY
xQ021 R AMT FROM WAGES AND SALARY - MIN
xQ022 R AMT FROM WAGES AND SALARY - MAX
*/


rename hhid HHID

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ020<9999998 // donor group
replace mmiss= 1 if RQ020>9999997 & RQ020<1999999999 // missing variable code
replace mmiss= 1 if RQ020==-8 // missing variable code

* if any coding is needed
replace RQ021= 0 if RQ021==. & mmiss==1      //fix annoying quirk in data
replace RQ022= 99999996 if RQ022==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ020
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ021
gen double uppervalue = RQ022

gen PN=RPN_FIN

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.

* Impute
imputethis


* Replace variable with imputation
gen r15iwage=exactvalue
gen r15ifwage=1 if RQ020<9999998 & RQ020!=-8
replace r15ifwage=2 if (RQ020>=9999998 & RQ020!=.) | RQ020==-8
replace r15ifwage=3 if RQ020==0 | RQ019==5 |  RQ019==.
replace r15ifwage=4 if inlist(RQ019,8,9,-8)

drop exactvalue uppervalue lowervalue

* -----------------
* respondent trade or professinal practice
* -----------------

gen mmiss=.
replace mmiss= 0 if RQ025<9999998 // donor group
replace mmiss= 1 if RQ025>9999997 & RQ025<1999999999 // missing variable code
replace mmiss= 1 if RQ025==-8 // missing variable code

* if any coding is needed
replace RQ026= 0 if RQ026==. & mmiss==1      //fix annoying quirk in data
replace RQ027= 99999996 if RQ027==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ025
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ026
gen double uppervalue = RQ027

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15itrad=exactvalue
gen r15iftrad=1 if RQ025<9999998 & RQ025!=-8
replace r15iftrad=2 if (RQ025>=9999998 & RQ025!=.) | RQ025==-8
replace r15iftrad=3 if RQ025==0 | RQ024==5 |  RQ024==.
replace r15iftrad=4 if inlist(RQ024,8,9,-8)

drop exactvalue uppervalue lowervalue


* -----------------
* respondent bonus
* -----------------

gen mmiss=.
replace mmiss= 0 if RQ030<999998 // donor group
replace mmiss= 1 if RQ030>999997 & RQ030<1999999999 // missing variable code
replace mmiss= 1 if RQ030==-8 // missing variable code

* if any coding is needed
replace RQ031= 0 if RQ031==. & mmiss==1      //fix annoying quirk in data
replace RQ032= 99999996 if RQ032==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ030
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ031
gen double uppervalue = RQ032

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15ibon=exactvalue
gen r15ifbon=1 if RQ030<999998 & RQ030!=-8
replace r15ifbon=2 if (RQ030>=999998 & RQ030!=.) | RQ030==-8
replace r15ifbon=3 if RQ030==0 | RQ029==5 |  RQ029==.
replace r15ifbon=4 if inlist(RQ029,8,9,-8)

drop exactvalue uppervalue lowervalue

* --------------------
* respondent second job
* --------------------
gen mmiss=.
replace mmiss= 0 if RQ035<999998 // donor group
replace mmiss= 1 if RQ035>999997 & RQ035<1999999999 // missing variable code
replace mmiss= 1 if RQ035==-8 // missing variable code

* if any coding is needed
replace RQ036= 0 if RQ036==. & mmiss==1      //fix annoying quirk in data
replace RQ037= 99999996 if RQ037==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ035
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ036
gen double uppervalue = RQ037

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15i2ind=exactvalue
gen r15if2ind=1 if RQ035<999998 & RQ035!=-8
replace r15if2ind=2 if (RQ035>=999998 & RQ035!=.) | RQ035==-8
replace r15if2ind=3 if RQ035==0 | RQ034==5 |  RQ034==.
replace r15if2ind=4 if inlist(RQ034,8,9,-8)

drop exactvalue uppervalue lowervalue

******************
* spouse
******************

*wage
gen mmiss=.
replace mmiss= 0 if RQ045<999998 // donor group
replace mmiss= 1 if RQ045>999997 & RQ045<1999999999 // missing variable code
replace mmiss= 1 if RQ045==-8 // missing variable code

* if any coding is needed
replace RQ046= 0 if RQ046==. & mmiss==1      //fix annoying quirk in data
replace RQ047= 99999996 if RQ047==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ045
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ046
gen double uppervalue = RQ047

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15iwage=exactvalue
gen s15ifwage=1 if RQ045<999998 & RQ045!=-8
replace s15ifwage=2 if (RQ045>=999998 & RQ045!=.) | RQ045==-8
replace s15ifwage=3 if RQ045==0 | RQ044==5 |  RQ044==.
replace s15ifwage=4 if inlist(RQ044,8,9,-8)
 

drop exactvalue uppervalue lowervalue

* -----------------
* spouse trade or professinal practice
* -----------------

gen mmiss=.
replace mmiss= 0 if RQ050<999998 // donor group
replace mmiss= 1 if RQ050>999997 & RQ050<1999999999 // missing variable code
replace mmiss= 1 if RQ050==-8 // missing variable code

* if any coding is needed
replace RQ051= 0 if RQ051==. & mmiss==1      //fix annoying quirk in data
replace RQ052= 99999996 if RQ052==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ050
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ051
gen double uppervalue = RQ052

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15itrad=exactvalue
gen s15iftrad=1 if RQ050<999998 & RQ050!=-8
replace s15iftrad=2 if (RQ050>=999998 & RQ050!=.) | RQ050==-8
replace s15iftrad=3 if RQ050==0 | RQ049==5 |  RQ049==.
replace s15iftrad=4 if inlist(RQ049,8,9,-8)
 

drop exactvalue uppervalue lowervalue

* -----------------
* spouse bonus
* -----------------

gen mmiss=.
replace mmiss= 0 if RQ055<999998 // donor group
replace mmiss= 1 if RQ055>999997 & RQ055<1999999999 // missing variable code
replace mmiss= 1 if RQ055==-8 // missing variable code

* if any coding is needed
replace RQ056= 0 if RQ056==. & mmiss==1      //fix annoying quirk in data
replace RQ057= 99999996 if RQ057==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ055
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ056
gen double uppervalue = RQ057

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15ibon=exactvalue
gen s15ifbon=1 if RQ055<999998 & RQ055!=-8
replace s15ifbon=2 if (RQ055>=999998 & RQ055!=.) | RQ055==-8
replace s15ifbon=3 if RQ055==0 | RQ054==5 |  RQ054==.
replace s15ifbon=4 if inlist(RQ054,8,9,-8)

drop exactvalue uppervalue lowervalue
* --------------------
* spouse second job
* --------------------

gen mmiss=.
replace mmiss= 0 if RQ060<99998 // donor group
replace mmiss= 1 if RQ060>99997 & RQ060<1999999999 // missing variable code
replace mmiss= 1 if RQ060==-8 // missing variable code

* if any coding is needed
replace RQ061= 0 if RQ061==. & mmiss==1      //fix annoying quirk in data
replace RQ062= 99999996 if RQ062==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ060
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ061
gen double uppervalue = RQ062

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15i2ind=exactvalue
gen s15if2ind=1 if RQ060<99998 & RQ060!=-8
replace s15if2ind=2 if (RQ060>=99998 & RQ060!=.) | RQ060==-8
replace s15if2ind=3 if RQ060==0 | RQ059==5 |  RQ059==.
replace s15if2ind=4 if inlist(RQ059,8,9,-8)
 

drop exactvalue uppervalue lowervalue

egen r15iearn=rowtotal(r15iwage r15ibon r15i2ind r15itrad)
egen s15iearn=rowtotal(s15iwage s15ibon s15i2ind s15itrad)

gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid r15i* s15i* 
save "$folder\wave15\earnings15.dta",replace