*government transfers
*veteran benefit
*welfare income
*food stamp

*Veteran benefit
clear

*load the imputation program
do "$main/imputethis.do"


use "$rawfolder\hrs2020\h20q_h.dta",clear
rename hhid HHID
gen PN=RPN_FIN
rename rsubhh RSUBHH
merge 1:1 HHID RSUBHH PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(RIWYEAR RPPN)
rename RSUBHH rsubhh
*WELFARE
/*
RQ113 R OR SP INCOME FR WELFARE NOT SSI - LCY
RQ114 WHO RECEIVED INC FR WELFARE NOT SSI LCY
RQ115 AMOUNT FROM WELFARE LCY
RQ116 AMOUNT FROM WELFARE - MIN
RQ117 AMOUNT FROM WELFARE - MAX
*/

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ115<99998 // donor group
replace mmiss= 1 if RQ115>99997 & RQ115<1999999999 // missing variable code
replace mmiss= 1 if RQ115==-8 // missing variable code

* if any coding is needed
replace RQ116= 0 if RQ116==. & mmiss==1     
replace RQ117= 99999996 if RQ117==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ115
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ116
gen double uppervalue = RQ117

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15iwelf=exactvalue
replace r15iwelf=0 if RQ114==2
replace r15iwelf=exactvalue/2 if RQ114==3

gen s15iwelf=exactvalue
replace s15iwelf=0 if RQ114==1 | RQ114==-8
replace s15iwelf=exactvalue/2 if RQ114==3

gen h15ifwelf=1 if RQ115<99998 & RQ115!=-8
replace h15ifwelf=2 if (RQ115>=99998 & RQ115!=.) | RQ115==-8
replace h15ifwelf=3 if RQ115==0 | RQ113==5 
replace h15ifwelf=4 if inlist(RQ113,8,9,-8)

drop exactvalue uppervalue lowervalue


*Veterans benefit

/*
xQ119 R OR SP INC FR VETERAN BEN MILITARY PENS
xQ120 WHO RECEIVES VET BEN MILITARY PENSION
xQ121 R AMT FR VETERAN BENEFITS - LAST MONTH
xQ122 R AMT FR VETERAN BENEFITS - MIN
xQ123 R AMT FR VETERAN BENEFITS - MAX
xQ124 R AMT FR VETERAN BENEFITS - RESULT
xQ125 R YEAR STARTED VETERAN BENEFITS
xQ126 R MONTH STARTED VETERAN BENEFITS
xQ127 SP AMT FR VETERAN BENEFITS - LAST MONTH
xQ128 SP AMT FR VETERAN BENEFITS - MIN
xQ129 SP AMT FR VETERAN BENEFITS - MAX
xQ130 SP AMT VETERAN BENEFITS - RESULT
xQ131 SP YEAR STARTED VETERAN BENEFITS
xQ132 SP MONTH STARTED VETERAN BENEFITS
*/


*respondent

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ121<99998 // donor group
replace mmiss= 1 if RQ121>99997 & RQ121<1999999999 // missing variable code
replace mmiss= 1 if RQ121==-8 

* if any coding is needed
replace RQ122= 0 if RQ122==. & mmiss==1      
replace RQ123=99999996 if RQ123==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ121
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ122
gen double uppervalue = RQ123

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15ivet=exactvalue
gen r15ifvet=1 if RQ121<99998 & RQ121!=-8
replace r15ifvet=2 if (RQ121>=99998 & RQ121!=.) | RQ121==-8 
replace r15ifvet=3 if RQ121==0 | RQ119==5 |  RQ120==2
replace r15ifvet=4 if inlist(RQ119,8,9,-8) 
*partial interview?
replace r15ifvet=5 if RQ119==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue

replace RIWYEAR=2020 if RIWYEAR==.
gen months1=12
replace months1=RQ126 if RQ125==2019 & !inlist(RQ126,-8,98,99) & RIWYEAR==2020
replace months1=RQ126 if RQ125==2020 & !inlist(RQ126,-8,98,99) & RIWYEAR==2021

replace r15ivet=r15ivet*months1


*spouse

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ127<9998 // donor group
replace mmiss= 1 if RQ127>9997 & RQ127<1999999999 // missing variable code
replace mmiss= 1 if RQ127==-8 

* if any coding is needed
replace RQ128= 0 if RQ128==. & mmiss==1      
replace RQ129=99999996 if RQ129==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ127
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ128
gen double uppervalue = RQ129

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15ivet=exactvalue
gen s15ifvet=1 if RQ127<9998 & RQ127!=-8
replace s15ifvet=2 if (RQ127>=9998 & RQ127!=.) | RQ127==-8 
replace s15ifvet=3 if RQ127==0 | RQ119==5 |  RQ120==1
replace s15ifvet=4 if inlist(RQ119,8,9,-8) 
*partial interview?
replace s15ifvet=5 if RQ119==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue

gen months2=12
replace months2=RQ132 if RQ131==2019 & !inlist(RQ132,-8,98,99) & RIWYEAR==2020
replace months2=RQ132 if RQ131==2020 & !inlist(RQ132,-8,98,99) & RIWYEAR==2021

replace s15ivet=s15ivet*months2


*food
*combine last month (if still receiveing) with last received (if stopped receiving) - ignore the inflation

gen aux=RQ410 if RQ532==1
replace aux=RQ406 if RQ532==5

gen aux_l=RQ411 if RQ532==1
replace aux_l=RQ407 if RQ532==5

gen aux_h=RQ412 if RQ532==1
replace aux_h=RQ408 if RQ532==5


* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if aux<9998 // donor group
replace mmiss= 1 if aux>9997 & aux<1999999999 // missing variable code
replace mmiss= 1 if aux==-8 

* if any coding is needed
replace aux_l= 0 if aux_l==. & mmiss==1      
replace aux_h=99999996 if aux_h==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = aux
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = aux_l
gen double uppervalue = aux_h

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15ifood=exactvalue
gen h15iffood=1 if aux<9998 & aux!=-8
replace h15iffood=2 if (aux>=9998 & aux!=.) | aux==-8 
replace h15iffood=3 if aux==0 | RQ400==5 
replace h15iffood=4 if inlist(RQ400,8,9,-8) 
*partial interview?
replace h15iffood=5 if RQ400==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue

replace RIWYEAR=2020 if RIWYEAR==.

gen monthsf=0  if RIWYEAR==2021 
gen monthsf2=0  if RIWYEAR==2020 
forvalues i=1/12{
	replace monthsf=monthsf+1 if RQW778_2M`i'!=. & RIWYEAR==2021 & RQW776_2 ==2020
	replace monthsf2=monthsf2+1 if RQW778_3M`i'!=. & RIWYEAR==2020 & RQW776_3 ==2019
}



replace h15ifood=h15ifood*monthsf if RIWYEAR==2021 
replace h15ifood=h15ifood*monthsf2 if RIWYEAR==2020 

gen r15ifood=h15ifood
replace r15ifood=h15ifood/2 if RPPN!="000"
gen s15ifood=h15ifood/2 if RPPN!="000"

egen r15igxfr=rowtotal(r15ivet r15iwelf r15ifood),m
egen s15igxfr=rowtotal(s15ivet s15iwelf s15ifood),m


gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid r15i* s15i* 
save "$folder\wave15\government_trans_15.dta",replace