global folder "\\courageous\Administration\Executive\CRR\Boxes\Nilufer\HRS project\imputation\data\hrs"
global rawfolder "\\courageous\Administration\Executive\CRR\CRRMicroDataFiles\HRS\HRS Stata files\CORE"

*use respondent level coverscreen
use "$rawfolder\hrs2020\h20pr_r.dta" ,clear

rename hhid HHID
rename pn PN

*merge respondent characteristics using the latest tracker file
merge 1:1 HHID PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) nogen keepusing(RAGE DEGREE RACE HISPANIC RCOUPLE WTCOHORT GENDER) 

*merge spouse age from household coverscreen
rename HHID hhid
rename PN RPN_CS
merge 1:1 hhid RPN_CS using "$rawfolder\hrs2020\h20a_h.dta", keep(1 3) nogen keepusing(RA044)

rename RPN_CS pn

gen h15hhid=hhid+rsubhh
destring h15hhid,replace
*merge income components
 foreach val in earnings capital government_trans_ irainc_ otherinc_ pension_ ssa_ unempwc{
 	merge m:1 h15hhid using "$folder\wave15\\`val'15.dta",keep(1 3) nogen
	
 }
 
 gen hhidpn=hhid+pn
 destring hhidpn,replace
 
 *merge missing spouse flag(created in the pension section)
 merge 1:1 hhidpn using "$folder/missingspouse.dta",keep(1 3) nogen keepusing(r15missingsp)
 
 
 
 *if not financial respondent, assign s to respondent and r to spouse - both values and flags
 
 
 *is there a household financial respondent this wave? -290 people w/o financial respondent
 bys h15hhid: egen anyfinr=min(rfinr)
 drop if anyfinr==5
 
 foreach val in wage trad bon 2ind semp welf vet food gxfr earn pen ann soc sret sdi ssi unem wcmp  unwc iraw1 iraw2 iraw3 iraw4 iraw1y1 iraw2y1 iraw3y1 iraw4y1{
 	
	gen r_aux=r15i`val'
	gen s_aux=s15i`val'
	cap gen rf_aux=r15if`val'
	cap gen sf_aux=s15if`val'
	
	replace r15i`val'=s_aux if rfinr==5 & anyfinr==1
	replace s15i`val'=r_aux if rfinr==5 & anyfinr==1
	
	cap replace r15if`val'=sf_aux if rfinr==5 & anyfinr==1
	cap replace s15if`val'=rf_aux if rfinr==5 & anyfinr==1
	
	drop *_aux
	
	replace r15i`val'=0 if r15i`val'==.
	replace s15i`val'=0 if s15i`val'==.
	replace s15i`val'=. if RPN_SP==""
	
	
 }
 
  
 *Missing spouse imputation
 *Get all missing values from the same neighbor - only for aggregate values
 *impute for missing spouses
 
 gen married=(RCOUPLE==1)
 gen age=RAGE
 gen sage=RA044
 replace sage=RAGE if sage==. & married==1
 gen gender=GENDER
 gen cohort=WTCOHORT
 gen nonwhite=(RACE!=1 & HISPANIC!=5) 
 gen college=(DEGREE>=4)
 
 
mi set wide 
mi register imputed s15iearn s15ipen s15isoc s15issi s15iunwc s15igxfr s15iann s15iiraw s15iirawy1
mi impute monotone (pmm, knn(1)) s15iearn s15ipen s15isoc s15issi s15iunwc s15igxfr = gender i.cohort age sage i.nonwhite i.college i.married r15iearn r15isoc r15ipen, replace add(1) force


 foreach val in iearn ipen iann isoc issi iunwc igxfr iiraw iirawy1{

replace s15`val'=_1_s15`val' if (r15missingsp==1)

 }
mi unregister  s15iearn s15ipen s15isoc s15issi s15iunwc s15igxfr  s15iann s15iiraw s15iirawy1
 
 

 
 keep hhidpn r15* s15* h15* anyfinr
 
 
 order hhidpn h15hhid
 
 *total household income as defined in RAND longitudinal file
 egen h15itot=rowtotal(r15iearn s15iearn r15ipen s15ipen r15iann s15iann r15isoc s15isoc r15issi s15issi r15iunwc s15iunwc r15igxfr s15igxfr h15icap h15iothr),m
 
 *if there is no financial respondent, total is zero
 *br h15itot if anyfinr==5
 
save "$folder/income_merged.dta",replace
