*other income
*lump sum in the LCY


clear


*load the imputation program
do "$main/imputethis.do"


use "$rawfolder\hrs2020\h20q_h.dta",clear
rename hhid HHID
gen PN=RPN_FIN
rename rsubhh RSUBHH
merge 1:1 HHID RSUBHH PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(RIWYEAR RPPN)
rename RSUBHH rsubhh

*other income

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ396<999998 // donor group
replace mmiss= 1 if RQ396>999997 & RQ396<1999999999 // missing variable code
replace mmiss= 1 if RQ396==-8 // missing variable code

* if any coding is needed
replace RQ397= 0 if RQ397==. & mmiss==1     
replace RQ398= 99999996 if RQ398==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ396
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ397
gen double uppervalue = RQ398

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15iothi2=exactvalue
gen h15ifothi2=1 if RQ396<999998 & RQ396!=-8
replace h15ifothi2=2 if (RQ396>=999998 & RQ396!=.) | RQ396==-8
replace h15ifothi2=3 if RQ396==0 | RQ395==5 
replace h15ifothi2=4 if inlist(RQ395,8,9,-8)

drop exactvalue uppervalue lowervalue

*lumpsum in the last calendar year - up to three
/*
xQ483_1 R OR SP IF LUMP SUM RECEIVED -1
xQ483_2 R OR SP IF LUMP SUM RECEIVED -2
xQ483_3 R OR SP IF LUMP SUM RECEIVED -3
xQ486_1 MONTH LUMP SUM RECEIVED -1
xQ486_2 MONTH LUMP SUM RECEIVED -2
xQ486_3 MONTH LUMP SUM RECEIVED -3
xQ487_1 YEAR LUMP SUM RECEIVED -1
xQ487_2 YEAR LUMP SUM RECEIVED -2
xQ487_3 YEAR LUMP SUM RECEIVED -3
xQ488_1 LUMP SUM AMOUNT RECEIVED -1
xQ488_2 LUMP SUM AMOUNT RECEIVED -2
xQ488_3 LUMP SUM AMOUNT RECEIVED -3
xQ489_1 LUMP SUM AMT - $50K -1
xQ489_2 LUMP SUM AMT - $50K -2
xQ489_3 LUMP SUM AMT - $50K -3
*/

*lumpsum #1

gen mmiss=.
replace RQ488_1=50000 if RQ489_1==3
replace mmiss= 0 if RQ488_1<99999998 // donor group
replace mmiss= 1 if RQ488_1>99999997 & RQ488_1<1999999999 // missing variable code
replace mmiss= 1 if RQ488_1==-8 // missing variable code
replace mmiss=. if RQ487_1<2018 


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ488_1 if mmiss!=.
replace exactvalue=99999999 if mmiss==1
gen double lowervalue = 0 if mmiss==1
replace lowervalue = 50000 if mmiss==1 & RQ489_1==5
gen double uppervalue = 99999996 if mmiss==1
replace uppervalue = 50000 if mmiss==1 & RQ489_1==1

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15iluyr1=exactvalue
replace h15iluyr1=0 if RQ487_1!=2019 & RIWYEAR==2020
replace h15iluyr1=0 if RQ487_1!=2020 & RIWYEAR==2021

gen h15ifiluyr1=1 if RQ488_1<99999998 & RQ488_1!=-8 & RQ487_1>=2019
replace h15ifiluyr1=2 if (RQ488_1>=99999998 & RQ488_1!=.) | RQ488_1==-8 
replace h15ifiluyr1=3 if RQ488_1==0 | RQ483_1 ==5 |  RQ487_1<2019 
replace h15ifiluyr1=4 if inlist(RQ483_1,8,9,-8)

drop exactvalue uppervalue lowervalue

*lumpsum #2

gen mmiss=.
replace RQ488_2=50000 if RQ489_2==3
replace mmiss= 0 if RQ488_2<9999998 // donor group
replace mmiss= 1 if RQ488_2>9999997 & RQ488_2<1999999999 // missing variable code
replace mmiss= 1 if RQ488_2==-8 // missing variable code
replace mmiss=. if RQ487_2<2018 


* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ488_2 if mmiss!=.
replace exactvalue=99999999 if mmiss==1
gen double lowervalue = 0 if mmiss==1
replace lowervalue = 50000 if mmiss==1 & RQ489_2==5
gen double uppervalue = 99999996 if mmiss==1
replace uppervalue = 50000 if mmiss==1 & RQ489_2==1

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen h15iluyr2=exactvalue
replace h15iluyr2=0 if RQ487_2!=2019 & RIWYEAR==2020
replace h15iluyr2=0 if RQ487_2!=2020 & RIWYEAR==2021

gen h15ifiluyr2=1 if RQ488_2<9999998 & RQ488_2!=-8 & RQ487_2>=2019
replace h15ifiluyr2=2 if (RQ488_2>=9999997 & RQ488_2!=.) | RQ488_2==-8 
replace h15ifiluyr2=3 if RQ488_2==0 | RQ483_1 ==5  | RQ483_2 ==5 |  RQ487_2<2019 
replace h15ifiluyr2=4 if inlist(RQ483_2,8,9,-8)

drop exactvalue uppervalue lowervalue

*lumpsum #3

gen mmiss=.
replace RQ488_3=50000 if RQ489_3==3
replace mmiss= 0 if RQ488_3<99998 // donor group
replace mmiss= 1 if RQ488_3>99997 & RQ488_3<1999999999 // missing variable code
replace mmiss= 1 if RQ488_3==-8 // missing variable code
replace mmiss=. if RQ487_3<2018 

*no missings
sum mmiss

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ488_3 if mmiss!=.
replace exactvalue=99999999 if mmiss==1
gen double lowervalue = 0 if mmiss==1
replace lowervalue = 50000 if mmiss==1 & RQ489_3==5
gen double uppervalue = 99999996 if mmiss==1
replace uppervalue = 50000 if mmiss==1 & RQ489_3==1

replace exactvalue=0 if exactvalue==.


* Replace variable with imputation
gen h15iluyr3=exactvalue
replace h15iluyr3=0 if RQ487_3!=2019 & RIWYEAR==2020
replace h15iluyr3=0 if RQ487_3!=2020 & RIWYEAR==2021

gen h15ifiluyr3=1 if RQ488_3<99998 & RQ488_3!=-8 & RQ487_3>=2019
replace h15ifiluyr3=2 if (RQ488_3>=99997 & RQ488_3!=.) | RQ488_3==-8 
replace h15ifiluyr3=3 if RQ488_3==0 | RQ483_1 ==5  | RQ483_2 ==5  | RQ483_3 ==5 |  RQ487_3<2019 
replace h15ifiluyr3=4 if inlist(RQ483_3,8,9,-8)

drop exactvalue uppervalue lowervalue

egen h15iothr=rowtotal(h15iothi2 h15iluyr*),m

gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid h15i*
save "$folder\wave15\otherinc_15.dta",replace
