*pension and annuity income* INCOMPLETE APPENDIX C IN RAND IMPUTATIONS CODEBOOK
*for non-financial respondent, use section Q (income section). For financial respondents : if positive value reported in section Q, use that only. If not, use the pension section.


clear

*load the imputation program
do "$main/imputethis.do"


use "$rawfolder\hrs2020\h20q_h.dta",clear
rename hhid HHID
gen PN=RPN_FIN
rename rsubhh RSUBHH
merge 1:1 HHID RSUBHH PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(RIWYEAR)
rename  RSUBHH rsubhh
* -----------------
* respondent pension income
* -----------------

*RQ215: currently receiving any other income from retirement pnesions?
*RQ216: who r/sp?
*RQ217: more than one pension?
*RQ218: number of pensions?


*pension 1

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ220_1<99998 // donor group
replace mmiss= 1 if RQ220_1>99997 & RQ220_1<1999999999 // missing variable code
replace mmiss= 1 if RQ220_1==-8 | inlist(RQ218,98,99,-8) // missing variable code

* if any coding is needed
replace RQ221_1= 0 if RQ221_1==. & mmiss==1      
replace RQ222_1=99999996 if RQ222_1==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ220_1
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ221_1
gen double uppervalue = RQ222_1

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15ipen1=exactvalue
gen r15ifpen1=1 if RQ220_1<99998 & RQ220_1!=-8
replace r15ifpen1=2 if (RQ220_1>=99998 & RQ220_1!=.) | RQ220_1==-8 | inlist(RQ218,98,99,-8)
replace r15ifpen1=3 if RQ220_1==0 | RQ215==5 |  RQ216==2
replace r15ifpen1=4 if inlist(RQ215,8,9,-8) | inlist(RQ216,8,9,-8)
*partial interview?
replace r15ifpen1=5 if RQ215==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue

replace RIWYEAR=2020 if RIWYEAR==.
gen months1=12
replace months1=RQ232_1 if RQ231_1==2019 & !inlist(RQ232_1,-8,98,99) & RIWYEAR==2020
replace months1=RQ232_1 if RQ231_1==2020 & !inlist(RQ232_1,-8,98,99) & RIWYEAR==2021

replace r15ipen1=r15ipen1*months1

*pension 2

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ220_2<9998 // donor group
replace mmiss= 1 if RQ220_2>9997 & RQ220_2<1999999999 // missing variable code
replace mmiss= 1 if RQ220_2==-8  // missing variable code

* if any coding is needed
replace RQ221_2= 0 if RQ221_2==. & mmiss==1      
replace RQ222_2=99999996 if RQ222_2==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ220_2
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ221_2
gen double uppervalue = RQ222_2

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15ipen2=exactvalue
gen r15ifpen2=1 if RQ220_2<9998 & RQ220_2!=-8
replace r15ifpen2=2 if (RQ220_2>=9998 & RQ220_2!=.) | RQ220_2==-8 
replace r15ifpen2=3 if RQ220_2==0 | RQ215==5 |  RQ216==2 | RQ218==1
replace r15ifpen2=4 if inlist(RQ215,8,9,-8) | inlist(RQ216,8,9,-8)
*partial interview?
replace r15ifpen2=5 if RQ215==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue

gen months2=12
replace months2=RQ232_2 if RQ231_2==2019 & !inlist(RQ232_2,-8,98,99) & RIWYEAR==2020
replace months2=RQ232_2 if RQ231_2==2020 & !inlist(RQ232_2,-8,98,99) & RIWYEAR==2021

replace r15ipen2=r15ipen2*months2

*other amount

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ238<9998 // donor group
replace mmiss= 1 if RQ238>9997 & RQ238<1999999999 // missing variable code
replace mmiss= 1 if RQ238==-8  // missing variable code

* if any coding is needed
replace RQ239= 0 if RQ239==. & mmiss==1      
replace RQ240=99999996 if RQ240==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ238
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ239
gen double uppervalue = RQ240

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15ipen3=exactvalue*12
gen r15ifpen3=1 if RQ238<9998 & RQ238!=-8
replace r15ifpen3=2 if (RQ238>=9998 & RQ238!=.) | RQ238==-8 
replace r15ifpen3=3 if RQ238==0 | RQ238==.


drop exactvalue uppervalue lowervalue


egen r15ipen=rowtotal(r15ipen1 r15ipen2 r15ipen3),m
drop months*

*if zero, use the amount from J2 section

* -----------------
* respondent annuity income
* -----------------
*annuity 1

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ278_1<99998 // donor group
replace mmiss= 1 if RQ278_1>99997 & RQ278_1<1999999999 // missing variable code
replace mmiss= 1 if RQ278_1==-8 | inlist(RQ276,98,99,-8) // missing variable code

* if any coding is needed
replace RQ279_1= 0 if RQ279_1==. & mmiss==1      
replace RQ280_1=99999996 if RQ280_1==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ278_1
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ279_1
gen double uppervalue = RQ280_1

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15iann1=exactvalue
gen r15ifann1=1 if RQ278_1<99998 & RQ278_1!=-8
replace r15ifann1=2 if (RQ278_1>=99998 & RQ278_1!=.) | RQ278_1==-8 | inlist(RQ276,98,99,-8)
replace r15ifann1=3 if RQ278_1==0 | RQ273==5 |  RQ274==2
replace r15ifann1=4 if inlist(RQ273,8,9,-8) | inlist(RQ274,8,9,-8)
*partial interview?
replace r15ifann1=5 if RQ273==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue


gen months1=12
replace months1=RQ284_1 if RQ283_1==2019 & !inlist(RQ284_1,-8,98,99) & RIWYEAR==2020
replace months1=RQ284_1 if RQ283_1==2020 & !inlist(RQ284_1,-8,98,99) & RIWYEAR==2021

replace r15iann1=r15iann1*months1

*annuity 2

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ278_2<99998 // donor group
replace mmiss= 1 if RQ278_2>99997 & RQ278_2<1999999999 // missing variable code
replace mmiss= 1 if RQ278_2==-8  // missing variable code

* if any coding is needed
replace RQ279_2= 0 if RQ279_2==. & mmiss==1      
replace RQ280_2=99999996 if RQ280_2==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ278_2
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ279_2
gen double uppervalue = RQ280_2

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15iann2=exactvalue
gen r15ifann2=1 if RQ278_2<99998 & RQ278_2!=-8
replace r15ifann2=2 if (RQ278_2>=99998 & RQ278_2!=.) | RQ278_2==-8 
replace r15ifann2=3 if RQ278_2==0 | RQ273==5 |   RQ274==2 | RQ276==1
replace r15ifann2=4 if inlist(RQ273,8,9,-8) | inlist(RQ274,8,9,-8)
*partial interview?
replace r15ifann2=5 if RQ273==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue

gen months2=12
replace months2=RQ284_2 if RQ283_2==2019 & !inlist(RQ284_2,-8,98,99) & RIWYEAR==2020
replace months2=RQ284_2 if RQ283_2==2020 & !inlist(RQ284_2,-8,98,99) & RIWYEAR==2021

replace r15iann2=r15iann2*months2

*other annuity

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ290<99998 // donor group
replace mmiss= 1 if RQ290>99997 & RQ290<1999999999 // missing variable code
replace mmiss= 1 if RQ290==-8  // missing variable code

* if any coding is needed
replace RQ291= 0 if RQ291==. & mmiss==1      
replace RQ292=99999996 if RQ292==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ290
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ291
gen double uppervalue = RQ292

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15iann3=exactvalue*12
gen r15ifann3=1 if RQ290<99998 & RQ290!=-8
replace r15ifann3=2 if (RQ290>=99998 & RQ290!=.) | RQ290==-8 
replace r15ifann3=3 if RQ290==0 | RQ290==.


drop exactvalue uppervalue lowervalue

*gen r15iann4=RQ527 if RQ527<9998


egen r15iann=rowtotal(r15iann1 r15iann2 r15iann3),m
drop months*

* -----------------
* spouse pension income
* -----------------
*pension 1

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ246_1<99998 // donor group
replace mmiss= 1 if RQ246_1>99997 & RQ246_1<1999999999 // missing variable code
replace mmiss= 1 if RQ246_1==-8 | inlist(RQ244,98,99,-8) // missing variable code

* if any coding is needed
replace RQ247_1= 0 if RQ247_1==. & mmiss==1      
replace RQ248_1=99999996 if RQ248_1==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ246_1
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ247_1
gen double uppervalue = RQ248_1

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15ipen1=exactvalue
gen s15ifpen1=1 if RQ246_1<99998 & RQ246_1!=-8
replace s15ifpen1=2 if (RQ246_1>=99998 & RQ246_1!=.) | RQ246_1==-8 | inlist(RQ244,98,99,-8)
replace s15ifpen1=3 if RQ246_1==0 | RQ215==5 |  RQ216==1
replace s15ifpen1=4 if inlist(RQ215,8,9,-8) | inlist(RQ216,8,9,-8)
*partial interview?
replace s15ifpen1=5 if RQ215==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue


gen months1=12
replace months1=RQ258_1 if RQ257_1==2019 & !inlist(RQ258_1,-8,98,99) & RIWYEAR==2020
replace months1=RQ258_1 if RQ257_1==2020 & !inlist(RQ258_1,-8,98,99) & RIWYEAR==2021

replace s15ipen1=s15ipen1*months1

*pension 2

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ246_2<9998 // donor group
replace mmiss= 1 if RQ246_2>9997 & RQ246_2<1999999999 // missing variable code
replace mmiss= 1 if RQ246_2==-8  // missing variable code

* if any coding is needed
replace RQ247_2= 0 if RQ247_2==. & mmiss==1      
replace RQ248_2=99999996 if RQ248_2==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ246_2
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ247_2
gen double uppervalue = RQ248_2

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15ipen2=exactvalue
gen s15ifpen2=1 if RQ246_2<9998 & RQ246_2!=-8
replace s15ifpen2=2 if (RQ246_2>=9998 & RQ246_2!=.) | RQ246_2==-8 
replace s15ifpen2=3 if RQ246_2==0 | RQ215==5 |  RQ216==1 | RQ244==1
replace s15ifpen2=4 if inlist(RQ215,8,9,-8) | inlist(RQ216,8,9,-8)
*partial interview?
replace s15ifpen2=5 if RQ215==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue

gen months2=12
replace months2=RQ258_2 if RQ257_2==2019 & !inlist(RQ258_2,-8,98,99) & RIWYEAR==2020
replace months2=RQ258_2 if RQ257_2==2020 & !inlist(RQ258_2,-8,98,99) & RIWYEAR==2021

replace s15ipen2=s15ipen2*months2

* pension 3
* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ264<9998 // donor group
replace mmiss= 1 if RQ264>9997 & RQ264<1999999999 // missing variable code
replace mmiss= 1 if RQ264==-8  // missing variable code

* if any coding is needed
replace RQ265= 0 if RQ265==. & mmiss==1      
replace RQ266=99999996 if RQ266==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ264
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ265
gen double uppervalue = RQ266

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15ipen3=exactvalue*12
gen s15ifpen3=1 if RQ264<9998 & RQ264!=-8
replace s15ifpen3=2 if (RQ264>=9998 & RQ264!=.) | RQ264==-8 
replace s15ifpen3=3 if RQ264==0 | RQ264==.


drop exactvalue uppervalue lowervalue


egen s15ipen=rowtotal(s15ipen1 s15ipen2 s15ipen3),m
drop months*

* -----------------
* spouse annuity income
* -----------------

*annsuity 1

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ298_1<9998 // donor group
replace mmiss= 1 if RQ298_1>9997 & RQ298_1<1999999999 // missing variable code
replace mmiss= 1 if RQ298_1==-8 | inlist(RQ296,98,99,-8) // missing variable code

* if any coding is needed
replace RQ299_1= 0 if RQ299_1==. & mmiss==1      
replace RQ300_1=99999996 if RQ300_1==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ298_1
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ299_1
gen double uppervalue = RQ300_1

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15iann1=exactvalue
gen s15ifann1=1 if RQ298_1<9998 & RQ298_1!=-8
replace s15ifann1=2 if (RQ298_1>=9998 & RQ298_1!=.) | RQ298_1==-8 | inlist(RQ296,98,99,-8)
replace s15ifann1=3 if RQ298_1==0 | RQ273==5 |  RQ274==1
replace s15ifann1=4 if inlist(RQ273,8,9,-8) | inlist(RQ274,8,9,-8)
*partial interview?
replace s15ifann1=5 if RQ273==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue


gen months1=12
replace months1=RQ304_1 if RQ303_1==2019 & !inlist(RQ304_1,-8,98,99) & RIWYEAR==2020
replace months1=RQ304_1 if RQ303_1==2020 & !inlist(RQ304_1,-8,98,99) & RIWYEAR==2021

replace s15iann1=s15iann1*months1

*annuity 2

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ298_2<9998 // donor group
replace mmiss= 1 if RQ298_2>9997 & RQ298_2<1999999999 // missing variable code
replace mmiss= 1 if RQ298_2==-8  // missing variable code

* if any coding is needed
replace RQ299_2= 0 if RQ299_2==. & mmiss==1      
replace RQ300_2=99999996 if RQ300_2==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ298_2
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ299_2
gen double uppervalue = RQ300_2

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15iann2=exactvalue
gen s15ifann2=1 if RQ298_2<9998 & RQ298_2!=-8
replace s15ifann2=2 if (RQ298_2>=9998 & RQ298_2!=.) | RQ298_2==-8 
replace s15ifann2=3 if RQ298_2==0 | RQ273==5 |  RQ274==1 | RQ244==1
replace s15ifann2=4 if inlist(RQ273,8,9,-8) | inlist(RQ274,8,9,-8)
*partial interview?
replace s15ifann2=5 if RQ273==. & RPN_FIN!=""


drop exactvalue uppervalue lowervalue

gen months2=12
replace months2=RQ304_2 if RQ303_2==2019 & !inlist(RQ304_2,-8,98,99) & RIWYEAR==2020
replace months2=RQ304_2 if RQ303_2==2020 & !inlist(RQ304_2,-8,98,99) & RIWYEAR==2021

replace s15iann2=s15iann2*months2

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if RQ310<998 // donor group
replace mmiss= 1 if RQ310>997 & RQ310<1999999999 // missing variable code
replace mmiss= 1 if RQ310==-8  // missing variable code

* if any coding is needed
replace RQ311= 0 if RQ311==. & mmiss==1      
replace RQ312=99999996 if RQ312==. & mmiss==1    
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ310
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ311
gen double uppervalue = RQ312

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen s15iann3=exactvalue*12
gen s15ifann3=1 if RQ310<998 & RQ310!=-8
replace s15ifann3=2 if (RQ310>=998 & RQ310!=.) | RQ310==-8 
replace s15ifann3=3 if RQ310==0 | RQ310==.


drop exactvalue uppervalue lowervalue

rename rsubhh RSUBHH
egen s15iann=rowtotal(s15iann1 s15iann2 s15iann3),m
drop months*
keep HHID RSUBHH RPN_FIN RPN_NFIN r15* s15*

save "$folder\wave15\pension_part1.dta",replace

*only do this for financial respondent
use "$rawfolder\hrs2020\h20j2_p.dta",clear
rename hhid HHID
gen PN=pn


*receiving benefits or annuity
keep if RJ2W434==1 | RJ2W440==1


*benefits (pension)

gen mmiss=.
replace mmiss= 0 if RJ2W015<999998  // donor group
replace mmiss= 1 if RJ2W015>999997 & RJ2W015<1999999999 // missing variable code
replace mmiss= 1 if RJ2W015==-8  // missing variable code

*assume they received for all 12 months
replace RJ2W015=RJ2W015*12 if RJ2W016==4
 
* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RJ2W015
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = 0
gen double uppervalue = 999999996

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15ipen_=0
replace r15ipen_=exactvalue if RJ2W434==1 
*there are 3 accounts with both annuity and benefit - take it as pension
gen r15iann_=0
replace r15iann_=exactvalue if RJ2W108==1 & RJ2W434==5 

gen r15ifpena_=1 if RJ2W015<999998 & RJ2W015!=-8
replace r15ifpena_=2 if (RJ2W015>=999998 & RJ2W015!=.) | RJ2W015==-8 
replace r15ifpena_=3 if RJ2W015==0 | (RJ2W434==5 & RJ2W108!=1)
*there is one person with  missing flag, they are receving benefits (434==1) but nothing else reported make flag 3
replace r15ifpena_=3 if RJ2W015==. & (RJ2W434==1)

drop exactvalue lowervalue uppervalue

collapse (sum) r15ipen_ r15iann,by(HHID PN)


gen RPN_FIN=PN

save "$folder\wave15\pension_part2.dta",replace

use "$folder\wave15\pension_part1.dta",clear
gen aux=_n*(-1)
tostring aux,replace
replace RPN_FIN=aux if RPN_FIN==""
merge 1:1 HHID RPN_FIN using  "$folder\wave15\pension_part2.dta"
drop if _m==2
replace r15ipen_=0 if _m==1
replace r15iann_=0 if _m==1
drop aux _m

replace r15ipen=r15ipen_ if r15ipen==0 & r15ipen_!=0
replace r15iann=r15iann_ if r15iann==0 & r15iann_==0

drop *1 *2 *3 *_

gen h15hhid=HHID+RSUBHH
destring h15hhid,replace

keep h15hhid r15* s15*
save "$folder\wave15\pension_15.dta",replace
