*CALCULATES THE ADDITIONAL AMOUNT THAT WOULD NEED TO BE WITHDRAWN TO SATISFY IRS RMD rules


*Table 3
import excel "$data\rmd tables.xlsx", sheet("Table3") clear
rename A age
rename B le
save "$folder\table3.dta",replace

*Table 2
import excel "$data\rmd tables.xlsx", sheet("Table2") cellrange(A1:CC62) firstrow clear
rename Ages age
reshape long a, i(age) j(spage)
rename a le2

save "$folder\table2.dta",replace



*since ira wealth is at the household level in RAND, rmd will be based on their age.
use "$rand\randhrs1992_2020v1.dta" ,clear
merge 1:1 hhidpn using "$folder/dcw.dta", nogen keep(1 3)

forvalues i=1/15{
	egen h`i'dcwy1=rowtotal(r`i'dcw s`i'dcw),m
}



keep hhidpn h*hhid s*hhidpn r*mstat r*agey_m s*agey_m h*dcwy1 h*aira h*iirawy1
merge 1:1 hhidpn using "${folder}\merged_pension.dta"


*there is only wave 2 IRA withdrawals before wave 5
forvalues i=5/15{
	egen tot_dcira`i'=rowtotal(h`i'dc_wth h`i'aira),m
	egen tot_dcira_w`i'=rowtotal(h`i'dcwy1 h`i'iirawy1),m
}



forvalues i=5/15{
	gen old`i'=r`i'agey_m if !missing(r`i'agey_m)
	replace old`i'=s`i'agey_m if !missing(s`i'agey_m) & s`i'agey_m>r`i'agey_m
	
	gen young`i'=r`i'agey_m if !missing(r`i'agey_m)
	replace young`i'=s`i'agey_m if !missing(s`i'agey_m) & s`i'agey_m<r`i'agey_m
	
	gen dif`i'=1 if old`i'-young`i'>10 & old`i'!=. & young`i'!=.
	
	egen average`i'=rowmean(old`i' young`i')
	replace average`i'=round(average`i')
	
	gen married`i'=1 if inrange(r`i'mstat,1,3)
	
}


*if more than 10 year older than spouse, use table 3
*if single or less than 10 year difference,  use average age using table 2

forvalues i=5/15{
	rename average`i' age 
 merge m:1 age using "$folder\table3.dta",gen(n`i') keep(1 3)
	rename age average`i'
rename old`i' age
rename young`i' spage
 merge m:1 age spage using "$folder\table2.dta",gen(m`i') keep(1 3)

 rename le r`i'_le
 rename le2	r`i'_le2
	
rename age old`i'
rename spage young`i'	
}


forvalues i=5/15{
	gen rmd`i'=0 if r`i'agey_m!=.
	replace rmd`i'=tot_dcira`i'/r`i'_le if average`i'>=71 & ((r`i'mstat!=. & married`i'==.) | (married`i'==1 & dif`i'==.))
	replace rmd`i'=tot_dcira`i'/r`i'_le2 if old`i'>=71 &  (married`i'==1 & dif`i'==1)
	
	gen rmd`i'_ad=0 if r`i'agey_m!=.
	replace rmd`i'_ad=rmd`i'-tot_dcira_w`i' if (tot_dcira_w`i'-rmd`i')<0
	
	
}

keep hhidpn rmd*_ad
save "$folder\rmd.dta",replace