*social security : supplemental, disability, and retirement

clear


*load the imputation program
do "$main/imputethis.do"

* -----------------
*turn respondent level
*do it for financial respondent first 
* -----------------

use "$rawfolder\hrs2020\h20q_h.dta",clear
gen PN=RPN_FIN
gen pn=RPN_FIN
merge 1:1 hhid rsubhh pn using "$rawfolder\hrs2020\h20m1_r.dta", keep(1 3) nogen
merge 1:1 hhid rsubhh pn using "$rawfolder\hrs2020\h20m2_r.dta", keep(1 3) nogen
merge 1:1 hhid rsubhh pn using "$rawfolder\hrs2020\h20j3_r.dta", keep(1 3) keepusing(RJ3478) nogen

*282 households don't have a financial respondent

*RJ3478 - currently receiving SS income?

/*
RQ085 R AMOUNT OF SS INCOME - LAST MONTH
RQ086 R AMT FROM SS INCOME - MIN
RQ087 R AMT FROM SS INCOME - MAX
RQ088 R AMT FROM SS INCOME - RESULT
RQ089 R YEAR STARTED TO RECEIVE SS BENEFITS
RQ090 R MONTH STARTED TO RECEIVE SS BENEFITS
*/

*impute last month's amount

rename hhid HHID
gen RSUBHH=rsubhh

merge 1:1 HHID RSUBHH PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(RIWYEAR RIWMONTH BIRTHYR BIRTHMO) nogen

gen mmiss=.
replace mmiss= 0 if RQ085<99998 // donor group
replace mmiss= 1 if RQ085>99997 & RQ085<1999999999 // missing variable code
replace mmiss= 1 if RQ085==-8 // missing variable code

*23 said yes to receiving SS but sequence wasn't asked
replace mmiss= 1 if RQ085==. & RJ3478==1
replace RQ085=99999  if RQ085==. & RJ3478==1

* if any coding is needed
replace RQ086= 0 if RQ086==. & mmiss==1      //fix annoying quirk in data
replace RQ087= 99999996 if RQ087==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ085
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ086
gen double uppervalue = RQ087

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis

*NUMBER OF MONTHS IN THE LAST CALENDAR YEAR - for first time reports of receving SS
*if not asked, assign 12
gen rmonths=0
replace rmonths=12 if RQ089==. & RQ085!=.
replace rmonths=12 if RQ089<=2018 | inlist(RQ089,9998,9999,-8)
replace rmonths=12 if RQ089==2019 & RIWYEAR==2021
replace rmonths=12 if RQ089==2019 & RIWYEAR==2020 & inlist(RQ090,-8,98)
replace rmonths=12-RQ090+1 if RQ089==2019 & RIWYEAR==2020 & !inlist(RQ090,-8,98)
replace rmonths=0 if RQ089==2021 & RIWYEAR==2021 & !inlist(RQ090,-8,98)
replace rmonths=12 if RQ089==2020 & RIWYEAR==2021 & inlist(RQ090,-8,98)
replace rmonths=12-RQ090+1 if RQ089==2020 & RIWYEAR==2021 & !inlist(RQ090,-8,98)
replace rmonths=0 if RQ089==2021 & RIWYEAR==2021 & !inlist(RQ090,-8,98)
replace rmonths=12-RQ090 if !inlist(RQ090,-8,98) & RQ089==2019



gen r15isoc=exactvalue*rmonths
gen r15ifsoc=1 if RQ085<99998 & RQ085!=-8
replace r15ifsoc=2 if (RQ085>=99998 & RQ085!=.) | RQ085==-8
replace r15ifsoc=3 if RQ085==0 | inlist(RJ3478,5,.) 
replace r15ifsoc=4 if inlist(RJ3478,8,9,-8)


drop exactvalue uppervalue lowervalue

*need age to determine full retirement age - if above FRA, assign all to ssret - if below and receiving SSDI assign to SSDI



**********************
*disability!
***********************
*determine if they were receiving SSDI in the last calendar year

*retinterviews
gen recsdi=0
*still receving SSDI or Social Security  (not SSI)
replace recsdi=12 if RMW238A==1
replace recsdi=RMW243A if RMW238A==5 & RMW244A==2019 & !inrange(RMW243A,98,99) & RIWYEAR==2020
replace recsdi=RMW243A if RMW238A==5 & RMW244A==2020 & !inrange(RMW243A,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238A==5 & RMW244A==2019 & inrange(RMW243A,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238A==5 & RMW244A==2020 & inrange(RMW243A,98,99) & RIWYEAR==2021

replace recsdi=12 if RMW238C==1
replace recsdi=RMW243C if RMW238C==5 & RMW244C==2019 & !inrange(RMW243C,98,99) & RIWYEAR==2020
replace recsdi=RMW243C if RMW238C==5 & RMW244C==2020 & !inrange(RMW243C,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238C==5 & RMW244C==2019 & inrange(RMW243C,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238C==5 & RMW244C==2020 & inrange(RMW243C,98,99) & RIWYEAR==2021

replace recsdi=12 if RMW238I==1
replace recsdi=RMW243I if RMW238I==5 & RMW244I==2019 & !inrange(RMW243I,98,99) & RIWYEAR==2020
replace recsdi=RMW243I if RMW238I==5 & RMW244I==2020 & !inrange(RMW243I,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238I==5 & RMW244I==2019 & inrange(RMW243I,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238I==5 & RMW244I==2020 & inrange(RMW243I,98,99) & RIWYEAR==2021




*non-reinterviews (none of the financial respondents fit this description)
/* 
replace recsdi=12 if RMW238Q==1
replace recsdi=RMW243Q if RMW238Q==5 & RMW244Q==2019 & !inrange(RMW243Q,98,99) & RIWYEAR==2020
replace recsdi=RMW243Q if RMW238Q==5 & RMW244Q==2020 & !inrange(RMW243Q,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238Q==5 & RMW244Q==2019 & inrange(RMW243Q,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238Q==5 & RMW244Q==2020 & inrange(RMW243Q,98,99) & RIWYEAR==2021

replace recsdi=12 if RMW238R==1
replace recsdi=RMW243R if RMW238R==5 & RMW244R==2019 & !inrange(RMW243R,98,99) & RIWYEAR==2020
replace recsdi=RMW243R if RMW238R==5 & RMW244R==2020 & !inrange(RMW243R,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238R==5 & RMW244R==2019 & inrange(RMW243R,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238R==5 & RMW244R==2020 & inrange(RMW243R,98,99) & RIWYEAR==2021
*/

*if starts receiving and still receiving
replace recsdi=12 if RMW238Q==1 & RMW234Q<2019 & inrange(RMW234Q,9997,9999)
replace recsdi=12 if RMW238Q==1 & RMW234Q==2019 & inrange(RMW233Q,98,99)
replace recsdi=RMW233Q if RMW238Q==1 & RMW234Q==2019 & !inrange(RMW233Q,98,99)
*was receiving and stopped receiving within LCY - no such cases in 2020

*receives from second application
replace recsdi=12 if RMW238R==1 & RMW234R<2019 & inrange(RMW234R,9997,9999)
replace recsdi=12 if RMW238R==1 & RMW234R==2019 & inrange(RMW233R,98,99)
replace recsdi=RMW233R if RMW238R==1 & RMW234R==2019 & !inrange(RMW233R,98,99)

*was receiving and stopped receiving within LCY - no such cases in 2020


gen age=(RIWYEAR-BIRTHYR-1)+(12-(BIRTHMO-RIWMONTH))/12  if RIWMONTH<=BIRTHMO & BIRTHMO!=.
replace age=(RIWYEAR-BIRTHYR)+(BIRTHMO-RIWMONTH)/12 if RIWMONTH>BIRTHMO & BIRTHMO!=.

*there are those without interview date (there are 35 people not in tracker file)
*282 households without a financial respondent

gen aboveFRA=0
replace aboveFRA=1 if age>=65 & BIRTHYR<=1937
replace aboveFRA=1 if age>=65+2/12 & BIRTHYR==1938
replace aboveFRA=1 if age>=65+4/12 & BIRTHYR==1939
replace aboveFRA=1 if age>=65+6/12 & BIRTHYR==1940
replace aboveFRA=1 if age>=65+8/12 & BIRTHYR==1941
replace aboveFRA=1 if age>=65+10/12 & BIRTHYR==1942
replace aboveFRA=1 if age>=66 & inrange(BIRTHYR,1943,1954)
replace aboveFRA=1 if age>=66+2/12 & BIRTHYR==1955
replace aboveFRA=1 if age>=66+4/12 & BIRTHYR==1956
replace aboveFRA=1 if age>=66+6/12 & BIRTHYR==1957
replace aboveFRA=1 if age>=66+8/12 & BIRTHYR==1958
replace aboveFRA=1 if age>=66+10/12 & BIRTHYR==1959
replace aboveFRA=1 if age>=67 & BIRTHYR>=1960 & BIRTHYR!=.

gen r15isret=0
replace r15isret=r15isoc if recsdi==0 | aboveFRA==1
gen r15isdi=0
replace r15isdi=r15isoc if recsdi!=0 & aboveFRA==0


*income from SSI


gen mmiss=.
replace mmiss= 0 if RQ107<9998 // donor group
replace mmiss= 1 if RQ107>9997 & RQ107<1999999999 // missing variable code
replace mmiss= 1 if RQ107==-8 // missing variable code

* if any coding is needed
replace RQ108= 0 if RQ108==. & mmiss==1      //fix annoying quirk in data
replace RQ109= 99999996 if RQ109==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ107
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ108
gen double uppervalue = RQ109

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis

gen rmonths2=0
replace rmonths2=12 if RQ111==. & RQ117!=.
replace rmonths2=12 if RQ111<=2018 | inlist(RQ111,9998,9999,-8)
replace rmonths2=12 if RQ111==2019 & RIWYEAR==2021
replace rmonths2=12 if RQ111==2019 & RIWYEAR==2020 & inlist(RQ112,-8,98)
replace rmonths2=12-RQ112+1 if RQ111==2019 & RIWYEAR==2020 & !inlist(RQ112,-8,98)
replace rmonths2=0 if RQ111==2021 & RIWYEAR==2021 & !inlist(RQ112,-8,98)
replace rmonths2=12 if RQ111==2020 & RIWYEAR==2021 & inlist(RQ112,-8,98)
replace rmonths2=12-RQ112+1 if RQ111==2020 & RIWYEAR==2021 & !inlist(RQ112,-8,98)
replace rmonths2=0 if RQ111==2021 & RIWYEAR==2021 & !inlist(RQ112,-8,98)
replace rmonths2=12-RQ112 if !inlist(RQ112,-8,98) & RQ111==2019



* Replace variable with imputation
gen r15issi=exactvalue*rmonths2
replace r15issi=exactvalue*rmonths2/2 if inlist(RQ106,3,8,9,-8)
replace r15issi=0 if RQ106==2

gen s15issi=exactvalue*rmonths2
replace s15issi=exactvalue*rmonths2/2 if inlist(RQ106,3,8,9,-8)
replace s15issi=0 if RQ106==1

gen r15ifssi=1 if RQ107<9998 & RQ107!=-8
replace r15ifssi=2 if (RQ107>=9998 & RQ107!=.) | RQ107==-8
replace r15ifssi=3 if RQ107==0 | inlist(RQ105,5,.) |  (RQ105==1 & RQ106==2)
replace r15ifssi=4 if inlist(RQ105,8,9,-8)

drop exactvalue uppervalue lowervalue

keep HHID rsubhh RPN_FIN PN pn r15isret r15isdi r15isoc r15issi r15ifssi r15ifsoc s15issi
save "$folder\wave15\r_ssa_15.dta",replace


*-----------------------------------------------*
*             SPOUSE                            *
*-----------------------------------------------*
use "$rawfolder\hrs2020\h20q_h.dta",clear
gen PN=RPN_NFIN
gen pn=RPN_NFIN
merge 1:1 hhid rsubhh pn using "$rawfolder\hrs2020\h20m1_r.dta", keep(3) nogen
merge 1:1 hhid rsubhh pn using "$rawfolder\hrs2020\h20m2_r.dta", keep(3) nogen
merge 1:1 hhid rsubhh pn using "$rawfolder\hrs2020\h20j3_r.dta", keep(3) keepusing(RJ3478) nogen

*282 households don't have a financial respondent

*first use self-report, if missing use financial respondent's report
*RJ3478 - currently receiving SS income?
*RQ084 - SP social security income

/*
RQ091 R AMOUNT OF SS INCOME - LAST MONTH
RQ092 R AMT FROM SS INCOME - MIN
RQ093 R AMT FROM SS INCOME - MAX
RQ094 R AMT FROM SS INCOME - RESULT
RQ095 R YEAR STARTED TO RECEIVE SS BENEFITS
RQ096 R MONTH STARTED TO RECEIVE SS BENEFITS
*/

*impute last month's amount

rename hhid HHID
gen RSUBHH=rsubhh

*one spouse is not in the tracker
merge 1:1 HHID RSUBHH PN using "$rawfolder\trk2020tr_r.dta", keep(1 3) keepusing(RIWYEAR RIWMONTH BIRTHYR BIRTHMO) nogen

gen s_has_ss=0
replace s_has_ss=1 if RJ3478==1
replace s_has_ss=1 if inlist(RJ3478,-8,8,9,.) & RQ084==1

gen mmiss=.
replace mmiss= 0 if RQ091<99998 // donor group
replace mmiss= 1 if RQ091>99997 & RQ091<1999999999 // missing variable code
replace mmiss= 1 if RQ091==-8 // missing variable code

replace mmiss= 1 if RQ091==. & (s_has_ss==1)
replace RQ091=99999  if RQ091==. & (s_has_ss==1)

* if any coding is needed
replace RQ092= 0 if RQ092==. & mmiss==1      
replace RQ093= 99999996 if RQ093==. & mmiss==1    

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ091
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ092
gen double uppervalue = RQ093

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis

*NUMBER OF MONTHS IN THE LAST CALENDAR YEAR - for first time reports of receving SS
*if not asked, assign 12
gen smonths=0
replace smonths=12 if RQ095==. & RQ091!=.
replace smonths=12 if RQ095<=2018 | inlist(RQ095,9998,9999,-8)
replace smonths=12 if RQ095==2019 & RIWYEAR==2021
replace smonths=12 if RQ095==2019 & RIWYEAR==2020 & inlist(RQ096,-8,98)
replace smonths=12-RQ096+1 if RQ095==2019 & RIWYEAR==2020 & !inlist(RQ096,-8,98)
replace smonths=0 if RQ095==2021 & RIWYEAR==2021 & !inlist(RQ096,-8,98)
replace smonths=12 if RQ095==2020 & RIWYEAR==2021 & inlist(RQ096,-8,98)
replace smonths=12-RQ096+1 if RQ095==2020 & RIWYEAR==2021 & !inlist(RQ096,-8,98)
replace smonths=0 if RQ095==2021 & RIWYEAR==2021 & !inlist(RQ096,-8,98)
replace smonths=12-RQ096 if !inlist(RQ096,-8,98) & RQ095==2019



gen s15isoc=exactvalue*smonths
gen s15ifsoc=1 if RQ091<99998 & RQ091!=-8
replace s15ifsoc=2 if (RQ091>=99998 & RQ091!=.) | RQ091==-8 | (s_has_ss==1 & RQ091==.)
replace s15ifsoc=3 if RQ091==0 | s_has_ss==0 
replace s15ifsoc=4 if inlist(RJ3478,8,9,-8) & inlist(RQ084,8,9,-8,.)


drop exactvalue uppervalue lowervalue

*need age to determine full retirement age - if above FRA, assign all to ssret - if below and receiving SSDI assign to SSDI


**********************
*disability!
***********************
*determine if they were receiving SSDI in the last calendar year

*retinterviews
gen recsdi=0
*still receving SSDI or Social Security  (not SSI)
replace recsdi=12 if RMW238A==1
replace recsdi=RMW243A if RMW238A==5 & RMW244A==2019 & !inrange(RMW243A,98,99) & RIWYEAR==2020
replace recsdi=RMW243A if RMW238A==5 & RMW244A==2020 & !inrange(RMW243A,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238A==5 & RMW244A==2019 & inrange(RMW243A,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238A==5 & RMW244A==2020 & inrange(RMW243A,98,99) & RIWYEAR==2021

replace recsdi=12 if RMW238C==1
replace recsdi=RMW243C if RMW238C==5 & RMW244C==2019 & !inrange(RMW243C,98,99) & RIWYEAR==2020
replace recsdi=RMW243C if RMW238C==5 & RMW244C==2020 & !inrange(RMW243C,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238C==5 & RMW244C==2019 & inrange(RMW243C,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238C==5 & RMW244C==2020 & inrange(RMW243C,98,99) & RIWYEAR==2021

replace recsdi=12 if RMW238I==1
replace recsdi=RMW243I if RMW238I==5 & RMW244I==2019 & !inrange(RMW243I,98,99) & RIWYEAR==2020
replace recsdi=RMW243I if RMW238I==5 & RMW244I==2020 & !inrange(RMW243I,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238I==5 & RMW244I==2019 & inrange(RMW243I,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238I==5 & RMW244I==2020 & inrange(RMW243I,98,99) & RIWYEAR==2021


*non-reinterviews 
replace recsdi=12 if RMW238Q==1
replace recsdi=RMW243Q if RMW238Q==5 & RMW244Q==2019 & !inrange(RMW243Q,98,99) & RIWYEAR==2020
replace recsdi=RMW243Q if RMW238Q==5 & RMW244Q==2020 & !inrange(RMW243Q,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238Q==5 & RMW244Q==2019 & inrange(RMW243Q,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238Q==5 & RMW244Q==2020 & inrange(RMW243Q,98,99) & RIWYEAR==2021

replace recsdi=12 if RMW238R==1
replace recsdi=RMW243R if RMW238R==5 & RMW244R==2019 & !inrange(RMW243R,98,99) & RIWYEAR==2020
replace recsdi=RMW243R if RMW238R==5 & RMW244R==2020 & !inrange(RMW243R,98,99) & RIWYEAR==2021
replace recsdi=12 if RMW238R==5 & RMW244R==2019 & inrange(RMW243R,98,99) & RIWYEAR==2020
replace recsdi=12 if RMW238R==5 & RMW244R==2020 & inrange(RMW243R,98,99) & RIWYEAR==2021



gen age=(RIWYEAR-BIRTHYR-1)+(12-(BIRTHMO-RIWMONTH))/12  if RIWMONTH<=BIRTHMO & BIRTHMO!=.
replace age=(RIWYEAR-BIRTHYR)+(BIRTHMO-RIWMONTH)/12 if RIWMONTH>BIRTHMO & BIRTHMO!=.


gen aboveFRA=0
replace aboveFRA=1 if age>=65 & BIRTHYR<=1937
replace aboveFRA=1 if age>=65+2/12 & BIRTHYR==1938
replace aboveFRA=1 if age>=65+4/12 & BIRTHYR==1939
replace aboveFRA=1 if age>=65+6/12 & BIRTHYR==1940
replace aboveFRA=1 if age>=65+8/12 & BIRTHYR==1941
replace aboveFRA=1 if age>=65+10/12 & BIRTHYR==1942
replace aboveFRA=1 if age>=66 & inrange(BIRTHYR,1943,1954)
replace aboveFRA=1 if age>=66+2/12 & BIRTHYR==1955
replace aboveFRA=1 if age>=66+4/12 & BIRTHYR==1956
replace aboveFRA=1 if age>=66+6/12 & BIRTHYR==1957
replace aboveFRA=1 if age>=66+8/12 & BIRTHYR==1958
replace aboveFRA=1 if age>=66+10/12 & BIRTHYR==1959
replace aboveFRA=1 if age>=67 & BIRTHYR>=1960 & BIRTHYR!=.

gen s15isret=0
replace s15isret=s15isoc if recsdi==0 | aboveFRA==1
gen s15isdi=0
replace s15isdi=s15isoc if recsdi!=0 & aboveFRA==0

keep HHID rsubhh RPN_FIN s15isret s15isdi s15isoc s15ifsoc
save "$folder\wave15\s_ssa_15.dta",replace

*---------------------------------------------*
*merge
***************************************************


use "$folder\wave15\r_ssa_15.dta",clear
gen aux=_n*(-1)
tostring aux,replace
replace RPN_FIN=aux if RPN_FIN==""
merge 1:1 HHID rsubhh RPN_FIN using "$folder\wave15\s_ssa_15.dta"

*(for every _m=2, there is a _m=1 in same hhid rsubhh -same household -no FR household)
*for households with missing financial respondent, values are imputed in the spouse section:
drop if RPN_FIN==""
destring RPN_FIN,gen(a2)
replace RPN_FIN="" if a2<0
drop aux a2 _merge

gen h15hhid=HHID+rsubhh
destring h15hhid,replace
save "$folder\wave15\ssa_15.dta",replace

*may need to make spouse values  of no FR respondents zero as well to be consistent with other measures