*unemployment and worker's compensation

clear

*load the imputation program
do "$main/imputethis.do"

* -----------------
* START CODING HERE
* -----------------

use "$rawfolder\hrs2020\h20q_h.dta",clear

rename hhid HHID
gen PN=RPN_FIN

* -----------------
* respondent unemployment
* -----------------

* Code missings (input for imputation code)

gen mmiss=.
replace mmiss= 0 if RQ066<99998 // donor group
replace mmiss= 1 if RQ066>99997 & RQ066<1999999999 // missing variable code
replace mmiss= 1 if RQ066==-8 // missing variable code

* if any coding is needed
replace RQ067= 0 if RQ067==. & mmiss==1      //fix annoying quirk in data
replace RQ068= 99999996 if RQ068==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ066
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ067
gen double uppervalue = RQ068

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
gen r15iunem=exactvalue
gen r15ifunem=1 if RQ066<99998 & RQ066!=-8
replace r15ifunem=2 if (RQ066>=99998 & RQ066!=.) | RQ066==-8
replace r15ifunem=3 if RQ066==0 | inlist(RQ064,5,.) |  (RQ064==1 & RQ065==2)
replace r15ifunem=4 if inlist(RQ064,8,9,-8)

drop exactvalue uppervalue lowervalue
* -------------------
* spouse unemployment
* -------------------


gen mmiss=.
replace mmiss= 0 if RQ070<99998 // donor group
replace mmiss= 1 if RQ070>99997 & RQ070<1999999999 // missing variable code
replace mmiss= 1 if RQ070==-8 // missing variable code

* if any coding is needed
replace RQ071= 0 if RQ071==. & mmiss==1      //fix annoying quirk in data
replace RQ072= 99999996 if RQ072==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ070
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ071
gen double uppervalue = RQ072

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation

gen s15iunem=exactvalue
gen s15ifunem=1 if RQ070<99998 & RQ070!=-8
replace s15ifunem=2 if (RQ070>=99998 & RQ070!=.) | RQ070==-8
replace s15ifunem=3 if RQ070==0 | inlist(RQ064,5,.) |  (RQ064==1 & RQ065==1)
replace s15ifunem=4 if inlist(RQ064,8,9,-8)

drop exactvalue uppervalue lowervalue

* -----------------
* respondent workers compensition
* -----------------


gen mmiss=.
replace mmiss= 0 if RQ076<99998 // donor group
replace mmiss= 1 if RQ076>99997 & RQ076<1999999999 // missing variable code
replace mmiss= 1 if RQ076==-8 // missing variable code

* if any coding is needed
replace RQ077= 0 if RQ077==. & mmiss==1      //fix annoying quirk in data
replace RQ078= 99999996 if RQ078==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ076
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ077
gen double uppervalue = RQ078

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
* Replace variable with imputation
gen r15iwcmp=exactvalue
gen r15ifwcmp=1 if RQ076<99998 & RQ076!=-8
replace r15ifwcmp=2 if (RQ076>=99998 & RQ076!=.) | RQ076==-8
replace r15ifwcmp=3 if RQ076==0 | inlist(RQ074,5,.) |  (RQ074==1 & RQ075==2)
replace r15ifwcmp=4 if inlist(RQ074,8,9,-8)

drop exactvalue uppervalue lowervalue

* -----------------
* spouse workers compensition
* -----------------


gen mmiss=.
replace mmiss= 0 if RQ080<99998 // donor group
replace mmiss= 1 if RQ080>99997 & RQ080<1999999999 // missing variable code
replace mmiss= 1 if RQ080==-8 // missing variable code

* if any coding is needed
replace RQ081= 0 if RQ081==. & mmiss==1      //fix annoying quirk in data
replace RQ082= 99999996 if RQ082==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = RQ080
replace exactvalue = 999999999 if mmiss==1
gen double lowervalue = RQ081
gen double uppervalue = RQ082

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999999 & exactvalue<.
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Replace variable with imputation
* Replace variable with imputation
gen s15iwcmp=exactvalue
gen s15ifwcmp=1 if RQ080<99998 & RQ080!=-8
replace s15ifwcmp=2 if (RQ080>=99998 & RQ080!=.) | RQ080==-8
replace s15ifwcmp=3 if RQ080==0 | inlist(RQ074,5,.) |  (RQ074==1 & RQ075==1)
replace s15ifwcmp=4 if inlist(RQ074,8,9,-8)

drop exactvalue uppervalue lowervalue

egen r15iunwc=rowtotal(r15iunem r15iwcmp )
egen s15iunwc=rowtotal(s15iunem s15iwcmp)

gen h15hhid=HHID+rsubhh
destring h15hhid,replace
keep h15hhid r15i* s15i* 
save "$folder\wave15\unempwc15.dta",replace
