*         PRESENT VALUE OF DB WEALTH in 2014

*OPTION: If you want to use GST discount rate (5.8), uncomment  line 314 and comment out line 316.







do "$do/imputethis.do"

use "${rawHRS}\hrs2014\H14J_P.dta",clear
merge m:1 HHID OSUBHH PN using "${rawHRS}\trk2020tr_r.dta", keepusing(OAGE BIRTHYR) nogen keep(3)

rename O* w12*

* # of pension records (raw data), # of individuals who are currently working for pay or have previous pension records in section PR_P (preloaded pension plans)
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn
count
codebook hhidpn

********************************************************************************
*	Drops plans that are inactive or not verified
********************************************************************************
* preloaded previous mentioned plans: w12J2Z139 could be as many as 7 plans
gen plan_prevwv = w12J2Z139
* Verified whether never have such preloaded pension plan. will be used to fix previous pension data in v2
gen verified = (w12J2W402==1)
* new plans (new people or new job or new plan)
gen plan_thiswv = 1 if w12J2W401==1
* plan active or dead
* dead plan assignment rules: page 7 of J2-QN. If active/dead missing, could be 1) W402 Verify failed 2) W404 lost all or DK/RF
gen plan_active = 0 if w12J2W451==1
replace plan_active = 1 if w12J2W451==5

*Some plans are inactive.

* For DB plans
*need: plan_exp_age, plan_exp_benamt, plantype, plan_exp_benpct, plan_now_benamt, plan_exp_bensum, plan_now_ten 

*Plan type
gen plan_db = inlist(w12J2338,1,3)
replace plan_db=0 if w12J2338==3 & !inlist(w12J2W407,2,16,97,98,99) // Unless DC type is reported, categorize "both" as DB
replace plan_db = 1 if inlist(w12J2338,8,9,.) &  inlist(w12J2W407,2,16)
replace plan_db = 1 if inlist(w12J2338,8,9,.)  & inlist(w12J2W407,.,98,99) & inlist(w12J2Z140,1,3)
replace plan_db = 1 if !inlist(w12J2W425,1,2) & (inlist(w12J2W426,1,2) | inlist(w12J2W428,1,2))
replace plan_db=0 if (w12J2929==5 |  w12J2931M1==2)
keep if plan_db==1


* 1. Amount of benefits received now in a year
* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if w12J2W015 <= 160000 // donor group
replace mmiss= 1 if inlist(w12J2W015,999998,999999) // missing variable code

* if any coding is needed
replace w12J2W015=w12J2W015 * 12 if w12J2W016 == 4

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = w12J2W015
gen double lowervalue = 0
gen double uppervalue = 160000


gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if inlist(w12J2W015,999998,999999)
replace exactvalue_imp=0  if exactvalue==.

* Impute *
gen yr=12
imputethis
drop yr


gen plan_now_benamt = exactvalue
gen plan_now_benamt_imp = 0 
replace plan_now_benamt_imp = 1 if inlist(w12J2W015,999998,999999)
drop exactvalue lowervalue uppervalue






* 2. Expected plan receiving age: (if this is missing, expected amount is missing)
gen plan_exp_age = .
replace plan_exp_age = w12J2353 if (w12J2W428==1 | w12J2W428==2) & w12J2353<=95
replace plan_exp_age = plan_exp_age + w12J2903/12 if w12J2903~=.
replace plan_exp_age = w12AGE+w12J2354 if w12J2353==96 & w12J2354<98
gen mis_exp_age=1 if w12J2353==98 | w12J2353==99 | w12J2354==98
   *if expected age is missing, use FRA
replace plan_exp_age=65 if BIRTHYR<=1937 & mis_exp_age==1
replace plan_exp_age=65+2/12 if BIRTHYR==1938 & mis_exp_age==1
replace plan_exp_age=65+4/12 if BIRTHYR==1939 & mis_exp_age==1
replace plan_exp_age=65+6/12 if BIRTHYR==1940 & mis_exp_age==1
replace plan_exp_age=65+8/12 if BIRTHYR==1941 & mis_exp_age==1
replace plan_exp_age=65+10/12 if BIRTHYR==1942 & mis_exp_age==1
replace plan_exp_age=66 if inrange(BIRTHYR,1943,1954) & mis_exp_age==1
replace plan_exp_age=66+2/12 if BIRTHYR==1955 & mis_exp_age==1
replace plan_exp_age=66+4/12 if BIRTHYR==1956 & mis_exp_age==1
replace plan_exp_age=66+6/12 if BIRTHYR==1957 & mis_exp_age==1
replace plan_exp_age=66+8/12 if BIRTHYR==1958 & mis_exp_age==1
replace plan_exp_age=66+10/12 if BIRTHYR==1959 & mis_exp_age==1
replace plan_exp_age=67 if BIRTHYR>=1960 & BIRTHYR!=. & mis_exp_age==1



* 2a plan tenure year (for proration)
gen plan_now_ten = .
replace plan_now_ten = w12J2W411 - w12J2W410 if w12J2W410<=2014+1 & w12J2W411<=2014+1
replace plan_now_ten = 2014+1 - w12J2W410 if w12J2W410<=2014+1 & w12J2W411==.
replace plan_now_ten=. if  w12J2W410>w12J2W411
replace plan_now_ten=. if plan_now_ten>75


* 3. Expected amount of benefits
gen plan_db_ben_imp = 0
* 3a Percent of payroll
gen plan_exp_benpct = .
replace plan_exp_benpct = w12J2356 if w12J2356<=100
qui: sum plan_exp_benpct,d
replace plan_db_ben_imp = 1 if plan_exp_benpct==. & w12J2356~=.
replace plan_exp_benpct = (w12J2789 + min(w12J2790,100))/2 if plan_exp_benpct==. & w12J2356~=.


* 3b Dollar amount (also impute for those with missing age)

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if w12J2357<9999998 // donor group
replace mmiss= 1 if w12J2357>9999997 & w12J2357<1999999999 // missing variable code
replace mmiss= 1 if mis_exp_age==1 // 

* if any coding is needed
replace w12J2358= 0 if w12J2358==. & mmiss==1      //fix annoying quirk in data
replace w12J2359= 99999996 if w12J2359==.  & mmiss==1    // fix annoying quirk in data
replace w12J2357= w12J2357*12 if  w12J2361==4
replace w12J2357=99999998 if mis_exp_age==1

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = w12J2357
replace exactvalue = 99999998 if mmiss==1
gen double lowervalue = w12J2358
gen double uppervalue = w12J2359


gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999998 
replace exactvalue_imp=0  if exactvalue==.

* Impute *
gen yr=12
imputethis
drop yr


gen plan_exp_benamt = exactvalue
replace plan_db_ben_imp = 1 if w12J2357>9999997 & w12J2357<1999999999
drop exactvalue lowervalue uppervalue


* 3c Lump sum amount

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if w12J2363<99999998 // donor group
replace mmiss= 1 if w12J2363>99999997 & w12J2363<1999999999 // missing variable code


* if any coding is needed
replace w12J2364= 0 if w12J2364==. & mmiss==1      //fix annoying quirk in data
replace w12J2365= 99999996 if w12J2365==.  & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = w12J2363
gen double lowervalue = w12J2364
gen double uppervalue = w12J2365



gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if exactvalue>=99999998 
replace exactvalue_imp=0  if exactvalue==.

* Impute *
gen yr=12
imputethis
drop yr


gen plan_exp_bensum = exactvalue
replace plan_db_ben_imp = 1 if w12J2363>99999997 & w12J2363<1999999999
drop exactvalue lowervalue uppervalue




keep hhidpn plan*

save "${folder}\DB_2014J.dta", replace



use "${rawHRS}\hrs2014\H14K_R.dta",clear
merge m:1 HHID NSUBHH PN using "${rawHRS}\trk2020tr_r.dta", keepusing(NAGE BIRTHYR) nogen keep(3)
rename O* w12*

* # of pension records (raw data), # of individuals who are currently working for pay or have previous pension records in section PR_P (preloaded pension plans)
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn
count
codebook hhidpn

keep if w12K031==1

local list="A B"
local j = 1
foreach x in `list' {
* 0. plan type
* Plan type (w12KW001A w12KW001B w12KW001C) 1-DB; 2-DC; 3-BOTH
gen plan_db_`j' = inlist(w12KW001`x',1,3)
replace plan_db_`j' =0 if  w12KW001`x'==3 & !inlist(w12KW082`x',2,16,97,98)

* 1. Amount of benefits received now
gen plan_now_benamt_`j' = w12KW015`x' if w12KW015`x' <= 32000
replace plan_now_benamt_`j' = plan_now_benamt_`j' * 12 if w12KW016`x' == 4
qui: sum plan_now_benamt_`j',d
replace plan_now_benamt_`j' = r(p50) if w12KW015`x' > 32000 & w12KW015`x'~=.

* 2. Expected plan receiving age: 0-not expected (indicator for expect benefit in the future); + as real age, - as in future years (convert to real age after merge to main dataset)
gen plan_exp_age_`j' = w12KW035`x'

* 3. Expected amount of benefits (none recorded in 2014)
gen plan_exp_benpct_`j' = w12KW037`x' if w12KW036`x' == 1 & w12KW037`x'<=100
gen plan_exp_benamt_`j' = w12KW038`x' if w12KW036`x' == 2 &  w12KW038`x'<9998
replace plan_exp_benamt_`j' = plan_exp_benamt_`j' * 12 if w12KW039`x' == 4
gen plan_exp_bensum_`j' = w12KW041`x' if w12KW041`x'<98

local ++j
}

keep hhidpn plan*
reshape long  plan_now_benamt_ plan_exp_age_ plan_exp_benpct_ plan_exp_benamt_ plan_exp_bensum_ plan_db_, i(hhidpn) j(plan_id)
rename *_ *

keep if plan_db==1
save "${folder}\DB_2014K.dta", replace




use "${rawHRS}\hrs2014\H14L_R.dta",clear

rename O* w12*

* # of pension records (raw data), # of individuals who are currently working for pay or have previous pension records in section PR_P (preloaded pension plans)
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn
count
codebook hhidpn

keep if w12L027==1 // included in pension plan


local list="A B E F"


local j = 1
foreach X in `list' {
* 0. plan type
* Plan type (w12KW001A w12KW001B w12KW001C) 1-DB; 2-DC; 3-BOTH
gen plan_db_`j' = inlist(w12LW001`X',1,3)
replace plan_db_`j' =0 if  w12LW001`X'==3 & !inlist(w12LW082`X',2,16,97,98)

* 1. Amount of benefits received now

gen plan_now_benamt_`j' = w12LW015`X' if w12LW015`X' <= 9997 //ok, active values<=5649
replace plan_now_benamt_`j' = plan_now_benamt_`j' * 12 if w12LW016`X' == 4
qui: sum plan_now_benamt_`j',d
replace plan_now_benamt_`j' = r(p50) if w12LW015`X' >= 9998 & w12LW015`X'~=.

* 2. Expected plan receiving age: 0-not expected (indicator for expect benefit in the future); + as real age, - as in future years (convert to real age after merge to main dataset)
gen plan_exp_age_`j' = w12LW035`X'

* 3. Expected amount of benefits
gen plan_exp_benpct_`j' = w12LW037`X' if w12LW036`X' == 1
gen plan_exp_benamt_`j' = w12LW038`X' if w12LW036`X' == 2 & w12LW038`X' <= 99997
replace plan_exp_benamt_`j' = (w12L133`X'+w12L134`X')/2 if w12LW038`X' > 99997 & w12L134`X' < 90000
replace plan_exp_benamt_`j' = plan_exp_benamt_`j' * 12 if w12LW039`X' == 4
gen plan_exp_bensum_`j' = w12LW041`X' 

local ++j
}

keep hhidpn plan*
reshape long  plan_now_benamt_ plan_exp_age_ plan_exp_benpct_ plan_exp_benamt_ plan_exp_bensum_ plan_db_, i(hhidpn) j(plan_id)
rename *_ *

keep if plan_db==1
save "${folder}\DB_2014L.dta", replace


*******append all and calculate present values

use "${folder}\DB_2014J.dta",clear
append using "${folder}\DB_2014K.dta"
append using "${folder}\DB_2014L.dta"
*append pensions mentioned in the income section
gen from_raw=1
append using "${rand}\randhrs1992_2020v1.dta",keep(r12ipen hhidpn)
drop if (r12ipen==0 | r12ipen==.) & from_raw!=1

* use RAND to get employee info such as current salary, current age
merge m:1 hhidpn using "${rand}\randhrs1992_2020v1.dta", nogen keep(3) keepusing(ragender r12agey_m r12iearn rabyear)

merge m:1 ragender rabyear using "${folder}\cumu_mort.dta", keep(3) nogen

*  1. DB Wealth

* (1) gen annual wage from RAND 
gen wage_yr = r12iearn
* (2) how many years to retirement if DB plans, if missing, use 65, if still missing, use next year age
gen ret_age = plan_exp_age
replace ret_age = r12agey  if ret_age==. | ret_age<r12agey
replace ret_age = int(ret_age)
gen ret_yrs = max(ret_age - r12agey,0)
* (3) get DB Benefit amount if reported as percentage 
*wage growth 3.9 percent per year as in GST
global nwg = 0.039
* discount rate (3% interest + 2.8% inflation as in GST) 
*global discrate 0.058
* discount rate (2.9% interest + 2.7% inflation as in 2014 Trustees report intermediate long run assumptions) 
global discrate 0.056


gen db_inc = plan_exp_benamt if  plan_exp_benamt~=.
replace db_inc = . if  plan_exp_benamt==0 & plan_exp_benpct!=.
replace db_inc = plan_exp_benpct/100 * wage_yr * (1+${nwg}) ^ (ret_yrs) if db_inc==. & (ret_yrs > 0 & ret_yrs~=.) & plan_exp_benpct ~= .
replace db_inc = plan_now_benamt if plan_now_benamt > 0 & plan_now_benamt~=.
*there are 45 account with missing amount

*second definition which incorporates pension income reported in income section but not in pension section.
*only add it if r*ipen is positive but total plan_now_benamt is zeros
gen has_now_ben=(plan_now_benamt>0 & plan_now_benamt!=.)
bys hhidpn: egen tot_has_now=sum(has_now_ben)


gen db_inc_2=db_inc
replace db_inc_2=r12ipen if tot_has_now==0 & r12ipen!=.


*calculate annuity factor
gen survp_cur=.
gen survp_ret_age=.
forvalues i=1/119{
	replace survp_cur=cpx`i' if r12agey==`i'
	replace survp_ret_age=cpx`i' if ret_age==`i'
	gen disc`i'=(1+${discrate})^(r12agey-`i')
	gen survp`i'=cpx`i'/survp_cur
	gen epv`i'=disc`i'*survp`i'
	replace epv`i'=0 if `i'<ret_age 
	replace epv`i'=0 if `i'<r12agey
}

egen epv=rowtotal(epv*),m
gen annuity_factor=1/epv




* (4) FV DB wealth for regular payment type in nominal term 
gen db_wth = db_inc / annuity_factor
* (5) FV DB wealth for lump sum type in nominal term
replace db_wth = plan_exp_bensum/(1+${discrate})^ ret_yrs if plan_exp_bensum~=. & db_wth==.
replace db_wth = db_wth + plan_exp_bensum/(1+${discrate})^ ret_yrs if plan_exp_bensum~=. & db_wth~=.

*second definition
gen db_wth_2 = db_inc_2 / annuity_factor
replace db_wth_2 = plan_exp_bensum/(1+${discrate})^ ret_yrs if plan_exp_bensum~=. & db_wth_2==.
replace db_wth_2 = db_wth_2 + plan_exp_bensum/(1+${discrate})^ ret_yrs if plan_exp_bensum~=. & db_wth_2~=.

* with proration based on tenure yrs so far
gen plan_db_pro = plan_now_ten / (ret_yrs + plan_now_ten)
replace plan_db_pro = 1 if plan_db_pro==.
replace db_wth = db_wth * plan_db_pro
replace db_wth_2 = db_wth_2 * plan_db_pro

by hhidpn,sort: egen db_wth_total = total(db_wth),m
by hhidpn,sort: egen db_wth_total_2 = total(db_wth_2),m


rename (db_wth_total db_wth_total_2 ) (r12db_wth r12db_wth_2 )
bys hhidpn:gen tag = _n
keep if tag ==1
keep hhidpn r12db*
save "${folder}\DBWealth_2014.dta", replace