*         PRESENT VALUE OF DB WEALTH in 2016

*OPTION: If you want to use GST discount rate (5.8), uncomment  line 229 and comment out line 231.






do "$do/imputethis.do"

********************************************************************************
* If updating: check if the following raw HRS variables still exist
********************************************************************************
* plan indexing vars (section PR): w13Z276 
* plan indexing vars (section J2): w13J2Z139 w13J2W401 w13J2W402 
* plan type type vars (section J2): w13J2338 w13J2Z140 w13J2Z507 
* account balance vars (section J2): w13J2W009 w13J2W010 w13J2W011

********************************************************************************
*	Drops plans that are not verified
* NOTE: in general, non-missing plan status (either active or dead) -> J2 PENSION FOLLOW UP LOOP (w13J2W419==1) for detail
********************************************************************************

* Prepare for pension records by preload and new.  Assign internal ID by HHIDPN and type (may use preload info)
use "${rawHRS}\hrs2016\H16J2_P.dta",clear
merge m:1 HHID PSUBHH PN using "${rawHRS}\trk2020tr_r.dta", keepusing(PAGE BIRTHYR) nogen keep(3)
capture rename hhid HHID
capture rename pn PN
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

rename P* w13*
rename w13N PN
* Preloaded pension plan to verify 
* preloaded pension plan index: w13J2Z139 could be as many as 9 plans; missing (recoded as 0) means new this wave
gen plan_prevwv = w13J2Z139
* Verified whether never have such preloaded pension plan. (might be used to fix previous pension data in v2)
* w13J2W402 i=not in 2018
gen verified = 0
replace verified = 1 if  !inlist(w13J2W403,6,9,.)
* Step 1-b: new plans confirmed (new people or new job or new plan) 
gen plan_thiswv = 1 if w13J2W401==1

********************************************************************************
*	Focus on DB plans
********************************************************************************
* keep this wave new plans and verified preloaded plans
keep if plan_thiswv == 1 | (plan_prevwv~=. & verified==1)

* Assign plan_type: w13J2338. 1-DB; 2-DC; 3-Both. Why some missing? How to deal other or DK/RF (some have preload type)?
gen plan_db = inlist(w13J2338,1,3)
replace plan_db=0 if w13J2338==3 & !inlist(w13J2W407,2,16,97,98,99) // Unless DC type is reported, categorize "both" as DB
* if missing, try to use detailed pension type
replace plan_db = 1 if inlist(w13J2338,8,9,.) & inlist(w13J2W407,2,16)
* if missing, try to use preload pension plan type: DC type
replace plan_db = 1 if inlist(w13J2338,8,9,.)  & inlist(w13J2W407,.,98,99) & inlist(w13J2Z140,1,3)
replace plan_db = 1 if !inlist(w13J2W425,1,2) & (inlist(w13J2W426,1,2) | inlist(w13J2W428,1,2))
replace plan_db=0 if w13J2929==5 |  (w13J2931M1==2 & inlist(w13J2931M2,2,.) & inlist(w13J2931M2,2,.) )

keep if plan_db==1

********************************************************************************
*	DB plan details
********************************************************************************
* 1. Amount of benefits received now
/*
gen plan_now_benamt = .
replace plan_now_benamt = 0 if w13J2W426 == 5
replace plan_now_benamt = w13J2W015 if w13J2W015 <= 150000
replace plan_now_benamt = w13J2W015 * 12 if w13J2W016 == 4
qui: sum plan_now_benamt if plan_now_benamt>0,d
* impute based on median annual benefit amount
gen plan_now_benamt_imp = 0 if plan_now_benamt > 0 & plan_now_benamt~=.
replace plan_now_benamt = r(p50) if w13J2W015 > 150000 & w13J2W015~=.
replace plan_now_benamt_imp = 1 if w13J2W015 > 150000 & w13J2W015~=.
*/

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if w13J2W015 <= 150000 // donor group
replace mmiss= 1 if inlist(w13J2W015,999998,999999) // missing variable code

* if any coding is needed
replace w13J2W015=w13J2W015 * 12 if w13J2W016 == 4

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = w13J2W015
gen double lowervalue = 0
gen double uppervalue = 150000



gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if inlist(w13J2W015,999998,999999)
replace exactvalue_imp=0  if exactvalue==.

* Impute *
gen yr=13
imputethis
drop yr



gen plan_now_benamt = exactvalue
gen plan_now_benamt_imp = 0 
replace plan_now_benamt_imp = 1 if inlist(w13J2W015,999998,999999)
drop exactvalue lowervalue uppervalue







* 2. plan receiving age: 0-not expected (indicator for expect benefit in the future); + as real age, - as in future years (convert to real age after merge to main dataset)
gen plan_exp_age = .
replace plan_exp_age = w13J2353 if (w13J2W428==1 | w13J2W428==2) & w13J2353<=95
replace plan_exp_age = plan_exp_age + w13J2903/12 if w13J2903~=. & w13J2903<13
replace plan_exp_age = w13AGE+w13J2354 if w13J2353==96 & w13J2354<98
gen mis_exp_age=1 if w13J2353==98 | w13J2353==99 | w13J2354==98
   *if expected age is missing, use FRA
replace plan_exp_age=65 if BIRTHYR<=1937 & mis_exp_age==1
replace plan_exp_age=65+2/12 if BIRTHYR==1938 & mis_exp_age==1
replace plan_exp_age=65+4/12 if BIRTHYR==1939 & mis_exp_age==1
replace plan_exp_age=65+6/12 if BIRTHYR==1940 & mis_exp_age==1
replace plan_exp_age=65+8/12 if BIRTHYR==1941 & mis_exp_age==1
replace plan_exp_age=65+10/12 if BIRTHYR==1942 & mis_exp_age==1
replace plan_exp_age=66 if inrange(BIRTHYR,1943,1954) & mis_exp_age==1
replace plan_exp_age=66+2/12 if BIRTHYR==1955 & mis_exp_age==1
replace plan_exp_age=66+4/12 if BIRTHYR==1956 & mis_exp_age==1
replace plan_exp_age=66+6/12 if BIRTHYR==1957 & mis_exp_age==1
replace plan_exp_age=66+8/12 if BIRTHYR==1958 & mis_exp_age==1
replace plan_exp_age=66+10/12 if BIRTHYR==1959 & mis_exp_age==1
replace plan_exp_age=67 if BIRTHYR>=1960 & BIRTHYR!=. & mis_exp_age==1


* 2a plan tenure year (for proration)
gen plan_now_ten = .
replace w13J2W410 = w13J2Z142 if (w13J2W410 ==9998 | w13J2W410 ==.) & w13J2Z142<9998
replace w13J2W411 = w13J2Z143 if (w13J2W411 ==9998 | w13J2W411 ==.) & w13J2Z143<9998
replace plan_now_ten = w13J2W411 - w13J2W410 if w13J2W410<=2016+2 & w13J2W411<=2016+2
replace plan_now_ten = 2016+1 - w13J2W410 if w13J2W410<=2016+1 & w13J2W411==.
replace plan_now_ten=. if  w13J2W410>w13J2W411
replace plan_now_ten=. if plan_now_ten>75
*12 missing

* 3. Expected amount of benefits
gen plan_db_ben_imp = 0
* 3a Percent of payroll
gen plan_exp_benpct = .
replace plan_exp_benpct = w13J2356 if w13J2356<=100
qui: sum plan_exp_benpct,d
replace plan_db_ben_imp = 1 if plan_exp_benpct==. & w13J2356~=.
replace plan_exp_benpct = (w13J2789 + min(w13J2790,100))/2 if plan_exp_benpct==. & w13J2356~=.
* 3b Dollar amount

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if w13J2357<999998 // donor group
replace mmiss= 1 if w13J2357>999997 & w13J2357<1999999999 // missing variable code
replace mmiss= 1 if mis_exp_age==1 // 

* if any coding is needed
replace w13J2358= 0 if w13J2358==. & mmiss==1      //fix annoying quirk in data
replace w13J2359= 99999996 if w13J2359==.  & mmiss==1    // fix annoying quirk in data
replace w13J2357= w13J2357*12 if  w13J2361==4
replace w13J2357=99999998 if mis_exp_age==1

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = w13J2357
replace exactvalue = 99999998 if mmiss==1
gen double lowervalue = w13J2358
gen double uppervalue = w13J2359



gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.

* Impute *
gen yr=13
imputethis
drop yr



gen plan_exp_benamt = exactvalue
replace plan_db_ben_imp = 1 if (w13J2357>999997 & w13J2357<1999999999) | mis_exp_age==1
drop exactvalue lowervalue uppervalue



* 3c Lump sum amount

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if w13J2363<9999998 // donor group
replace mmiss= 1 if w13J2363>9999997 & w13J2363<1999999999 // missing variable code


* if any coding is needed
replace w13J2364= 0 if w13J2364==. & mmiss==1      //fix annoying quirk in data
replace w13J2365= 99999996 if w13J2365==.  & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = w13J2363
replace exactvalue=99999998 if mmiss==1
gen double lowervalue = w13J2364
gen double uppervalue = w13J2365


gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.

* Impute *
gen yr=13
imputethis
drop yr


gen plan_exp_bensum = exactvalue
replace plan_db_ben_imp = 1 if w13J2363>9999997 & w13J2363<1999999999
drop exactvalue lowervalue uppervalue


***
keep hhidpn plan_*
save "${folder}\DB_2016.dta", replace

use "${folder}\DB_2016.dta", clear
*append pensions mentioned in the income section
gen from_raw=1
append using "${rand}\randhrs1992_2020v1.dta",keep(r13ipen hhidpn)
drop if (r13ipen==0 | r13ipen==.) & from_raw!=1
* use RAND to get employee info such as current salary, current age
merge m:1 hhidpn using "${rand}\randhrs1992_2020v1.dta", nogen keep(3) keepusing(ragender r13agey_m r13iearn rabyear)
merge m:1 ragender rabyear using "${folder}\cumu_mort.dta", keep(3) nogen


* 1. DB wealth
* (1) gen annual wage from RAND 
gen wage_yr = r13iearn
* (2) how many years to retirement if DB plans, if missing, use 65, if still missing, use next year age
gen ret_age = plan_exp_age
replace ret_age = r13agey  if ret_age==. | ret_age<r13agey
replace ret_age = int(ret_age)
gen ret_yrs = max(ret_age - r13agey,0)
* (3) get DB Benefit amount if reported as percentage 
*wage growth 3.9 percent per year as in GST
global nwg = 0.039
* discount rate (3% interest + 2.8% inflation as in GST) 
*global discrate 0.058
* discount rate (2.7% interest + 2.6% inflation as in 2016 Trustees report intermediate long run assumptions) 
global discrate 0.053



* (3) get DB Benefit amount if reported as percentage (assume 2.8% + 1.1% nominal wage growth rate. See G&S Book Page235)
gen db_inc = plan_exp_benamt if  plan_exp_benamt~=.
replace db_inc = . if  plan_exp_benamt==0 & plan_exp_benpct!=.
replace db_inc = plan_exp_benpct/100 * wage_yr * (1+${nwg}) ^ (ret_yrs) if db_inc==. & (ret_yrs > 0 & ret_yrs~=.) & plan_exp_benpct ~= .
replace db_inc = plan_now_benamt if plan_now_benamt > 0 & plan_now_benamt~=.
*zeros are not expecting benefits (428==5) and not currently receiving benefits (426==5) - inactive accounts

*second definition which incorporates pension income reported in income section but not in pension section.
*only add it if r*ipen is positive but total plan_now_benamt is zeros
gen has_now_ben=(plan_now_benamt>0 & plan_now_benamt!=.)
bys hhidpn: egen tot_has_now=sum(has_now_ben)


gen db_inc_2=db_inc
replace db_inc_2=r13ipen if tot_has_now==0 & r13ipen!=.

* (4) FV DB wealth for regular payment type in nominal term 

*calculate annuity factor
gen survp_cur=.
gen survp_ret_age=.
forvalues i=1/119{
	replace survp_cur=cpx`i' if r13agey==`i'
	replace survp_ret_age=cpx`i' if ret_age==`i'
	gen disc`i'=(1+${discrate})^(r13agey-`i')
	gen survp`i'=cpx`i'/survp_cur
	gen epv`i'=disc`i'*survp`i'
	replace epv`i'=0 if `i'<ret_age 
	replace epv`i'=0 if `i'<r13agey
}

egen epv=rowtotal(epv*),m
gen annuity_factor=1/epv




* (4) FV DB wealth for regular payment type in nominal term 
gen db_wth = db_inc / annuity_factor
* (5) FV DB wealth for lump sum type in nominal term
replace db_wth = plan_exp_bensum/(1+${discrate})^ ret_yrs if plan_exp_bensum~=. & db_wth==.
replace db_wth = db_wth + plan_exp_bensum/(1+${discrate})^ ret_yrs if plan_exp_bensum~=. & db_wth~=.

*second definition
gen db_wth_2 = db_inc_2 / annuity_factor
replace db_wth_2 = plan_exp_bensum/(1+${discrate})^ ret_yrs if plan_exp_bensum~=. & db_wth_2==.
replace db_wth_2 = db_wth_2 + plan_exp_bensum/(1+${discrate})^ ret_yrs if plan_exp_bensum~=. & db_wth_2~=.


* with proration based on tenure yrs so far
gen plan_db_pro = plan_now_ten / (ret_yrs + plan_now_ten)
replace plan_db_pro = 1 if plan_db_pro==.
replace db_wth = db_wth * plan_db_pro
replace db_wth_2 = db_wth_2 * plan_db_pro

by hhidpn,sort: egen db_wth_total = total(db_wth),m
by hhidpn,sort: egen db_wth_total_2 = total(db_wth_2),m


rename (db_wth_total db_wth_total_2) (r13db_wth r13db_wth_2 )
bys hhidpn:gen tag = _n
keep if tag ==1

keep hhidpn r13db*
save "${folder}\DBWealth_2016.dta", replace

