*Pensions





do "$do/imputethis.do"


********************************************************************************
* If updating: check if the following raw HRS variables still exist
********************************************************************************
* plan indexing vars (section PR): w13Z276 
* plan indexing vars (section J2): w13J2Z139 w13J2W401 w13J2W402 
* plan type type vars (section J2): w13J2338 w13J2Z140 w13J2Z507 
* account balance vars (section J2): w13J2W009 w13J2W010 w13J2W011

********************************************************************************
*	Drops plans that are not active
********************************************************************************

* Prepare for pension records by preload and new.  Assign internal ID by HHIDPN and type (may use preload info)
use "${rawHRS}\hrs2016\H16J2_P.dta",clear
gen hhidpn = HHID+PN
destring hhidpn,replace
order hhidpn

rename PJ* w13J*


*keep active plans
keep if w13J2W451==5

********************************************************************************
*	Focus on DC plans
********************************************************************************
* Assign plan_type: w13J2338. 1-DB; 2-DC; 3-Both. Why some missing? How to deal other or DK/RF (some have preload type)?
gen plan_dc = inlist(w13J2338,2)
replace plan_dc= 1 if w13J2338==3 & !inlist(w13J2W407,2,16,97,98,99)
* if missing, try to use detailed pension type
replace plan_dc = 1 if inlist(w13J2338,8,9,.) & !inlist(w13J2W407,.,2,97,98,99,96,16)
* if missing, try to use preload pension plan type: DC type
replace plan_dc = 1 if inlist(w13J2338,8,9,.)  & inlist(w13J2W407,.,98,99) & inlist(w13J2Z140,2,3)
replace plan_dc = 1 if inlist(w13J2W425,1,2)  & !inlist(w13J2W428,1,2) & !inlist(w13J2W426,1,2)
keep if plan_dc==1

********************************************************************************
*	DC plan balance
********************************************************************************

* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if w13J2W009<99999998 // donor group
replace mmiss= 1 if w13J2W009>99999997 & w13J2W009<1999999999 // missing variable code


* if any coding is needed
replace w13J2W010= 0 if w13J2W010==. & mmiss==1      //fix annoying quirk in data
replace w13J2W011= 99999996 if w13J2W011==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = w13J2W009
gen double lowervalue = w13J2W010
gen double uppervalue = w13J2W011


gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.

* Impute *
gen yr=13
imputethis
drop yr


* Plan DC balance

gen plan_dc_bal=exactvalue
gen plan_dc_bal_imp=0 
replace plan_dc_bal_imp=1 if (w13J2W009>=99999998 & w13J2W009!=.) 




* Individual DC Wealth
by hhidpn,sort: egen dc_wth_total13 = total(plan_dc_bal),m
by hhidpn,sort: egen dc_wth_total13_imp = total(plan_dc_bal_imp)

collapse (first) dc_wth_total13*,by(hhidpn)
rename (dc_wth_total13 ) (r13dc_wth )
save "${folder}\DC_2016.dta", replace

