*Pensions





do "$do/imputethis.do"


********************************************************************************
* If updating: check if the following raw HRS variables still exist
********************************************************************************
* plan indexing vars (section PR): w15Z276 
* plan indexing vars (section J2): w15J2Z139 w15J2W401 w15J2W402 
* plan type type vars (section J2): w15J2338 w15J2Z140 w15J2Z507 
* account balance vars (section J2): w15J2W009 w15J2W010 w15J2W011

********************************************************************************
*	Drops plans that are not active
********************************************************************************

use "${rawHRS}\hrs2020\H20J2_P.dta",clear
gen hhidpn = hhid+pn
destring hhidpn,replace
order hhidpn

rename RJ* w15J*


*keep active plans
keep if w15J2W451==5

********************************************************************************
*	Focus on DC plans
********************************************************************************
* Assign plan_type: w15J2338. 1-DB; 2-DC; 3-Both. Why some missing? How to deal other or DK/RF (some have preload type)?
gen plan_dc = inlist(w15J2338,2)
replace plan_dc= 1 if w15J2338==3 & !inlist(w15J2W407,2,16,97,98,99)
* if missing, try to use detailed pension type
replace plan_dc = 1 if inlist(w15J2338,8,9,.,-8) & !inlist(w15J2W407,.,2,97,98,99,95,96,16,-8)
* if missing, try to use preload pension plan type: DC type
replace plan_dc = 1 if inlist(w15J2338,8,9,.,-8)  & inlist(w15J2W407,.,98,99,-8) & inlist(w15J2Z140,2,3)
replace plan_dc = 1 if inlist(w15J2W425,1,2)  & !inlist(w15J2W428,1,2) & !inlist(w15J2W426,1,2)
keep if plan_dc==1

********************************************************************************
*	DC plan balance
********************************************************************************
rename hhid HHID
rename pn PN
* Code missings (input for imputation code)
gen mmiss=.
replace mmiss= 0 if w15J2W009<99999998   // donor group
replace mmiss= 1 if w15J2W009>99999997 & w15J2W009<1999999999 // missing variable code
replace mmiss= 1 if w15J2W009==-8

* if any coding is needed
replace w15J2W010= 0 if w15J2W010==. & mmiss==1      //fix annoying quirk in data
replace w15J2W011= 99999996 if w15J2W011==. & mmiss==1    // fix annoying quirk in data

* Code lower, upper, and exact values (input for imputation code)
gen double exactvalue = w15J2W009
replace exactvalue = 99999998 if w15J2W009==-8
gen double lowervalue = w15J2W010
gen double uppervalue = w15J2W011

gen exactvalue_imp=exactvalue
replace exactvalue_imp=.  if mmiss==1
replace exactvalue_imp=0  if exactvalue==.
* Impute
imputethis


* Plan DC balance

gen plan_dc_bal=exactvalue
gen plan_dc_bal_imp=0 
replace plan_dc_bal_imp=1 if (w15J2W009>=99999998 & w15J2W009!=.) | w15J2W009==-8




* Individual DC Wealth
by hhidpn,sort: egen dc_wth_total15 = total(plan_dc_bal),m
by hhidpn,sort: egen dc_wth_total15_imp = total(plan_dc_bal_imp)
 
collapse (first) dc_wth_total15*,by(hhidpn)
rename (dc_wth_total15 ) (r15dc_wth )
save "${folder}\DC_2020.dta", replace

