*Find missing/non-respondent spouses for each wave

use "$rawHRS/trk2020tr_r.dta",clear
keep HHID PN *COUPLE PN *PPN HHID *IWYEAR *AGE FIRSTIW
drop if FIRSTIW==9996

 forvalues i=1/18{
 local let : word `i' of `c(ALPHA)'
	if "`let'"!="I"{
        preserve
		keep HHID PN `let'AGE
		rename PN `let'PPN
		rename `let'AGE `let'AGE_2
		save "$folder/`let'spouse.dta",replace
		restore
		
		merge m:1 HHID `let'PPN using "$folder/`let'spouse.dta", gen(_`let'`let') keep(1 3)
		duplicates drop
		
	}
	
 }
 
 gen r1missingsp= (ACOUPLE==1 & AIWYEAR!=. & AAGE!=999) & (_AA==1 | (_AA==3 & AAGE_2==999 ))
 gen r2missingsp= (CCOUPLE==1 & CIWYEAR!=. & CAGE!=999) & (_CC==1 | (_CC==3 & CAGE_2==999 ))
 forvalues i=5/8{
 local let : word `i' of `c(ALPHA)'
 local k=`i'-2
 gen r`k'missingsp= (`let'COUPLE==1 & `let'IWYEAR!=. & `let'AGE!=999) & (_`let'`let'==1 | (_`let'`let'==3 & `let'AGE_2==999 ))
 }
 
 forvalues i=10/18{
 local let : word `i' of `c(ALPHA)'
 local k=`i'-3
 gen r`k'missingsp= (`let'COUPLE==1 & `let'IWYEAR!=. & `let'AGE!=999) & (_`let'`let'==1 | (_`let'`let'==3 & `let'AGE_2==999 ))
 }
 
 
keep HHID PN r*missingsp
gen hhidpn=HHID+PN
destring hhidpn,replace

save "$folder/missingspouse.dta",replace