use "$working\SSB for RR.dta",clear

* Starts at 1975
matrix COLA = (8.0,6.4,5.9,6.5,9.9,14.3,11.2,7.4,3.5,3.5,3.1,1.3,4.2,4.0,4.7,5.4,3.7,3.0,2.6,2.8,2.6,2.9,2.1,1.3,2.5,3.5,2.6,1.4,2.1,2.7,4.1,3.3,2.3,5.8,0.0,0.0,3.6,1.7,1.5,1.7,0.0,0.3,2.0,2.8,1.6,1.3,5.9,8.7,3.3,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4,2.4) 

*turn cola into index
matrix def COLA_ind=J(1,101,.)
matrix COLA_ind[1,1]=100
forvalues i=2/101{
	local j=`i'-1
	matrix COLA_ind[1,`i']=COLA_ind[1,`j']*(1+COLA[1,`i']/100)
}


foreach val in 62 65 FR 70{
	gen year_`val'=round(rabyear+`val')
	gen cola`val'=COLA_ind[1,year_`val'-1974]
}

*turn benefits to year 62 dollars
replace SSB_70=SSB_70/12*cola62/cola70
replace SSB_65=SSB_65/12*cola62/cola65
replace SSB_FR=SSB_FR/12*cola62/colaFR
replace SSB_62=SSB_62/12

*               STEP 1   back out PIA

*age 62 penalty
gen own_perc62=.
replace own_perc62 =0.8 if rabyear<1938             
replace own_perc62 =((79+1/6)/100) if rabyear==1938                 
replace own_perc62 =((78+1/3)/100) if rabyear==1939                
replace own_perc62 =((77+1/2)/100) if rabyear==1940               
replace own_perc62 =((76+2/3)/100) if rabyear==1941               
replace own_perc62 =((75+5/6)/100) if rabyear==1942              
replace own_perc62 =((75)/100) 	   if rabyear>1942
replace own_perc62 =((74+1/6)/100) if rabyear==1955             
replace own_perc62 =((73+1/3)/100) if rabyear==1956              
replace own_perc62 =((72+1/2)/100) if rabyear==1957            
replace own_perc62 =((71+2/3)/100) if rabyear==1958                 
replace own_perc62 =((70+5/6)/100) if rabyear==1959              
replace own_perc62 =(70/100) 	   if rabyear>1959  


*age 65 penalty
gen own_perc65=.
replace own_perc65 =((100)/100)    if rabyear<1938             
replace own_perc65 =((98+8/9)/100) if rabyear==1938             
replace own_perc65 =((97+7/9)/100) if rabyear==1939            
replace own_perc65 =((96+2/3)/100) if rabyear==1940              
replace own_perc65 =((95+5/9)/100) if rabyear==1941            
replace own_perc65 =((94+4/9)/100) if rabyear==1942             
replace own_perc65 =((93+1/3)/100) if rabyear>1942 & rabyear<1955 
replace own_perc65 =((92+2/9)/100) if rabyear==1955             
replace own_perc65 =((91+1/9)/100) if rabyear==1956            
replace own_perc65 =((90)/100) 	 if rabyear==1957             
replace own_perc65 =((88+8/9)/100) if rabyear==1958             
replace own_perc65 =((87+7/9)/100) if rabyear==1959            
replace own_perc65 =((86+2/3)/100) if rabyear>1959 


*age 70 
gen own_perc70=.
replace own_perc70 =(((106)/100)+3*0.03) if rabyear<1925           
replace own_perc70 =(((107)/100)+3*0.035) if rabyear>1924 & rabyear<1927    
replace own_perc70 =(((108)/100)+3*0.04) if rabyear>1926 & rabyear<1929
replace own_perc70 =(((109)/100)+3*0.045) if rabyear>1928 & rabyear<1931
replace own_perc70 =(((110)/100)+3*0.05) if rabyear>1930 & rabyear<1933
replace own_perc70 =(((111)/100)+3*0.055) if rabyear>1932 & rabyear<1935  
replace own_perc70 =(((112)/100)+3*0.06) if rabyear>1934 & rabyear<1937
replace own_perc70 =(((113)/100)+3*0.065) if rabyear==1937                 
replace own_perc70 =(((111+11/12)/100)+3*0.065) if rabyear==1938              
replace own_perc70 =(((111+2/3)/100)+3*0.07) if rabyear==1939              
replace own_perc70 =(((110+1/2)/100)+3*0.07) if rabyear==1940               
replace own_perc70 =(((110)/100)+3*0.075) if rabyear==1941              
replace own_perc70 =(((108+3/4)/100)+3*0.075) if rabyear==1942             
replace own_perc70 =(((108)/100)+3*0.08) if rabyear>1942 & rabyear<1955
replace own_perc70 =(((106+2/3)/100)+3*0.08) if rabyear==1955               
replace own_perc70 =(((105+1/3)/100)+3*0.08) if rabyear==1956              
replace own_perc70 =(((104)/100)+3*0.08) if rabyear==1957             
replace own_perc70 =(((102+2/3)/100)+3*0.08) if rabyear==1958              
replace own_perc70 =(((101+1/3)/100)+3*0.08) if rabyear==1959              
replace own_perc70 =(((100)/100)+3*0.08) if rabyear>1959

*age FR 
gen own_percFR=1

foreach val in 62 65 FR 70{
 gen PIA`val'=SSB_`val'/own_perc`val'
}


*               STEP 2   back out AIME

matrix BP1 = (180,194,211,230,254,267,280,297,310,319,339,356,370,387,401,422,426,437,455,477,505,531,561,592,606,612,627,656,680,711,744,761,749,767,791,816,826,856,885,895,926,960,996,1024, 1115, 1168, 1218, 1263, 1314, 1368, 1425, 1482, 1542, 1603, 1659, 1717, 1777, 1839,1903, 1970, 2039, 2110, 2184, 2260, 2339, 2421, 2506, 2594, 2685, 2779, 2876, 2977, 3081, 3189, 3301, 3417, 3537, 3661, 3789, 3922, 4059, 4201, 4348, 4500, 4658, 4821, 4990)
matrix list BP1

matrix BP2 = (1085,1171,1274,1388,1528,1612,1691,1790,1866,1922,2044,2145,2230,2333,2420,2545,2567,2635,2741,2875,3043,3202,3381,3567,3653,3689,3779,3955,4100,4288,4483,4586,4517,4624,4768,4917,4980,5157,5336,5397,5583,5785,6002,6172, 6721, 7042, 7339, 7614, 7923, 8249, 8587, 8932, 9293, 9664, 10002, 10352, 10714, 11089, 11477, 11879, 12295, 12725, 13170, 13631, 14108, 14602, 15113, 15642, 16189, 16756, 17342, 17949, 18577, 19227, 19900, 20597, 21318, 22064, 22836, 23635, 24462, 25318, 26204, 27121, 28070, 29052, 30069)
matrix list BP2




gen BP1_62=BP1[1,year_62-1978]
gen BP2_62=BP2[1,year_62-1978]

foreach val in 62 65 FR 70{
 gen A1`val'=((PIA`val'-BP1_62*0.9)/0.32) + BP1_62
 gen A2`val'=((PIA`val'-BP1_62*0.9 -(BP2_62-BP1_62)*0.32)/0.15) + BP2_62
 
 gen AIME`val'=PIA`val'/0.9 if PIA`val'/0.9<=BP1_62
 replace AIME`val'=A1`val' if A1`val'<=BP2_62 & A1`val'>BP1_62
 replace AIME`val'=A2`val' if A2`val'>BP2_62
 replace AIME`val'=AIME`val'*12
 }

 drop A1* A2*
 
 *turn everything to 2020 dollars
*CPI 1951-2065
matrix cpi=(26.10, 26.70, 26.90, 27.00, 26.90, 27.30, 28.30, 29.10, 29.30, 29.80, 30.10, 30.40, 30.80, 31.20, 31.70, 32.60, 33.60, 35.00, 36.90, 39.00, 40.70, 42.10, 44.70, 49.60, 54.10, 57.20, 60.90, 65.60, 73.10, 82.90, 91.40, 96.90, 99.80, 103.30, 106.90, 108.60, 112.50, 117.00, 122.60, 129.00, 134.30, 138.20, 142.10, 145.60, 149.80, 154.10, 157.60, 159.70, 163.20, 168.90, 173.50, 175.90, 179.80, 184.50, 191.00, 197.10, 202.77, 211.05, 209.63, 213.97, 221.58, 226.23, 229.32, 232.77, 231.81, 234.08, 239.05, 245.15, 249.22, 252.25, 265.51, 287.98, 294.90, 301.97, 309.22, 316.64, 324.24, 332.02, 339.99, 348.15, 356.51, 365.06, 373.82, 382.80, 391.98, 401.39, 411.02, 420.89, 430.99, 441.33, 451.93, 462.77, 473.88, 485.25, 496.90, 508.82, 521.04, 533.54, 546.35, 559.46, 572.88, 586.63, 600.71, 615.13, 629.89, 645.01, 660.49, 676.34, 692.57, 709.20, 726.22, 743.65, 761.49, 779.77, 798.48)

foreach val in 62 65 FR 70{
 replace AIME`val'=AIME`val'*cpi[1,2020-1950]/cpi[1,year_`val'-1950]
}


*for those with match, merge top 5 after 45 
merge 1:1 hhidpn using "$working\preretirement.dta"

rename preret_earnings_real_* preret*


*using nearest neighbor and AIME, fill in missing
mi set wide
mi register imputed preret62 preret65 preretFR preret70
mi impute monotone (pmm, knn(1)) preret62 preret65 preretFR preret70 = AIMEFR ragender i.hacoh rabyear i.nonwhite i.college i.indust, replace add(1) force

*if industry is missing
mi impute monotone (pmm, knn(1))  preret62 preret65 preretFR preret70 = AIMEFR ragender i.hacoh rabyear i.nonwhite i.college, add(1) force


foreach val in 62 65 70 FR{
	replace preret`val'=_1_preret`val' if _mi_miss==1
	replace preret`val'=_2_preret`val' if _mi_miss==1 & _1_preret`val'==.
}

mi unset
drop preret62_* preret65_*  preret70_* preretFRAyr_* mi_miss


keep hhidpn AIME* preret*
rename  preret* preret_earnings_real_*

save "$working\preretirement2.dta",replace
