
*-----------------------------SSA Pre-retirement earnings----------------------*

use "$working\earnings_path.dta", clear

keep hhidpn EARN* BIRTHYR

*CPI 1951-2065
matrix cpi=(26.10, 26.70, 26.90, 27.00, 26.90, 27.30, 28.30, 29.10, 29.30, 29.80, 30.10, 30.40, 30.80, 31.20, 31.70, 32.60, 33.60, 35.00, 36.90, 39.00, 40.70, 42.10, 44.70, 49.60, 54.10, 57.20, 60.90, 65.60, 73.10, 82.90, 91.40, 96.90, 99.80, 103.30, 106.90, 108.60, 112.50, 117.00, 122.60, 129.00, 134.30, 138.20, 142.10, 145.60, 149.80, 154.10, 157.60, 159.70, 163.20, 168.90, 173.50, 175.90, 179.80, 184.50, 191.00, 197.10, 202.77, 211.05, 209.63, 213.97, 221.58, 226.23, 229.32, 232.77, 231.81, 234.08, 239.05, 245.15, 249.22, 252.25, 265.51, 287.98, 294.90, 301.97, 309.22, 316.64, 324.24, 332.02, 339.99, 348.15, 356.51, 365.06, 373.82, 382.80, 391.98, 401.39, 411.02, 420.89, 430.99, 441.33, 451.93, 462.77, 473.88, 485.25, 496.90, 508.82, 521.04, 533.54, 546.35, 559.46, 572.88, 586.63, 600.71, 615.13, 629.89, 645.01, 660.49, 676.34, 692.57, 709.20, 726.22, 743.65, 761.49, 779.77, 798.48)

forvalues year = 1951/2065 {
	gen earn`year' = EARN`year' * cpi[1,70] / cpi[1, `year'-1950]
	}
	forvalues year = 1951/2065 {
la var earn`year' "`year' earnings in 2020 dollars"
	}
	
	
	
*Full retirement age 
* Months
gen FRA=0
replace FRA = (65 * 12) if BIRTHYR <= 1937
replace FRA = (65 * 12) + 2 if BIRTHYR == 1938
replace FRA = (65 * 12) + 4 if BIRTHYR == 1939
replace FRA = (65 * 12) + 6 if BIRTHYR == 1940
replace FRA = (65 * 12) + 8 if BIRTHYR == 1941
replace FRA = (65 * 12) + 10 if BIRTHYR == 1942
replace FRA = (66 * 12) if inrange(BIRTHYR, 1943, 1954)
qui: replace FRA = (66 * 12) + 2 if BIRTHYR ==1955
qui: replace FRA = (66 * 12) + 4 if BIRTHYR ==1956
qui: replace FRA = (66 * 12) + 6 if BIRTHYR ==1957
qui: replace FRA = (66 * 12) + 8 if BIRTHYR ==1958
qui: replace FRA = (66 * 12) + 10 if BIRTHYR ==1959
qui: replace FRA = (67 * 12) if BIRTHYR >=1960
tab FRA, m

gen FRAyr = FRA/12
gen year_FR=round(BIRTHYR+FRAyr)
	
	
foreach val in 62 65 FRAyr 70{	

gen earnings_start = BIRTHYR+45
gen earnings_end = round(BIRTHYR+ `val')



forvalues rank = 1/5 {
	qui gen rank`rank' = 0
	qui gen year`rank' = .
}

* Rank 1  
forvalues year = 1951/2065 {
	replace year1 = `year' if (earn`year' > rank1) & (earn`year' != .)  & inrange(`year', earnings_start, earnings_end) 
	replace rank1 = earn`year' if (earn`year' > rank1) & (earn`year' != .) & inrange(`year', earnings_start, earnings_end) 
	}
* Rank 2  
forvalues year = 1951/2065 {
	replace year2 = `year' if (earn`year' > rank2) & (earn`year' != .)  & inrange(`year', earnings_start, earnings_end) & `year' != year1
	replace rank2 = earn`year' if (earn`year' > rank2) & (earn`year' != .)  & inrange(`year', earnings_start, earnings_end) & `year' != year1
	}
* Rank 3  
forvalues year = 1951/2065 { 
	replace year3 = `year' if (earn`year' > rank3) & (earn`year' != .)  & inrange(`year', earnings_start, earnings_end) & `year' != year1 & `year' != year2 
	replace rank3 = earn`year' if (earn`year' > rank3) & (earn`year' != .)  & inrange(`year', earnings_start, earnings_end) & `year' != year1 & `year' != year2 
}
* Rank 4  
forvalues year = 1951/2065 {
	replace year4 = `year' if (earn`year' > rank4) & (earn`year' != .)  & inrange(`year', earnings_start, earnings_end) & `year' != year1 & `year' != year2 & `year' != year3 
	replace rank4 = earn`year' if (earn`year' > rank4) & (earn`year' != .)  & inrange(`year', earnings_start, earnings_end) & `year' != year1 & `year' != year2 & `year' != year3 
}
* Rank 5  
forvalues year = 1951/2065 {
	replace year5 = `year' if (earn`year' > rank5) & (earn`year' != .)  & inrange(`year', earnings_start, earnings_end) & `year' != year1 & `year' != year2 & `year' != year3  & `year' != year4
	replace rank5 = earn`year' if (earn`year' > rank5) & (earn`year' != .)  & inrange(`year', earnings_start, earnings_end) & `year' != year1 & `year' != year2 & `year' != year3  & `year' != year4

}

egen preret_earnings_real_`val' = rowmean(rank*)

drop rank* year* earnings_start earnings_end

}

keep hhidpn preret_earnings_real_*

save "$working\preretirement.dta",replace