%% Calculating annuity factors 

clear all
close all
datapath = ['.......'];


%long term nominal interest rate from each corresponding SSA trustees
%report



all_para.int = [6.2 6.3 6.3 6.2 6.3 6 5.7 5.7 5.7 5.7 5.7 5.6 5.3 5.3 4.7];



mort_F = readmatrix([datapath  'CohLifeTables_F_Alt2_TR2023.xlsx'],'Sheet','CohLifeTables','Range','C7:C24126');
mort_M = readmatrix([datapath  'CohLifeTables_M_Alt2_TR2023.xlsx'],'Sheet','CohLifeTables','Range','C7:C24126');
mort_f = reshape(mort_F,[120,201])';
mort_m = reshape(mort_M,[120,201])';
surv_prob_f = 1-mort_f(1:100,1:119);
surv_prob_m = 1-mort_m(1:100,1:119);
w = size(surv_prob_m,2) + 1;
cohort = size(surv_prob_m,1);


for r=1:15
    annuity_f_m = zeros(cohort,w);
    annuity_f_f = zeros(cohort,w);
    for age = 1:w-1
        cum_prob_m = cumprod(surv_prob_m(:,age:end),2);
        cum_prob_f = cumprod(surv_prob_f(:,age:end),2);
        d = (1+all_para.int(1,r)) .^ [1:w-age];
        annuity_f_m(:,age) = sum(cum_prob_m ./ d,2);
        annuity_f_f(:,age) = sum(cum_prob_f ./ d,2);
    end
    annuity_factor_m = 1./annuity_f_m;
    annuity_factor_f = 1./annuity_f_f;

    sheetname=r;
    filename = [datapath 'annuity_rate_f.xlsx'];
    writematrix(annuity_factor_f,filename,'Sheet',r)

    filename = [datapath 'annuity_rate_m.xlsx'];
    writematrix(annuity_factor_m,filename,'Sheet',r)

end