*------------------------------------------------------------------------------*
*        Social Security Wealth in HRS - Main Do file                          *
*------------------------------------------------------------------------------*
cd "R:\SharedProjects\Shared1999-007-SSAONLY\HRS project"
*create a working folder - save all edited data to this path
global working "..."
*path for mortatlity data
global data "..."


*calculate potential benefits if claimed at 62,65,FRA,and 70 for respodents with matched SSA records
do "earnings file 62.do"
do "earnings file 65.do"
do "earnings file FRA.do"
do "earnings file 70.do"

*back out PIA from self-reported Social Security retirement income 
do "back out PIA.do"

*merge and impute for those with no matched earnings record and no reported SS ret income
*first, run this to find longest job industry to use in the imputation
do "industry.do"
do "merge.do"

*find cumulative mortality rates
do "mortality.do"

*prepare mortality rates to be merged with benefits
do "mortality to merge.do"

*construct 62-119 benefits using based on claiming age, and find present value of benefits
do "SSW62.do"
do "SSW65.do"
do "SSWFR.do"
do "SSW70.do"

*merge everything and impute household level present value for those with non-respondent spouses

do "nonrespondent spouse.do"
